% !!!!this version w/ hard peg
% for Taylor w/ Sdev see BaselineModelAnalysis.m
% for Taylor w/o Sdev see BaselineModelAnalysis2 and 3.m
addpath(genpath('C:\dynare\4.4.2\matlab'))
%addpath(genpath('C:\dynare\4.4.1\matlab'))
% rmpath(genpath('C:\dynare\4.3.3\matlab'))
%if want to send mail:
%addpath('C:\Users\gintersb\Documents\mydata\matlab\myfunc\sendmail')
mainpath='C:\Users\gintersb\Documents\mydata\matlab\dynare\examples\lv_examples';
cd(mainpath)
addpath(genpath('C:\Users\gintersb\Documents\mydata\matlab\external codes\lesage'))

myLatexPath='C:\Users\gintersb\Documents\mydata\latex\finfric_soe_lv_peg';

% which finfric in irfs:
cd(mainpath)
cd('CTWopenEconDataAndCode')
addpath('utilities_and_data')
cd('CTW CodeKit across models')
cd('finfric')


myWhichFFModel='finfric130'; %133 130 125 110,100; 106
load([myWhichFFModel '_results.mat'])

finfric_M_ = M_;
finfric_oo_=oo_;

% ctw baseline
cd(mainpath)
cd('CTWopenEconDataAndCode')
addpath('utilities_and_data')
cd('CTW CodeKit across models')
cd('baseline')

myWhichSVARmodel='foreign_svar50'; % 50; 45
load([myWhichSVARmodel '_results.mat'])

SVAR_M_ = M_;
SVAR_oo_=oo_;

myWhichHomeSVARmodel='lv_svar9'; % svar9 lv_svar1 svar10
load([myWhichHomeSVARmodel '_results.mat'])

HomeSVAR_M_ = M_;
HomeSVAR_oo_=oo_;


myWhichBModel='baseline241'; % 243 241 236 231, 223; 230
load([myWhichBModel '_results.mat'])
whichmoment='Mean'; % 'Median' or 'Mean'
%load original vars
load('myOriginalData.mat');

smoothedvars= eval(['oo_.SmoothedVariables.',whichmoment]);
updatedvars = eval(['oo_.UpdatedVariables.',whichmoment]);
filteredvars = eval(['oo_.FilteredVariables.',whichmoment]);

ff_smoothedvars= eval(['finfric_oo_.SmoothedVariables.',whichmoment]);
ff_updatedvars = eval(['finfric_oo_.UpdatedVariables.',whichmoment]);
ff_filteredvars = eval(['finfric_oo_.FilteredVariables.',whichmoment]);

myvarlist = {'ydiff','pid','R','wdiff','cdiff','idiff','qdiff','Hdiff',...
'xdiff','impdiff','pic','pii','gdiff','Rstar','pistar','ystardiff','ndiff',...
'spread'}; % ,'sdev'

myVarNames={'Output','Output price inflation','Interest rate','Real wage','Consumption','Investment','Real exchange rate'...
    'Total hours','Exports','Imports','CPI inflation','Investment price inflation','Government expenditure',...
    'Foreign interest rate','Foreign inflation','Foreign output',...
    'Net worth','Spread'}; % ,'Deviation from nominal exch. rate target'

R_ss=oo_.steady_state(find(strcmp(cellstr(M_.endo_names),'data_RU')));
Rstar_ss=oo_.steady_state(find(strcmp(cellstr(M_.endo_names),'data_RstarU')));
pid_ss=oo_.steady_state(find(strcmp(cellstr(M_.endo_names),'data_pidU'))); 
pic_ss=oo_.steady_state(find(strcmp(cellstr(M_.endo_names),'data_picU')));
pii_ss=oo_.steady_state(find(strcmp(cellstr(M_.endo_names),'data_piiU')));
pistar_ss=oo_.steady_state(find(strcmp(cellstr(M_.endo_names),'data_pistarU')));

ff_pid_ss=finfric_oo_.steady_state(find(strcmp(cellstr(finfric_M_.endo_names),'data_pidU')));
ff_R_ss=finfric_oo_.steady_state(find(strcmp(cellstr(finfric_M_.endo_names),'data_RU')));
ff_Rstar_ss=finfric_oo_.steady_state(find(strcmp(cellstr(finfric_M_.endo_names),'data_RstarU'))); 
ff_pic_ss=finfric_oo_.steady_state(find(strcmp(cellstr(finfric_M_.endo_names),'data_picU')));
ff_pii_ss=finfric_oo_.steady_state(find(strcmp(cellstr(finfric_M_.endo_names),'data_piiU')));
ff_pistar_ss=finfric_oo_.steady_state(find(strcmp(cellstr(finfric_M_.endo_names),'data_pistarU')));
ff_spread_ss = finfric_oo_.steady_state(find(strcmp(cellstr(finfric_M_.endo_names),'data_spreadU')));

mylevel = [0,pid_ss,R_ss,0,0,0,0,0,0,0,pic_ss,pii_ss,0,Rstar_ss,pistar_ss,0]; % ,0

ff_mylevel = [0,ff_pid_ss,ff_R_ss,0,0,0,0,0,0,0,ff_pic_ss,ff_pii_ss,0,...
    ff_Rstar_ss,ff_pistar_ss,0,0,ff_spread_ss]; % 0,
for myj = 1:length(myvarlist)
 if myj<17
    smoothedvar = eval(['smoothedvars.data_',myvarlist{myj},'U'])+mylevel(myj);
    updatedvar = eval(['updatedvars.data_',myvarlist{myj},'U'])+mylevel(myj);
    filteredvar = eval(['filteredvars.data_',myvarlist{myj},'U'])+mylevel(myj);
 else
     smoothedvar = nan(length(eval(['smoothedvars.data_',myvarlist{1},'U'])),1);
     updatedvar = nan(length(eval(['smoothedvars.data_',myvarlist{1},'U'])),1);
     filteredvar = nan(length(eval(['smoothedvars.data_',myvarlist{1},'U'])),1);
 end
 
 ff_smoothedvar = eval(['ff_smoothedvars.data_',myvarlist{myj},'U'])+ff_mylevel(myj);
 ff_updatedvar = eval(['ff_updatedvars.data_',myvarlist{myj},'U'])+ff_mylevel(myj);
 ff_filteredvar = eval(['ff_filteredvars.data_',myvarlist{myj},'U'])+ff_mylevel(myj);
 originalvar = eval(['data_' myvarlist{myj},'U']);
 
 
 figure(myj)
 
    %aH=subaxis(6,3,myj, 'SpacingHoriz', 0.04,'SpacingVert',.08); % fro
    %plot(smoothedvar,'black','linewidth',2)
    plot(originalvar,':black','linewidth',2)
    hold on
    plot([nan;filteredvar(1:end-1)],'--blue', 'linewidth',2)
    plot([nan;ff_filteredvar(1:end-1)],'red', 'linewidth',2)
    
    %legend([myvarlist{myj},'original'], [myvarlist{myj},'filtered'])  
    title(myVarNames{myj},'FontSize',14)
    hold off
    %set(aH,'PlotBoxAspectRatio',[1 1 1])
    set(gca,'XTick',[4 20 36 52 68])
    set(gca,'XTickLabel',['1996';'2000';'2004';'2008';'2012'])
    axis([-Inf length(originalvar) -Inf +Inf])
    if myj==15  || myj==18 || myj==12 || myj==11 || myj==6 || myj==3
        myLocation='North';
    elseif myj==7 || myj==4
        myLocation='South';
    else
        myLocation='SouthWest';
    end
     [legh,objh,outh,outm]  = legend(gca,'original','filtered, baseline','filtered, finfric','location',myLocation); %'show' 'zero line',
    set(legh,'Fontsize',13);
    set(objh,'linewidth',3);
    
thispath = cd; 
cd(myLatexPath)
print(myj,'-depsc',['FilteredVars_' myvarlist{myj}])
print(myj,'-dpdf',['FilteredVars_' myvarlist{myj}])
cd(thispath)
end
close all
% [legh,objh,outh,outm]  = legend(gca,'original','filtered'); %'show' 'zero line',
% set(legh,'Position',[.65 0.07 .25 .1],'Fontsize',13);
% set(objh,'linewidth',3);
% % box off
% set(legh,'box','off','Xcolor',[1 1 1],'Ycolor',[1 1 1]);


% thispath = cd; 
% cd(myLatexPath)
% print(1,'-depsc','baselineFilteredVars')
% print(1,'-dpdf','baselineFilteredVars')
% cd(thispath)

% close(1)


%%%%%%%%%%%%% matched moments %%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%% baseline %%%%%%%%%%%%%
findWhatParams={'delta','varphi','AL'};
BaselineMatchedVars=zeros(length(findWhatParams),1);
myparamcell=cellstr(M_.param_names);
for myI=1:length(findWhatParams)
    myIndex=find(strcmp(myparamcell,findWhatParams(myI)));
    BaselineMatchedVars(myI)=M_.params(myIndex);
end
disp('matched from moments:');
BaselineMatchedVars

% baseline depreciation rate
matrix2latexNS(BaselineMatchedVars(1),[myLatexPath '\baseline_delta.tex'],'format', '%-6.3f');
% baseline varphi
matrix2latexNS(BaselineMatchedVars(2),[myLatexPath '\baseline_varphi.tex'],'format', '%-6.2f');
% baseline AL
matrix2latexNS(BaselineMatchedVars(3),[myLatexPath '\baseline_AL.tex'],'format', '%-6.2f');

%%%%%%%%%%% finfric %%%%%%%%%%%%%%%
findWhatParams={'delta','varphi','AL','gammaa'};
FinfricMatchedVars=zeros(length(findWhatParams),1);
myparamcell=cellstr(finfric_M_.param_names);
for myI=1:length(findWhatParams)
    myIndex=find(strcmp(myparamcell,findWhatParams(myI)));
    FinfricMatchedVars(myI)=finfric_M_.params(myIndex);
end
FinfricMatchedVars


% finfric depreciation rate
matrix2latexNS(FinfricMatchedVars(1),[myLatexPath '\finfric_delta.tex'],'format', '%-6.3f');
% finfric varphi
matrix2latexNS(FinfricMatchedVars(2),[myLatexPath '\finfric_varphi.tex'],'format', '%-6.2f');
% finfric AL
matrix2latexNS(FinfricMatchedVars(3),[myLatexPath '\finfric_AL.tex'],'format', '%-6.2f');
% finfric gammaa
matrix2latexNS(FinfricMatchedVars(4),[myLatexPath '\finfric_gammaa.tex'],'format', '%-6.2f');

%%%%%%%%%%%%%%% calibrated params %%%%%%%%%%%%%%%%%%%%%%%
%%% take from finfric %%%%
findWhatParams={'alphaa','betaa','omegai','omegac',...
    'omegax','phitildea','etag','tauk','tauw','tauc',...
    'tauy','taub','muzplus','pitarget','lambdad','lambdamx','lambdamc','lambdami','lambdax'...
    'thetaw','pibreve','hours_target','iy_target',...
    'xy_target','Fomegabar','wesharePercent','nk_target','lambdaw'};
FinfricCalibVars=zeros(length(findWhatParams),1);
myparamcell=cellstr(finfric_M_.param_names);
for myI=1:length(findWhatParams)
    myIndex=find(strcmp(myparamcell,findWhatParams(myI)));
    FinfricCalibVars(myI)=finfric_M_.params(myIndex);
    matrix2latexNS(FinfricCalibVars(myI),[myLatexPath '\calib_' findWhatParams{myI} '.tex'],'format', '%-6.3f');
end
FinfricCalibVars

%%%%%%%%%%%%%%%% posterior mean %%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% foreign SVAR
disp('posterior mean of params:')
SVAR_oo_.posterior_mean.parameters;

findWhatParams={ 'rhomuz', 'a11',...
    'a22','a33','a12','a13','a21','a23','a24','a31','a32','a34','c21',...
    'c31','c32','c24','c34'...
    };
SVARPosteriorMeanPars=zeros(length(findWhatParams),1);
for myI=1:length(findWhatParams)
    SVARPosteriorMeanPars(myI)=eval(['SVAR_oo_.posterior_mean.parameters.' findWhatParams{myI}]);
    matrix2latexNS(SVARPosteriorMeanPars(myI),[myLatexPath '\SVARPMean_' findWhatParams{myI} '.tex'],'format', '%-6.3f');
end

disp('posterior std of params:')
SVAR_oo_.posterior_std.parameters;

SVARPosteriorSTDPars=zeros(length(findWhatParams),1);
for myI=1:length(findWhatParams)
    SVARPosteriorSTDPars(myI)=eval(['SVAR_oo_.posterior_std.parameters.' findWhatParams{myI}]);
    matrix2latexNS(SVARPosteriorSTDPars(myI),[myLatexPath '\SVARPStd_' findWhatParams{myI} '.tex'],'format', '%-6.3f');
end


% highest posterior density interval
SVAR_oo_.posterior_hpdinf.parameters;
SVAR_oo_.posterior_hpdsup.parameters;

%%% inf %%%%
SVARPosteriorHpdinfPars=zeros(length(findWhatParams),1);
for myI=1:length(findWhatParams)
    SVARPosteriorHpdinfPars(myI)=eval(['SVAR_oo_.posterior_hpdinf.parameters.' findWhatParams{myI}]);
    matrix2latexNS(SVARPosteriorHpdinfPars(myI),[myLatexPath '\SVARPHpdinf_' findWhatParams{myI} '.tex'],'format', '%-6.3f');
end
%%% sup %%%%
SVARPosteriorHpdsupPars=zeros(length(findWhatParams),1);
for myI=1:length(findWhatParams)
    SVARPosteriorHpdsupPars(myI)=eval(['SVAR_oo_.posterior_hpdsup.parameters.' findWhatParams{myI}]);
    matrix2latexNS(SVARPosteriorHpdsupPars(myI),[myLatexPath '\SVARPHpdsup_' findWhatParams{myI} '.tex'],'format', '%-6.3f');
end


disp('posterior mean of shock std:')
SVAR_oo_.posterior_mean.shocks_std;

findWhatShocks={'muz_eps','ystar_eps','pistar_eps','Rstar_eps'};
SVARPosteriorMeanSTDSHocks=zeros(length(findWhatShocks),1);
for myI=1:length(findWhatShocks)
    SVARPosteriorMeanSTDSHocks(myI)=eval(['SVAR_oo_.posterior_mean.shocks_std.' findWhatShocks{myI}]);
    matrix2latexNS(SVARPosteriorMeanSTDSHocks(myI),[myLatexPath '\SVARPShockStd_' findWhatShocks{myI} '.tex'],'format', '%-6.3f');
end

disp('posterior std of shock std:')
SVAR_oo_.posterior_std.shocks_std;


SVARPosteriorSTDSTDSHocks=zeros(length(findWhatShocks),1);
for myI=1:length(findWhatShocks)
    SVARPosteriorSTDSTDSHocks(myI)=eval(['SVAR_oo_.posterior_std.shocks_std.' findWhatShocks{myI}]);
    matrix2latexNS(SVARPosteriorSTDSTDSHocks(myI),[myLatexPath '\SVARPShockStdStd_' findWhatShocks{myI} '.tex'],'format', '%-6.3f');
end


% highest posterior density interval
SVAR_oo_.posterior_hpdinf.shocks_std;
SVAR_oo_.posterior_hpdsup.shocks_std;

%%% inf %%%%
SVARPosteriorHpdinfShocks=zeros(length(findWhatShocks),1);
for myI=1:length(findWhatShocks)
    SVARPosteriorHpdinfShocks(myI)=eval(['SVAR_oo_.posterior_hpdinf.shocks_std.' findWhatShocks{myI}]);
    matrix2latexNS(SVARPosteriorHpdinfShocks(myI),[myLatexPath '\SVARPShockHpdinf_' findWhatShocks{myI} '.tex'],'format', '%-6.3f');
end

%%% sup %%%%
SVARPosteriorHpdsupShocks=zeros(length(findWhatShocks),1);
for myI=1:length(findWhatShocks)
    SVARPosteriorHpdsupShocks(myI)=eval(['SVAR_oo_.posterior_hpdsup.shocks_std.' findWhatShocks{myI}]);
    matrix2latexNS(SVARPosteriorHpdsupShocks(myI),[myLatexPath '\SVARPShockHpdsup_' findWhatShocks{myI} '.tex'],'format', '%-6.3f');
end


%%%%%%baseline %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('posterior mean of params:')
oo_.posterior_mean.parameters;

findWhatParams={'xid','xix','ximc','ximi','ximx','kappad',...
    'kappax','kappamc','kappami','kappamx','kappaw','work_cap_para',...
    'sigmaLScaled','b','SppScaled','sigmaa',... %'rhoR','rpi','ry','rRstar'
    'etax','etac','etaf','rhoepsilon','etai',... % ,'etai' calib, ,'phitildes' zero
    'rhoUpsilon','rhozetac','rhozetah','rhophitilde','rhog'... % 'rhomuz', 'a11',
    %'a22','a33','a12','a13','a21','a23','a24','a31','a32','a34','c21',...
    %'c31','c32','c24','c34'
    };
BaselinePosteriorMeanPars=zeros(length(findWhatParams),1);
for myI=1:length(findWhatParams)
    BaselinePosteriorMeanPars(myI)=eval(['oo_.posterior_mean.parameters.' findWhatParams{myI}]);
    matrix2latexNS(BaselinePosteriorMeanPars(myI),[myLatexPath '\BPMean_' findWhatParams{myI} '.tex'],'format', '%-6.3f');
end

disp('posterior std of params:')
oo_.posterior_std.parameters;

BaselinePosteriorSTDPars=zeros(length(findWhatParams),1);
for myI=1:length(findWhatParams)
    BaselinePosteriorSTDPars(myI)=eval(['oo_.posterior_std.parameters.' findWhatParams{myI}]);
    matrix2latexNS(BaselinePosteriorSTDPars(myI),[myLatexPath '\BPStd_' findWhatParams{myI} '.tex'],'format', '%-6.3f');
end


disp('posterior mean of shock std:')
oo_.posterior_mean.shocks_std;

findWhatShocks={'epsilon_eps','Upsilon_eps','zetac_eps',... % 'muz_eps',
    'zetah_eps','phitilde_eps','g_eps','taud_eps','taux_eps',... % 'epsR_eps',
    'taumc_eps','taumi_eps','taumx_eps'}; % ,'ystar_eps','pistar_eps','Rstar_eps'
BaselinePosteriorMeanSTDSHocks=zeros(length(findWhatShocks),1);
for myI=1:length(findWhatShocks)
    BaselinePosteriorMeanSTDSHocks(myI)=eval(['oo_.posterior_mean.shocks_std.' findWhatShocks{myI}]);
    matrix2latexNS(BaselinePosteriorMeanSTDSHocks(myI),[myLatexPath '\BPShockStd_' findWhatShocks{myI} '.tex'],'format', '%-6.3f');
end

disp('posterior std of shock std:')
oo_.posterior_std.shocks_std;


BaselinePosteriorSTDSTDSHocks=zeros(length(findWhatShocks),1);
for myI=1:length(findWhatShocks)
    BaselinePosteriorSTDSTDSHocks(myI)=eval(['oo_.posterior_std.shocks_std.' findWhatShocks{myI}]);
    matrix2latexNS(BaselinePosteriorSTDSTDSHocks(myI),[myLatexPath '\BPShockStdStd_' findWhatShocks{myI} '.tex'],'format', '%-6.3f');
end

%%%%%%%%%%%%%%%%%finfric %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%% prior mean
finfric_oo_.prior.mean;

findWhatParams={'xid','xix','ximc','ximi','ximx','kappad',...
    'kappax','kappamc','kappami','kappamx','kappaw','work_cap_para',...
    'sigmaLScaled','b','SppScaled','sigmaa',... %'rhoR','rpi','ry','rRstar',...
    'etax','etaf','rhoepsilon',... % ,'etai' calib ,'phitildes' zero
    'rhoUpsilon','rhozetac','rhozetah','rhophitilde','rhog',... %'a11',... % 'rhomuz'
    'mu','rhogamma','etac'}; % ,'etac'
    %'a22','a33','a12','a13','a21','a23','a24','a31','a32','a34','c21',...
    %'c31','c32','c24','c34',
    

% FinfricPriorMeanPars=zeros(length(findWhatParams),1);
% for myI=1:length(findWhatParams)
%     FinfricPriorMeanPars(myI)=eval(['finfric_oo_.prior.mean.' findWhatParams{myI}]);
%     matrix2latexNS(FinfricPriorMeanPars(myI),[myLatexPath '\FPriorMean_' findWhatParams{myI} '.tex'],'format', '%-6.3f');
% end

%%%% prior std
sqrt(finfric_oo_.prior.variance);

% FinfricPriorSTDPars=zeros(length(findWhatParams),1);
% for myI=1:length(findWhatParams)
%     FinfricPriorSTDPars(myI)=sqrt(eval(['finfric_oo_.prior.variance.' findWhatParams{myI}]));
%     matrix2latexNS(FinfricPriorSTDPars(myI),[myLatexPath '\FPriorStd_' findWhatParams{myI} '.tex'],'format', '%-6.3f');
% end



disp('posterior mean of params:')
finfric_oo_.posterior_mean.parameters;


FinfricPosteriorMeanPars=zeros(length(findWhatParams),1);
for myI=1:length(findWhatParams)
    FinfricPosteriorMeanPars(myI)=eval(['finfric_oo_.posterior_mean.parameters.' findWhatParams{myI}]);
    matrix2latexNS(FinfricPosteriorMeanPars(myI),[myLatexPath '\FPMean_' findWhatParams{myI} '.tex'],'format', '%-6.3f');
end

disp('posterior std of params:')
finfric_oo_.posterior_std.parameters;

FinfricPosteriorSTDPars=zeros(length(findWhatParams),1);
for myI=1:length(findWhatParams)
    FinfricPosteriorSTDPars(myI)=eval(['finfric_oo_.posterior_std.parameters.' findWhatParams{myI}]);
    matrix2latexNS(FinfricPosteriorSTDPars(myI),[myLatexPath '\FPStd_' findWhatParams{myI} '.tex'],'format', '%-6.3f');
end

% highest posterior density interval
%%%%%finfric model %%%%%%%%%%%%%%%
finfric_oo_.posterior_hpdinf.parameters;
finfric_oo_.posterior_hpdsup.parameters;

%%% inf %%%%
FinfricPosteriorHpdinfPars=zeros(length(findWhatParams),1);
for myI=1:length(findWhatParams)
    FinfricPosteriorHpdinfPars(myI)=eval(['finfric_oo_.posterior_hpdinf.parameters.' findWhatParams{myI}]);
    matrix2latexNS(FinfricPosteriorHpdinfPars(myI),[myLatexPath '\FPHpdinf_' findWhatParams{myI} '.tex'],'format', '%-6.3f');
end
%%% sup %%%%
FinfricPosteriorHpdsupPars=zeros(length(findWhatParams),1);
for myI=1:length(findWhatParams)
    FinfricPosteriorHpdsupPars(myI)=eval(['finfric_oo_.posterior_hpdsup.parameters.' findWhatParams{myI}]);
    matrix2latexNS(FinfricPosteriorHpdsupPars(myI),[myLatexPath '\FPHpdsup_' findWhatParams{myI} '.tex'],'format', '%-6.3f');
end


disp('posterior mean of shock std:')
finfric_oo_.posterior_mean.shocks_std;

findWhatShocks={'epsilon_eps','Upsilon_eps','zetac_eps',...   % 'muz_eps',
    'zetah_eps','phitilde_eps','g_eps','taud_eps','taux_eps',...  % 'epsR_eps',
    'taumc_eps','taumi_eps','taumx_eps',...   %'ystar_eps','pistar_eps',...
    'gamma_eps'%,'Rstar_eps'
    };

FinfricPosteriorMeanSTDSHocks=zeros(length(findWhatShocks),1);
for myI=1:length(findWhatShocks)
    FinfricPosteriorMeanSTDSHocks(myI)=eval(['finfric_oo_.posterior_mean.shocks_std.' findWhatShocks{myI}]);
    matrix2latexNS(FinfricPosteriorMeanSTDSHocks(myI),[myLatexPath '\FPShockStd_' findWhatShocks{myI} '.tex'],'format', '%-6.3f');
end

disp('posterior std of shock std:')
finfric_oo_.posterior_std.shocks_std;


FinfricPosteriorSTDSTDSHocks=zeros(length(findWhatShocks),1);
for myI=1:length(findWhatShocks)
    FinfricPosteriorSTDSTDSHocks(myI)=eval(['finfric_oo_.posterior_std.shocks_std.' findWhatShocks{myI}]);
    matrix2latexNS(FinfricPosteriorSTDSTDSHocks(myI),[myLatexPath '\FPShockStdStd_' findWhatShocks{myI} '.tex'],'format', '%-6.3f');
end

% highest posterior density interval
%%%%%finfric model %%%%%%%%%%%%%%%
finfric_oo_.posterior_hpdinf.shocks_std;
finfric_oo_.posterior_hpdsup.shocks_std;

%%% inf %%%%
FinfricPosteriorHpdinfShocks=zeros(length(findWhatShocks),1);
for myI=1:length(findWhatShocks)
    FinfricPosteriorHpdinfShocks(myI)=eval(['finfric_oo_.posterior_hpdinf.shocks_std.' findWhatShocks{myI}]);
    matrix2latexNS(FinfricPosteriorHpdinfShocks(myI),[myLatexPath '\FPShockHpdinf_' findWhatShocks{myI} '.tex'],'format', '%-6.3f');
end

%%% sup %%%%
FinfricPosteriorHpdsupShocks=zeros(length(findWhatShocks),1);
for myI=1:length(findWhatShocks)
    FinfricPosteriorHpdsupShocks(myI)=eval(['finfric_oo_.posterior_hpdsup.shocks_std.' findWhatShocks{myI}]);
    matrix2latexNS(FinfricPosteriorHpdsupShocks(myI),[myLatexPath '\FPShockHpdsup_' findWhatShocks{myI} '.tex'],'format', '%-6.3f');
end

%%%%%%%%%%%%%%% model moments %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%% baseline %%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%  mean  %%%%%%%%%%%%%%%%%%%%
%%% beware: the order depends on the var list after stoch_simul
nbefore=1;
myVarList={'data_RU','data_wdiffU','data_cdiffU','data_ydiffU',...  
'data_ystardiffU','data_pistarU','data_RstarU','data_HdiffU',... 
'data_impdiffU','data_piiU','data_pidU','data_picU','data_xdiffU',... 
'data_qdiffU','data_idiffU','data_gdiffU'}; % ,'data_sdevU'
muzplusInd=find(strcmp(cellstr(M_.param_names),'muzplus'));
BaselineVarMean=zeros(length(myVarList),1);
for myI=1:length(myVarList)
    BaselineVarMean(myI)=oo_.mean(nbefore+myI);
    if myI==2 || myI==3 || myI==4 || myI==5||myI==9||myI==13 || myI==15|| myI==16
        BaselineVarMean(myI) = BaselineVarMean(myI)+(M_.params(muzplusInd)-1)*100;
    end
    if myI==10 || myI==11 || myI==12
        BaselineVarMean(myI) = BaselineVarMean(myI)+400*log(M_.params(muzplusInd));
    end
    matrix2latexNS(BaselineVarMean(myI),[myLatexPath '\BVMean_' myVarList{myI} '.tex'],'format', '%-6.2f');
end

%%%%% std  %%%%%%

BaselineVarStd=zeros(length(myVarList),1);
for myI=1:length(myVarList)
    BaselineVarStd(myI)=sqrt(oo_.var(nbefore+myI,nbefore+myI));
    matrix2latexNS(BaselineVarStd(myI),[myLatexPath '\BVStd_' myVarList{myI} '.tex'],'format', '%-6.2f');
end

%%%%%%%%%% finfric %%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%  mean  %%%%%%%%%%%%%%%%%%%%
%%% beware: the order depends on the var list after stoch_simul
fnbefore=1; 
myVarList={'data_RU','data_wdiffU','data_cdiffU','data_ydiffU',...  
'data_ystardiffU','data_pistarU','data_RstarU','data_HdiffU',... 
'data_impdiffU','data_piiU','data_pidU','data_picU','data_xdiffU',... 
'data_qdiffU','data_idiffU','data_gdiffU','data_ndiffU',...
'data_spreadU'}; % ,'data_sdevU'
muzplusInd=find(strcmp(cellstr(finfric_M_.param_names),'muzplus'));
FinfricVarMean=zeros(length(myVarList),1);
for myI=1:length(myVarList)
    FinfricVarMean(myI)=finfric_oo_.mean(fnbefore+myI);
    if myI==2 || myI==3 || myI==4 || myI==5||myI==9||myI==13 || myI==15|| myI==16|| myI==17
        FinfricVarMean(myI) = FinfricVarMean(myI)+(finfric_M_.params(muzplusInd)-1)*100;
    end
    if myI==10 || myI==11 || myI==12
        FinfricVarMean(myI) = FinfricVarMean(myI)+400*log(finfric_M_.params(muzplusInd));
    end
    matrix2latexNS(FinfricVarMean(myI),[myLatexPath '\FVMean_' myVarList{myI} '.tex'],'format', '%-6.2f');
end

%%%%% std  %%%%%%

FinfricVarStd=zeros(length(myVarList),1);
for myI=1:length(myVarList)
    FinfricVarStd(myI)=sqrt(finfric_oo_.var(nbefore+myI,nbefore+myI));
    matrix2latexNS(FinfricVarStd(myI),[myLatexPath '\FVStd_' myVarList{myI} '.tex'],'format', '%-6.2f');
end

%%%%%%%%%%%% data moments %%%%%%%%%%%%%%%%%%%%%
load('myUndemeanedData');

myVarList={'data_RU','dw_obs','dc_obs','dy_obs','dystar_obs',...
    'data_pistarU','data_RstarU','data_HdiffU','dimp_obs',...
    'data_piiU','data_pidU','data_picU','dexp_obs','data_qdiffU',...
    'dinv_obs','dg_obs','dlrstockvq','data_spreaddiffU',...
    'data_spreadU','data_unempdiffU'}; % ,'data_sdevU'

DataMean=zeros(length(myVarList),1);
for myI=1:length(myVarList)
    DataMean(myI)=mean(eval(['myUndemeanedData.' myVarList{myI}]));
    matrix2latexNS(DataMean(myI),[myLatexPath '\DataMean_' myVarList{myI} '.tex'],'format', '%-6.2f');
end

DataStd=zeros(length(myVarList),1);
for myI=1:length(myVarList)
    DataStd(myI)=std(eval(['myUndemeanedData.' myVarList{myI}]));
    matrix2latexNS(DataStd(myI),[myLatexPath '\DataStd_' myVarList{myI} '.tex'],'format', '%-6.2f');
end


% smoothed shocks figure

%%%%% baseline %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% oo_.SmoothedShocks.Mean
myShockLength=length(oo_.SmoothedShocks.Mean.epsilon_eps);
myXaxisLen=myShockLength+2;
nticks=3;
myShocks={'muz';'epsilon'; 'Upsilon';'zetac';'Rstar';'phitilde';...
    'zetah';'ystar';'pistar';'g';'taud';... % 'epsR';
    'taux';'taumc';'taumi';'taumx';'data_pidU';'data_wdiffU';...
    'data_cdiffU';'data_idiffU';'data_qdiffU';'data_HdiffU';...
    'data_ydiffU';'data_xdiffU';'data_impdiffU';'data_picU';...
    'data_piiU';'data_gdiffU'}; %;'data_sdevU'; 'gamma'

myShocksText={'unit-root technology';'stationary technology';'marginal efficiency of inv.';'consumption preference';...
    'foreign interest rate';'country risk premium';'labor preference';'foreign output';'foreign inflation';'government expenditure';... % 'monetary policy';
    'domestic markup';'export markup';'import consumption markup';'import investment markup';...
    'import export markup';'meas. GDP deflator';'meas. real wage';...
    'meas. consumption';'meas. investment';'meas. real x-rate';...
    'meas. hours';'meas. output';'meas. exports';...
    'meas. imports';'meas. CPI';'meas. investment price';...
    'meas. gov. expend.'}; % ;'meas. nominal x-rate'
for myi=1:ceil(length(myShocks)/9)
    figure(myi)
    if myi==ceil(length(myShocks)/9)
        myInd = 9*(myi-1)+[1:(length(myShocks)-9*(myi-1))];
    else
        myInd=9*(myi-1)+[1:9];
    end
    for myj=myInd
    %subplot(5,3,myj)
    subaxis(3,3,myj-9*(myi-1), 'SpacingHoriz', 0.04,'SpacingVert',.08); % from
    %fileExchange , 'Padding', 0, 'Margin', 0
    plot(eval(['oo_.SmoothedShocks.Mean.' myShocks{myj} '_eps']),'k','LineWidth',1)
    hold on
    plot(zeros(myShockLength,1),'k:')
    hold off
    axis([-Inf myXaxisLen -Inf +Inf])
    %title(myShocks{myj})
    %set(gca,'XTick',myShockLength-3-nticks*32+(1:nticks)*32)
    set(gca,'XTick',[4 20 36 52 68])
    set(gca,'XTickLabel',['1996';'2000';'2004';'2008';'2012'])
    %set(gca,'FontSize',18) 
    %title(['$' myShocksLatex{myj} '$'],'interpreter','latex','FontSize', 13)
    title([myShocksText{myj}],'FontSize', 13)
    
    %axis tight
    end
    thispath = cd; 
    cd(myLatexPath)
    print(myi,'-depsc',['BSmoothedShocksFig_' num2str(myi)])
    print(myi,'-dpdf',['BSmoothedShocksFig_' num2str(myi)])
    cd(thispath)
    %close all
end

close all



%%%%% finfric %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% finfric_oo_.SmoothedShocks.Mean
myShockLength=length(finfric_oo_.SmoothedShocks.Mean.epsilon_eps);
myXaxisLen=myShockLength+2;
nticks=3;
myShocks={'muz';'epsilon'; 'Upsilon';'zetac';'Rstar';'phitilde';...
    'zetah';'ystar';'pistar';'g';'taud';... % 'epsR';
    'taux';'taumc';'taumi';'taumx';'data_pidU';'data_wdiffU';...
    'data_cdiffU';'data_idiffU';'data_qdiffU';'data_HdiffU';...
    'data_ydiffU';'data_xdiffU';'data_impdiffU';'data_picU';...
    'data_piiU';'data_gdiffU';'gamma';'data_ndiffU';...
    'data_spreadU'}; % 'data_sdevU';

myShocksText={'unit-root technology';'stationary technology';'marginal efficiency of inv.';'consumption preference';...
    'foreign interest rate';'country risk premium';'labor preference';'foreign output';'foreign inflation';'government expenditure';... % 'monetary policy';
    'domestic markup';'export markup';'import consumption markup';'import investment markup';...
    'import export markup';'meas. GDP deflator';'meas. real wage';...
    'meas. consumption';'meas. investment';'meas. real x-rate';...
    'meas. hours';'meas. output';'meas. exports';...
    'meas. imports';'meas. CPI';'meas. investment price';...
    'meas. gov. expend.';'entrepreneurial wealth';...
    'meas. net worth';'meas. spread'}; % 'meas. nominal x-rate';
for myi=1:ceil(length(myShocks)/9)
    figure(myi)
    if myi==ceil(length(myShocks)/9)
        myInd = 9*(myi-1)+[1:(length(myShocks)-9*(myi-1))];
    else
        myInd=9*(myi-1)+[1:9];
    end
    for myj=myInd
    %subplot(5,3,myj)
    subaxis(3,3,myj-9*(myi-1), 'SpacingHoriz', 0.04,'SpacingVert',.08); % from
        %fileExchange , 'Padding', 0, 'Margin', 0
    plot(eval(['finfric_oo_.SmoothedShocks.Mean.' myShocks{myj} '_eps']),'k','LineWidth',1)
    hold on
    plot(zeros(myShockLength,1),'k:')
    hold off
    axis([-Inf myXaxisLen -Inf +Inf])
    %title(myShocks{myj})
    %set(gca,'XTick',myShockLength-3-nticks*32+(1:nticks)*32)
    set(gca,'XTick',[4 20 36 52 68])
    set(gca,'XTickLabel',['1996';'2000';'2004';'2008';'2012'])
    %set(gca,'FontSize',18) 
    %title(['$' myShocksLatex{myj} '$'],'interpreter','latex','FontSize', 13)
    title([myShocksText{myj}],'FontSize', 13)
    end
    thispath = cd; 
    cd(myLatexPath)
    print(myi,'-depsc',['FFSmoothedShocksFig_' num2str(myi)])
    print(myi,'-dpdf',['FFSmoothedShocksFig_' num2str(myi)])
    cd(thispath)
    %close all
end


close all

%%% smoothed shock means and std  %%%%%%%%%
%%% baseline %%%%

myShocks={'mupsi';'muz';'epsilon';'Rstar'; 'Upsilon';'zetac';'phitilde';... % ;
    'tauy';'zetah';'ystar';'pistar';'g';'taud';... % 'epsR';
    'taux';'taumc';'taumi';'taumx';'data_pidU';'data_wdiffU';...
    'data_cdiffU';'data_idiffU';'data_qdiffU';'data_HdiffU';...
    'data_ydiffU';'data_xdiffU';'data_impdiffU';'data_picU';...
    'data_piiU';'data_gdiffU'}; %'gamma' ;'data_sdevU'

BaselineSmoothedShockMean=zeros(length(myShocks),1);
for myI=1:length(myShocks)
    BaselineSmoothedShockMean(myI)=mean(eval(['oo_.SmoothedShocks.Mean.' myShocks{myI} '_eps']));
    matrix2latexNS(BaselineSmoothedShockMean(myI),[myLatexPath '\BSSMean_' myShocks{myI} '.tex'],'format', '%-6.2f');
end

BaselineSmoothedShockStd=zeros(length(myShocks),1);
for myI=1:length(myShocks)
    BaselineSmoothedShockStd(myI)=std(eval(['oo_.SmoothedShocks.Mean.' myShocks{myI} '_eps']));
    matrix2latexNS(BaselineSmoothedShockStd(myI),[myLatexPath '\BSSStd_' myShocks{myI} '.tex'],'format', '%-6.2f');
end


%%% finfric %%%%

myShocks={'mupsi';'muz';'epsilon'; 'Upsilon';'zetac';'Rstar';'phitilde';...
    'tauy';'zetah';'ystar';'pistar';'g';'taud';... % 'epsR';
    'taux';'taumc';'taumi';'taumx';'data_pidU';'data_wdiffU';...
    'data_cdiffU';'data_idiffU';'data_qdiffU';'data_HdiffU';...
    'data_ydiffU';'data_xdiffU';'data_impdiffU';'data_picU';...
    'data_piiU';'data_gdiffU';'gamma';'data_ndiffU';...
    'data_spreadU'};  % ;'data_sdevU'

FinfricSmoothedShockMean=zeros(length(myShocks),1);
for myI=1:length(myShocks)
    FinfricSmoothedShockMean(myI)=mean(eval(['finfric_oo_.SmoothedShocks.Mean.' myShocks{myI} '_eps']));
    matrix2latexNS(FinfricSmoothedShockMean(myI),[myLatexPath '\FSSMean_' myShocks{myI} '.tex'],'format', '%-6.2f');
end

FinfricSmoothedShockStd=zeros(length(myShocks),1);
for myI=1:length(myShocks)
    FinfricSmoothedShockStd(myI)=std(eval(['finfric_oo_.SmoothedShocks.Mean.' myShocks{myI} '_eps']));
    matrix2latexNS(FinfricSmoothedShockStd(myI),[myLatexPath '\FSSStd_' myShocks{myI} '.tex'],'format', '%-6.2f');
end


% shock decomposition

%%%%%% baseline %%%%%%%%%%%%%%
%oo_.shock_decomposition
%gdp
findWhatVars={'data_ydiffU'};
myVarsCell=cellstr(M_.endo_names);
myVarsIndex=find(strcmp(myVarsCell,findWhatVars));
%myWhichShocks=zeros(length(M_.exo_names),1);
%for myj=1:length(M_.exo_names)
%    myWhichShocks(myj)=max(abs(oo_.shock_decomposition(myVarsIndex,myj,:)))>1e-1; %tolerance value
%end

%z=oo_.shock_decomposition(:,find(myWhichShocks),:);
z=oo_.shock_decomposition;
%shock_names = M_.exo_names(find(myWhichShocks),:);
shock_names = M_.exo_names;
shockNamesText={'investment specific technology';'unit-root technology';...
    'stationary technology';'inflation target';'marginal efficiency of inv.';...
    'consumption preference';'foreign interest rate';'country risk premium';...
    'tauy_eps';'labor preference';'monetary policy';'foreign output';...
    'foreign inflation';'government expenditure';'domestic markup';...
    'export markup';'import cons. markup';'import inv. markup';...
    'import export markup';'meas. pid';'meas. wage';'meas. cons.';'meas. inv.';...
    'meas. x-rate';'meas. hours';'meas. GDP';'meas. exp.';'meas. imp.';'meas. pic';'meas. pii';...
    'meas. ystar';'meas. pistar';'meas. wealth';'meas. unemp';'meas. spread';...
    'meas. govt.';'meas. Hhat';'lsU';'initial values'}; % 'data_sdev';
endo_names = M_.endo_names;
i_var = myVarsIndex;
initial_date=options_.initial_date;
myTol=2.5e+0; %1e-1

%MyGraphDecomp(z,shock_names,endo_names,i_var,initial_date,myTol)
MyGraphDecomp(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)

thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','GDPDecomposition')
print(1,'-dpdf','GDPDecomposition')
cd(thispath)

close all

% from 2004
myTol=2.5e+0; %2.5e+0
MyGraphDecompFrom2004(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)

thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','GDPDecompositionShort')
print(1,'-dpdf','GDPDecompositionShort')
cd(thispath)

close all


% from 2004     plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)    plot(exp(ctw_smoothedvars.lmU)./(1-exp(ctw_smoothedvars.lLU)),'--blue', 'linewidth',2)
myTol=2.5e+0; %2.5e+0
MyGraphDecompFrom2004(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)

thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','GDPDecompositionShort')
print(1,'-dpdf','GDPDecompositionShort')
cd(thispath)    
close all

%%%% GDP levels

%
findWhatVars={'lylessdU'};
myVarsCell=cellstr(M_.endo_names);
myVarsIndex=find(strcmp(myVarsCell,findWhatVars));
%myWhichShocks=zeros(length(M_.exo_names),1);
%for myj=1:length(M_.exo_names)
%    myWhichShocks(myj)=max(abs(oo_.shock_decomposition(myVarsIndex,myj,:)))>1e-1; %tolerance value
%end

%z=oo_.shock_decomposition(:,find(myWhichShocks),:);
z=100*oo_.shock_decomposition;
%shock_names = M_.exo_names(find(myWhichShocks),:);
shock_names = M_.exo_names;
endo_names = M_.endo_names;
i_var = myVarsIndex;
initial_date=options_.initial_date;
myTol= 5e-0; %1e-1;

%MyGraphDecomp(z,shock_names,endo_names,i_var,initial_date,myTol)
MyGraphDecomp(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)


thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','GDPlevelsDecomposition')
print(1,'-dpdf','GDPDlevelsecomposition')
cd(thispath)

close all

% from 2004
myTol= 4.5e-0; %4.5e-0
MyGraphDecompFrom2004(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)


thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','GDPlevelsDecompositionShort')
print(1,'-dpdf','GDPlevelsDecompositionShort')
cd(thispath)

close all


% cpi
findWhatVars={'data_picU'};
myVarsCell=cellstr(M_.endo_names);
myVarsIndex=find(strcmp(myVarsCell,findWhatVars));
%myWhichShocks=zeros(length(M_.exo_names),1);
%for myj=1:length(M_.exo_names)
%    myWhichShocks(myj)=max(abs(oo_.shock_decomposition(myVarsIndex,myj,:)))>1e-1; %tolerance value
%end

%z=oo_.shock_decomposition(:,find(myWhichShocks),:);
z=oo_.shock_decomposition;
%shock_names = M_.exo_names(find(myWhichShocks),:);
shock_names = M_.exo_names;
endo_names = M_.endo_names;
i_var = myVarsIndex;
initial_date=options_.initial_date;
myTol=2e+0; %1e-1;

%MyGraphDecomp(z,shock_names,endo_names,i_var,initial_date,myTol)
MyGraphDecomp(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)

thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','CPIDecomposition')
print(1,'-dpdf','CPIDecomposition')
cd(thispath)

close all

% from 2004
myTol=1.5e+0; %1e-1;
MyGraphDecompFrom2004(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)

thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','CPIDecompositionShort')
print(1,'-dpdf','CPIDecompositionShort')
cd(thispath)

close all


% % sdev
% findWhatVars={'data_sdevU'};
% myVarsCell=cellstr(M_.endo_names);
% myVarsIndex=find(strcmp(myVarsCell,findWhatVars));
% %myWhichShocks=zeros(length(M_.exo_names),1);
% %for myj=1:length(M_.exo_names)
% %    myWhichShocks(myj)=max(abs(oo_.shock_decomposition(myVarsIndex,myj,:)))>1e-1; %tolerance value
% %end
% 
% %z=oo_.shock_decomposition(:,find(myWhichShocks),:);
% z=oo_.shock_decomposition;
% %shock_names = M_.exo_names(find(myWhichShocks),:);
% shock_names = M_.exo_names;
% endo_names = M_.endo_names;
% i_var = myVarsIndex;
% initial_date=options_.initial_date;
% myTol=.7e-2; %1e-3;
% 
% %MyGraphDecomp(z,shock_names,endo_names,i_var,initial_date,myTol)
% MyGraphDecomp(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)
% 
% % 
% thispath = cd; 
% cd(myLatexPath)
% print(1,'-depsc','sdevDecomposition')
% print(1,'-dpdf','sdevDecomposition')
% cd(thispath)
% 
% close(1)
%     
 

%%%%%% finfric %%%%%%%%%%%%%%
% finfric_oo_.shock_decomposition
% gdp
findWhatVars={'data_ydiffU'};
myVarsCell=cellstr(finfric_M_.endo_names);
myVarsIndex=find(strcmp(myVarsCell,findWhatVars));
%myWhichShocks=zeros(length(M_.exo_names),1);
%for myj=1:length(M_.exo_names)
%    myWhichShocks(myj)=max(abs(oo_.shock_decomposition(myVarsIndex,myj,:)))>1e-1; %tolerance value
%end

%z=oo_.shock_decomposition(:,find(myWhichShocks),:);
z=finfric_oo_.shock_decomposition;
%shock_names = M_.exo_names(find(myWhichShocks),:);
shock_names = finfric_M_.exo_names;
shockNamesText={'investment specific technology';'unit-root technology';...
    'stationary technology';'inflation target';'marginal efficiency of inv.';...
    'consumption preference';'foreign interest rate';'country risk premium';...
    'tauy_eps';'labor preference';'monetary policy';'foreign output';...
    'foreign inflation';'government expenditure';'domestic markup';...
    'export markup';'import cons. markup';'import inv. markup';...
    'import export markup';'sigma_eps';'entrepreneurial wealth';'meas. pid';...
    'meas. wage';'meas. cons.';'meas. inv.';...
    'meas. x-rate';'meas. hours';'meas. GDP';'meas. exp.';'meas. imp.';'meas. pic';'meas. pii';...
    'meas. ystar';'meas. pistar';'meas. wealth';'meas. unemp';'meas. spread';...
    'meas. govt.';'meas. Hhat';'meas. spreaddiff';'lsU';'initial values'}; % ;'data_sdev'
endo_names = finfric_M_.endo_names;
i_var = myVarsIndex;
initial_date=options_.initial_date;
myTol=2e-0; %1e-1;

%MyGraphDecomp(z,shock_names,endo_names,i_var,initial_date,myTol)
MyGraphDecomp(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)


thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','FFGDPDecomposition')
print(1,'-dpdf','FFGDPDecomposition')
cd(thispath)

close all

% from 2004
myTol=2e-0; %1e-1;
MyGraphDecompFrom2004(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)


thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','FFGDPDecompositionShort')
print(1,'-dpdf','FFGDPDecompositionShort')
cd(thispath)

close all

%%%% GDP levels

%
findWhatVars={'lylessdU'};
myVarsCell=cellstr(finfric_M_.endo_names);
myVarsIndex=find(strcmp(myVarsCell,findWhatVars));
%myWhichShocks=zeros(length(M_.exo_names),1);
%for myj=1:length(M_.exo_names)
%    myWhichShocks(myj)=max(abs(oo_.shock_decomposition(myVarsIndex,myj,:)))>1e-1; %tolerance value
%end

%z=oo_.shock_decomposition(:,find(myWhichShocks),:);
z=100*finfric_oo_.shock_decomposition;
%shock_names = M_.exo_names(find(myWhichShocks),:);
shock_names = finfric_M_.exo_names;
endo_names = finfric_M_.endo_names;
i_var = myVarsIndex;
initial_date=options_.initial_date;
myTol= 4e-0; %1e-1;

%MyGraphDecomp(z,shock_names,endo_names,i_var,initial_date,myTol)
MyGraphDecomp(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)


thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','FFGDPlevelsDecomposition')
print(1,'-dpdf','FFGDPDlevelsecomposition')
cd(thispath)

close all

% from 2004
myTol= 4e-0; %1e-1;
MyGraphDecompFrom2004(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)


thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','FFGDPlevelsDecompositionShort')
print(1,'-dpdf','FFGDPlevelsDecompositionShort')
cd(thispath)

close all



% cpi
findWhatVars={'data_picU'};
myVarsCell=cellstr(finfric_M_.endo_names);
myVarsIndex=find(strcmp(myVarsCell,findWhatVars));
%myWhichShocks=zeros(length(M_.exo_names),1);
%for myj=1:length(M_.exo_names)
%    myWhichShocks(myj)=max(abs(oo_.shock_decomposition(myVarsIndex,myj,:)))>1e-1; %tolerance value
%end

%z=oo_.shock_decomposition(:,find(myWhichShocks),:);
z=finfric_oo_.shock_decomposition;
%shock_names = M_.exo_names(find(myWhichShocks),:);
shock_names = finfric_M_.exo_names;
endo_names = finfric_M_.endo_names;
i_var = myVarsIndex;
initial_date=options_.initial_date;
myTol= 1.5e-0; %1e-1;

%MyGraphDecomp(z,shock_names,endo_names,i_var,initial_date,myTol)
MyGraphDecomp(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)


thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','FFCPIDecomposition')
print(1,'-dpdf','FFCPIDecomposition')
cd(thispath)

close all

% from 2004
myTol= 1.5e-0; %1e-1;
MyGraphDecompFrom2004(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)


thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','FFCPIDecompositionShort')
print(1,'-dpdf','FFCPIDecompositionShort')
cd(thispath)

close all

% % sdev
% findWhatVars={'data_sdevU'};
% myVarsCell=cellstr(finfric_M_.endo_names);
% myVarsIndex=find(strcmp(myVarsCell,findWhatVars));
% %myWhichShocks=zeros(length(M_.exo_names),1);
% %for myj=1:length(M_.exo_names)
% %    myWhichShocks(myj)=max(abs(oo_.shock_decomposition(myVarsIndex,myj,:)))>1e-1; %tolerance value
% %end
% 
% %z=oo_.shock_decomposition(:,find(myWhichShocks),:);
% z=finfric_oo_.shock_decomposition;
% %shock_names = M_.exo_names(find(myWhichShocks),:);
% shock_names = finfric_M_.exo_names;
% endo_names = finfric_M_.endo_names;
% i_var = myVarsIndex;
% initial_date=options_.initial_date;
% myTol=.7e-2;  %1e-3;
% 
% %MyGraphDecomp(z,shock_names,endo_names,i_var,initial_date,myTol)
% MyGraphDecomp(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)
% 
% % 
% thispath = cd; 
% cd(myLatexPath)
% print(1,'-depsc','FFsdevDecomposition')
% print(1,'-dpdf','FFsdevDecomposition')
% cd(thispath)
% 
% close(1)


% spreaddiff or spread
%findWhatVars={'data_spreaddiffU'};
findWhatVars={'data_spreadU'};
myVarsCell=cellstr(finfric_M_.endo_names);
myVarsIndex=find(strcmp(myVarsCell,findWhatVars));
%myWhichShocks=zeros(length(M_.exo_names),1);
%for myj=1:length(M_.exo_names)
%    myWhichShocks(myj)=max(abs(oo_.shock_decomposition(myVarsIndex,myj,:)))>1e-1; %tolerance value
%end

%z=oo_.shock_decomposition(:,find(myWhichShocks),:);
z=finfric_oo_.shock_decomposition;
%shock_names = M_.exo_names(find(myWhichShocks),:);
shock_names = finfric_M_.exo_names;
endo_names = finfric_M_.endo_names;
i_var = myVarsIndex;
initial_date=options_.initial_date;
myTol=.8e-0;   %1e-0;

%MyGraphDecomp(z,shock_names,endo_names,i_var,initial_date,myTol)
MyGraphDecomp(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)

%  
thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','FFspreadDecomposition')
print(1,'-dpdf','FFspreadDecomposition')
cd(thispath)

close all

% from 2004
myTol=.8e-0;   %.8e-0
MyGraphDecompFrom2004(z,char(shockNamesText),endo_names,i_var,initial_date,myTol)

%  
thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','FFspreadDecompositionShort')
print(1,'-dpdf','FFspreadDecompositionShort')
cd(thispath)

close all




%%%%%impulse response functions (IRF) %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% shocks: 
% monetary policy shock: epsR
myIRFTitleList = {... %  'Monetary policy shock';...
    'Stationary neutral technology shock';...
    'Marginal efficiency of investment shock';...
    'Consumption preference shock';...
    'Labor preference shock';...
    'Government consumption shock';...
    'Domestic markup shock';...
    'Import export markup shock';...
    'Import consumption markup shock';...
    'Import investment markup shock';...
    'Export markup shock';...
    'Country risk premium shock';...
    'Unit-root technology shock';...
    'Foreign nominal interest rate shock';...
    'Foreign inflation shock';...
    'Foreign output shock';...
    'Entrepreneurial wealth shock'}; %finfric only
  
    
myIRFShockList={'epsilon_eps'; 'Upsilon_eps';'zetac_eps';... % 'epsR_eps';
'zetah_eps';'g_eps';'taud_eps';'taumx_eps';'taumc_eps';'taumi_eps';...
'taux_eps';'phitilde_eps';'muz_eps';'Rstar_eps';'pistar_eps';'ystar_eps';...
'gamma_eps'}; 

myIRFVarList = {'Nom. interest rate (ABP)';'CPI inflation (ABP)';'GDP (% dev.)';...
    'Consumption (% dev.)';'Investment (% dev.)';'Net exports/Y (Lev. dev.)';...
    'Total hours (% dev.)';'Real wage (% dev.)';...
    'Real exch. rate (% dev.)';'Net worth (% dev.)';'Spread (ABP)';'Net foreign assets/GDP (Lev.dev.)'};

for myJ=1:length(myIRFShockList)
if  ~strcmp(myIRFShockList{myJ},'gamma_eps')   
baselineIRFMatrix=[... 
eval(['oo_.irfs.data_RU_' myIRFShockList{myJ}]);...
eval(['oo_.irfs.data_picU_' myIRFShockList{myJ}]);...
eval(['oo_.irfs.data_ydiffU_' myIRFShockList{myJ}]);...
eval(['oo_.irfs.data_cdiffU_' myIRFShockList{myJ}]);...
eval(['oo_.irfs.data_idiffU_' myIRFShockList{myJ}]);...
eval(['oo_.irfs.nxdivGDPU_' myIRFShockList{myJ}]);...
eval(['oo_.irfs.data_HdiffU_' myIRFShockList{myJ}]);...
eval(['oo_.irfs.data_wdiffU_' myIRFShockList{myJ}]);...
eval(['oo_.irfs.data_qdiffU_' myIRFShockList{myJ}]);...
nan(2,length(oo_.irfs.data_RU_epsilon_eps));...
eval(['oo_.irfs.etaaU_' myIRFShockList{myJ}]);...
];
else
  baselineIRFMatrix=[...
  nan(size(myIRFVarList,1),length(oo_.irfs.data_RU_epsilon_eps));    
  ];    
end

finfricIRFMatrix=[...
eval(['finfric_oo_.irfs.data_RU_' myIRFShockList{myJ}]);...
eval(['finfric_oo_.irfs.data_picU_' myIRFShockList{myJ}]);...    
eval(['finfric_oo_.irfs.data_ydiffU_' myIRFShockList{myJ}]);...    
eval(['finfric_oo_.irfs.data_cdiffU_' myIRFShockList{myJ}]);...    
eval(['finfric_oo_.irfs.data_idiffU_' myIRFShockList{myJ}]);...    
eval(['finfric_oo_.irfs.nxdivGDPU_' myIRFShockList{myJ}]);...    
eval(['finfric_oo_.irfs.data_HdiffU_' myIRFShockList{myJ}]);...    
eval(['finfric_oo_.irfs.data_wdiffU_' myIRFShockList{myJ}]);...    
eval(['finfric_oo_.irfs.data_qdiffU_' myIRFShockList{myJ}]);...    
eval(['finfric_oo_.irfs.data_ndiffU_' myIRFShockList{myJ}]);...    
eval(['finfric_oo_.irfs.data_spreadU_' myIRFShockList{myJ}]);... 
eval(['finfric_oo_.irfs.etaaU_' myIRFShockList{myJ}]);...
];

ForeignRstar=[...
eval(['finfric_oo_.irfs.data_RstarU_' myIRFShockList{myJ}]);...
nan(11,length(finfric_oo_.irfs.data_RU_epsilon_eps));... 
];


for myI=1:size(baselineIRFMatrix,1)
    subaxis(5,3,myI, 'SpacingHoriz', 0.05,'SpacingVert',.08, 'MarginTop',0.14); % .08
    %fileExchange , 'Padding', 0, 'Margin', 0
    plot(baselineIRFMatrix(myI,:),'--k','LineWidth',2)
    hold on
    plot(finfricIRFMatrix(myI,:),'k','LineWidth',2)
    plot(ForeignRstar(myI,:),'-.red','LineWidth',2)
   % plot(zeros(length(baselineIRFMatrix(myI,:)),1),'k:')
    hold off
    axis([-Inf length(baselineIRFMatrix(myI,:)) -Inf +Inf])
    %title(myShocks{myj})
    %set(gca,'XTick',myShockLength-3-nticks*32+(1:nticks)*32)
    %set(gca,'XTick',[4 20 36 52 68])
    %set(gca,'XTickLabel',['1996';'2000';'2004';'2008';'2012'])
    %set(gca,'FontSize',18) 
    title(myIRFVarList{myI},'FontSize', 13)
   
end
% [legh,objh,outh,outm]  = legend(gca,'baseline model','financial frictions model','foreign'); %'show' 'zero line',
% set(legh,'Position',[.65 0.07 .25 .2],'Fontsize',13);
[legh,objh,outh,outm]  = legend(gca,'baseline model','financial frictions model','foreign','orientation','horizontal'); %'show' 'zero line',
set(legh,'Position',[.5 .21 .01 .01],'Fontsize',13);
%gb2014: for multirow,multicolumn legend google matlab columnlegend or gridLegend
set(objh,'linewidth',3);
% box off
set(legh,'box','off','Xcolor',[1 1 1],'Ycolor',[1 1 1]);
% set in suplab axBuf=.06; or greater
[ax,h3]=suplabel(myIRFTitleList{myJ} ,'t'); 
   set(h3,'FontSize',16) 
   
thispath = cd; 
cd(myLatexPath)
print(1,'-depsc',['IRFFig_' myIRFShockList{myJ}])
print(1,'-dpdf',['IRFFig_' myIRFShockList{myJ}])
cd(thispath)
close(1)
end







% stationary neutral technology shock: epsilon_eps
% marginal efficiency of investment shock: Upsilon_eps
% consumption preference shock: zetac_eps
% labor preference shock: zetah_eps
% government consumption shock: g_eps
% domestic markup shock: taud_eps
% import export markup shock: taumx_eps
% import consumption markup shock: taumc_eps
% import investment markup shock: taumi_eps
% export markup shock: taux_eps
% country risk premium shock: phitilde_eps
% unit-root technology shock: muz_eps
% foreign nominal interest rate shock: Rstar_eps
% foreign inflation shock: pistar_eps
% foreign output shock: ystar_eps


% finfric model
% entrepreneur wealth shock: gamma_eps


%nominal interest rate
% lRU
% observable: annualized, %, no meas.errors
%data_RU

% CPI inflation
%lpicU
%observable: annualized, %, with meas. errors
%data_picU

% GDP 
% lylessdU
%observable, demeaned, qoq, %, with meas. errors
%data_ydiffU

%consumption
% lcU
%observable, demeaned, qoq, %, with meas.err.
% data_cdiffU

%investment
% liU 
%observable, demeaned, qoq, %, with meas. err.
% data_idiffU

% net exports/Y: (value of exports - value of imports)/Y
%nxdivGDPU

%total hours 
% lsmallhU
%observable: demeaned, qoq, %, with meas. err.
%data_HdiffU


% real Nash wage
% lwbarU
%observable: demeaned, qoq, %, with meas. err.
% data_wdiffU

% nominal exchange rate: 
% exp(lsU)
% I replace with real exchange rate
% lqU
% observable, qoq, %, with meas. err.
% data_qdiffU

%%% in finfric model
    % net worth
    % lnU
    % observable, demeaned, qoq, %, with meas. err.
    % data_ndiffU

    % spread
    % lspreadU or, specifically, 400*exp(lspreadU)
    % observable, qoq, %, with meas. err.
    % data_spreaddiffU or data_spreadU
    
%%% in employment model
    % unemployment rate
    % level dev: exp(lUnemprateU)
    % qoq growth: data_unempdiffU

    % hours per employee
    % look in the employment model 

    % shadow wage, marginal product of labor
    % look in the employment model    
    



%%%%%%%%%%%% baseline %%%%%%%%%%%%%%%%%%%
% mean conditional variance decomposition .i.e. taking parameter
% uncertainty
meanCvdMatrix=oo_.PosteriorTheoreticalMoments.dsge.ConditionalVarianceDecomposition.Mean;
%confidence interval
lowerCvdMatrix=oo_.PosteriorTheoreticalMoments.dsge.ConditionalVarianceDecomposition.HPDinf;
upperCvdMatrix=oo_.PosteriorTheoreticalMoments.dsge.ConditionalVarianceDecomposition.HPDsup;

clear meanCvdSelected
for myi=1:4
meanCvdSelected(myi,:,:)=[...
    meanCvdMatrix.data_RU.epsilon_eps(myi),...
    meanCvdMatrix.data_picU.epsilon_eps(myi),...
    meanCvdMatrix.data_ydiffU.epsilon_eps(myi),...
    meanCvdMatrix.data_cdiffU.epsilon_eps(myi),...
    meanCvdMatrix.data_idiffU.epsilon_eps(myi),...
    meanCvdMatrix.nxdivGDPU.epsilon_eps(myi),...
    meanCvdMatrix.data_HdiffU.epsilon_eps(myi),...
    meanCvdMatrix.data_wdiffU.epsilon_eps(myi),...
    meanCvdMatrix.data_qdiffU.epsilon_eps(myi);...
      meanCvdMatrix.data_RU.Upsilon_eps(myi),...
    meanCvdMatrix.data_picU.Upsilon_eps(myi),...
    meanCvdMatrix.data_ydiffU.Upsilon_eps(myi),...
    meanCvdMatrix.data_cdiffU.Upsilon_eps(myi),...
    meanCvdMatrix.data_idiffU.Upsilon_eps(myi),...
    meanCvdMatrix.nxdivGDPU.Upsilon_eps(myi),...
    meanCvdMatrix.data_HdiffU.Upsilon_eps(myi),...
    meanCvdMatrix.data_wdiffU.Upsilon_eps(myi),...
    meanCvdMatrix.data_qdiffU.Upsilon_eps(myi);...
  meanCvdMatrix.data_RU.zetac_eps(myi),...
    meanCvdMatrix.data_picU.zetac_eps(myi),...
    meanCvdMatrix.data_ydiffU.zetac_eps(myi),...
    meanCvdMatrix.data_cdiffU.zetac_eps(myi),...
    meanCvdMatrix.data_idiffU.zetac_eps(myi),...
    meanCvdMatrix.nxdivGDPU.zetac_eps(myi),...
    meanCvdMatrix.data_HdiffU.zetac_eps(myi),...
    meanCvdMatrix.data_wdiffU.zetac_eps(myi),...
    meanCvdMatrix.data_qdiffU.zetac_eps(myi);...
      meanCvdMatrix.data_RU.zetah_eps(myi),...
    meanCvdMatrix.data_picU.zetah_eps(myi),...
    meanCvdMatrix.data_ydiffU.zetah_eps(myi),...
    meanCvdMatrix.data_cdiffU.zetah_eps(myi),...
    meanCvdMatrix.data_idiffU.zetah_eps(myi),...
    meanCvdMatrix.nxdivGDPU.zetah_eps(myi),...
    meanCvdMatrix.data_HdiffU.zetah_eps(myi),...
    meanCvdMatrix.data_wdiffU.zetah_eps(myi),...
    meanCvdMatrix.data_qdiffU.zetah_eps(myi);...
...%       meanCvdMatrix.data_RU.epsR_eps(myi),...
...%     meanCvdMatrix.data_picU.epsR_eps(myi),...
...%     meanCvdMatrix.data_ydiffU.epsR_eps(myi),...
...%     meanCvdMatrix.data_cdiffU.epsR_eps(myi),...
...%     meanCvdMatrix.data_idiffU.epsR_eps(myi),...
...%     meanCvdMatrix.nxdivGDPU.epsR_eps(myi),...
...%     meanCvdMatrix.data_HdiffU.epsR_eps(myi),...
...%     meanCvdMatrix.data_wdiffU.epsR_eps(myi),...
...%     meanCvdMatrix.data_qdiffU.epsR_eps(myi);...
    meanCvdMatrix.data_RU.taud_eps(myi),...
    meanCvdMatrix.data_picU.taud_eps(myi),...
    meanCvdMatrix.data_ydiffU.taud_eps(myi),...
    meanCvdMatrix.data_cdiffU.taud_eps(myi),...
    meanCvdMatrix.data_idiffU.taud_eps(myi),...
    meanCvdMatrix.nxdivGDPU.taud_eps(myi),...
    meanCvdMatrix.data_HdiffU.taud_eps(myi),...
    meanCvdMatrix.data_wdiffU.taud_eps(myi),...
    meanCvdMatrix.data_qdiffU.taud_eps(myi);...
        meanCvdMatrix.data_RU.taux_eps(myi),...
    meanCvdMatrix.data_picU.taux_eps(myi),...
    meanCvdMatrix.data_ydiffU.taux_eps(myi),...
    meanCvdMatrix.data_cdiffU.taux_eps(myi),...
    meanCvdMatrix.data_idiffU.taux_eps(myi),...
    meanCvdMatrix.nxdivGDPU.taux_eps(myi),...
    meanCvdMatrix.data_HdiffU.taux_eps(myi),...
    meanCvdMatrix.data_wdiffU.taux_eps(myi),...
    meanCvdMatrix.data_qdiffU.taux_eps(myi);...
      meanCvdMatrix.data_RU.taumc_eps(myi),...
    meanCvdMatrix.data_picU.taumc_eps(myi),...
    meanCvdMatrix.data_ydiffU.taumc_eps(myi),...
    meanCvdMatrix.data_cdiffU.taumc_eps(myi),...
    meanCvdMatrix.data_idiffU.taumc_eps(myi),...
    meanCvdMatrix.nxdivGDPU.taumc_eps(myi),...
    meanCvdMatrix.data_HdiffU.taumc_eps(myi),...
    meanCvdMatrix.data_wdiffU.taumc_eps(myi),...
    meanCvdMatrix.data_qdiffU.taumc_eps(myi);...
      meanCvdMatrix.data_RU.taumi_eps(myi),...
    meanCvdMatrix.data_picU.taumi_eps(myi),...
    meanCvdMatrix.data_ydiffU.taumi_eps(myi),...
    meanCvdMatrix.data_cdiffU.taumi_eps(myi),...
    meanCvdMatrix.data_idiffU.taumi_eps(myi),...
    meanCvdMatrix.nxdivGDPU.taumi_eps(myi),...
    meanCvdMatrix.data_HdiffU.taumi_eps(myi),...
    meanCvdMatrix.data_wdiffU.taumi_eps(myi),...
    meanCvdMatrix.data_qdiffU.taumi_eps(myi);...
      meanCvdMatrix.data_RU.taumx_eps(myi),...
    meanCvdMatrix.data_picU.taumx_eps(myi),...
    meanCvdMatrix.data_ydiffU.taumx_eps(myi),...
    meanCvdMatrix.data_cdiffU.taumx_eps(myi),...
    meanCvdMatrix.data_idiffU.taumx_eps(myi),...
    meanCvdMatrix.nxdivGDPU.taumx_eps(myi),...
    meanCvdMatrix.data_HdiffU.taumx_eps(myi),...
    meanCvdMatrix.data_wdiffU.taumx_eps(myi),...
    meanCvdMatrix.data_qdiffU.taumx_eps(myi);...
    meanCvdMatrix.data_RU.phitilde_eps(myi),...
    meanCvdMatrix.data_picU.phitilde_eps(myi),...
    meanCvdMatrix.data_ydiffU.phitilde_eps(myi),...
    meanCvdMatrix.data_cdiffU.phitilde_eps(myi),...
    meanCvdMatrix.data_idiffU.phitilde_eps(myi),...
    meanCvdMatrix.nxdivGDPU.phitilde_eps(myi),...
    meanCvdMatrix.data_HdiffU.phitilde_eps(myi),...
    meanCvdMatrix.data_wdiffU.phitilde_eps(myi),...
    meanCvdMatrix.data_qdiffU.phitilde_eps(myi);...      
    meanCvdMatrix.data_RU.muz_eps(myi),...
    meanCvdMatrix.data_picU.muz_eps(myi),...
    meanCvdMatrix.data_ydiffU.muz_eps(myi),...
    meanCvdMatrix.data_cdiffU.muz_eps(myi),...
    meanCvdMatrix.data_idiffU.muz_eps(myi),...
    meanCvdMatrix.nxdivGDPU.muz_eps(myi),...
    meanCvdMatrix.data_HdiffU.muz_eps(myi),...
    meanCvdMatrix.data_wdiffU.muz_eps(myi),...
    meanCvdMatrix.data_qdiffU.muz_eps(myi);...    
     meanCvdMatrix.data_RU.Rstar_eps(myi),...
     meanCvdMatrix.data_picU.Rstar_eps(myi),...
     meanCvdMatrix.data_ydiffU.Rstar_eps(myi),...
     meanCvdMatrix.data_cdiffU.Rstar_eps(myi),...
     meanCvdMatrix.data_idiffU.Rstar_eps(myi),...
     meanCvdMatrix.nxdivGDPU.Rstar_eps(myi),...
     meanCvdMatrix.data_HdiffU.Rstar_eps(myi),...
     meanCvdMatrix.data_wdiffU.Rstar_eps(myi),...
     meanCvdMatrix.data_qdiffU.Rstar_eps(myi);...
     meanCvdMatrix.data_RU.ystar_eps(myi),...
     meanCvdMatrix.data_picU.ystar_eps(myi),...
     meanCvdMatrix.data_ydiffU.ystar_eps(myi),...
     meanCvdMatrix.data_cdiffU.ystar_eps(myi),...
     meanCvdMatrix.data_idiffU.ystar_eps(myi),...
     meanCvdMatrix.nxdivGDPU.ystar_eps(myi),...
     meanCvdMatrix.data_HdiffU.ystar_eps(myi),...
     meanCvdMatrix.data_wdiffU.ystar_eps(myi),...
     meanCvdMatrix.data_qdiffU.ystar_eps(myi);...
     meanCvdMatrix.data_RU.pistar_eps(myi),...
     meanCvdMatrix.data_picU.pistar_eps(myi),...
     meanCvdMatrix.data_ydiffU.pistar_eps(myi),...
     meanCvdMatrix.data_cdiffU.pistar_eps(myi),...
     meanCvdMatrix.data_idiffU.pistar_eps(myi),...
     meanCvdMatrix.nxdivGDPU.pistar_eps(myi),...
     meanCvdMatrix.data_HdiffU.pistar_eps(myi),...
     meanCvdMatrix.data_wdiffU.pistar_eps(myi),...
     meanCvdMatrix.data_qdiffU.pistar_eps(myi);...
%%%%%%%%%  5 foreign %%%%%%%%%%%%%%%%%%%
    sum([meanCvdMatrix.data_RU.muz_eps(myi),meanCvdMatrix.data_RU.phitilde_eps(myi),meanCvdMatrix.data_RU.Rstar_eps(myi),meanCvdMatrix.data_RU.pistar_eps(myi),meanCvdMatrix.data_RU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_picU.muz_eps(myi),meanCvdMatrix.data_picU.phitilde_eps(myi),meanCvdMatrix.data_picU.Rstar_eps(myi),meanCvdMatrix.data_picU.pistar_eps(myi),meanCvdMatrix.data_picU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_ydiffU.muz_eps(myi),meanCvdMatrix.data_ydiffU.phitilde_eps(myi),meanCvdMatrix.data_ydiffU.Rstar_eps(myi),meanCvdMatrix.data_ydiffU.pistar_eps(myi),meanCvdMatrix.data_ydiffU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_cdiffU.muz_eps(myi),meanCvdMatrix.data_cdiffU.phitilde_eps(myi),meanCvdMatrix.data_cdiffU.Rstar_eps(myi),meanCvdMatrix.data_cdiffU.pistar_eps(myi),meanCvdMatrix.data_cdiffU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_idiffU.muz_eps(myi),meanCvdMatrix.data_idiffU.phitilde_eps(myi),meanCvdMatrix.data_idiffU.Rstar_eps(myi),meanCvdMatrix.data_idiffU.pistar_eps(myi),meanCvdMatrix.data_idiffU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.nxdivGDPU.muz_eps(myi),meanCvdMatrix.nxdivGDPU.phitilde_eps(myi),meanCvdMatrix.nxdivGDPU.Rstar_eps(myi),meanCvdMatrix.nxdivGDPU.pistar_eps(myi),meanCvdMatrix.nxdivGDPU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_HdiffU.muz_eps(myi),meanCvdMatrix.data_HdiffU.phitilde_eps(myi),meanCvdMatrix.data_HdiffU.Rstar_eps(myi),meanCvdMatrix.data_HdiffU.pistar_eps(myi),meanCvdMatrix.data_HdiffU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_wdiffU.muz_eps(myi),meanCvdMatrix.data_wdiffU.phitilde_eps(myi),meanCvdMatrix.data_wdiffU.Rstar_eps(myi),meanCvdMatrix.data_wdiffU.pistar_eps(myi),meanCvdMatrix.data_wdiffU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_qdiffU.muz_eps(myi),meanCvdMatrix.data_qdiffU.phitilde_eps(myi),meanCvdMatrix.data_qdiffU.Rstar_eps(myi),meanCvdMatrix.data_qdiffU.pistar_eps(myi),meanCvdMatrix.data_qdiffU.ystar_eps(myi)]);...
%%%%%%%%%  all foreign %%%%%%%%%%%%%%%%%%%
    sum([meanCvdMatrix.data_RU.muz_eps(myi),meanCvdMatrix.data_RU.phitilde_eps(myi),meanCvdMatrix.data_RU.Rstar_eps(myi),meanCvdMatrix.data_RU.pistar_eps(myi),meanCvdMatrix.data_RU.ystar_eps(myi),meanCvdMatrix.data_RU.taumc_eps(myi),meanCvdMatrix.data_RU.taumi_eps(myi),meanCvdMatrix.data_RU.taumx_eps(myi),meanCvdMatrix.data_RU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_picU.muz_eps(myi),meanCvdMatrix.data_picU.phitilde_eps(myi),meanCvdMatrix.data_picU.Rstar_eps(myi),meanCvdMatrix.data_picU.pistar_eps(myi),meanCvdMatrix.data_picU.ystar_eps(myi),meanCvdMatrix.data_picU.taumc_eps(myi),meanCvdMatrix.data_picU.taumi_eps(myi),meanCvdMatrix.data_picU.taumx_eps(myi),meanCvdMatrix.data_picU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_ydiffU.muz_eps(myi),meanCvdMatrix.data_ydiffU.phitilde_eps(myi),meanCvdMatrix.data_ydiffU.Rstar_eps(myi),meanCvdMatrix.data_ydiffU.pistar_eps(myi),meanCvdMatrix.data_ydiffU.ystar_eps(myi),meanCvdMatrix.data_ydiffU.taumc_eps(myi),meanCvdMatrix.data_ydiffU.taumi_eps(myi),meanCvdMatrix.data_ydiffU.taumx_eps(myi),meanCvdMatrix.data_ydiffU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_cdiffU.muz_eps(myi),meanCvdMatrix.data_cdiffU.phitilde_eps(myi),meanCvdMatrix.data_cdiffU.Rstar_eps(myi),meanCvdMatrix.data_cdiffU.pistar_eps(myi),meanCvdMatrix.data_cdiffU.ystar_eps(myi),meanCvdMatrix.data_cdiffU.taumc_eps(myi),meanCvdMatrix.data_cdiffU.taumi_eps(myi),meanCvdMatrix.data_cdiffU.taumx_eps(myi),meanCvdMatrix.data_cdiffU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_idiffU.muz_eps(myi),meanCvdMatrix.data_idiffU.phitilde_eps(myi),meanCvdMatrix.data_idiffU.Rstar_eps(myi),meanCvdMatrix.data_idiffU.pistar_eps(myi),meanCvdMatrix.data_idiffU.ystar_eps(myi),meanCvdMatrix.data_idiffU.taumc_eps(myi),meanCvdMatrix.data_idiffU.taumi_eps(myi),meanCvdMatrix.data_idiffU.taumx_eps(myi),meanCvdMatrix.data_idiffU.taux_eps(myi)]),...
    sum([meanCvdMatrix.nxdivGDPU.muz_eps(myi),meanCvdMatrix.nxdivGDPU.phitilde_eps(myi),meanCvdMatrix.nxdivGDPU.Rstar_eps(myi),meanCvdMatrix.nxdivGDPU.pistar_eps(myi),meanCvdMatrix.nxdivGDPU.ystar_eps(myi),meanCvdMatrix.nxdivGDPU.taumc_eps(myi),meanCvdMatrix.nxdivGDPU.taumi_eps(myi),meanCvdMatrix.nxdivGDPU.taumx_eps(myi),meanCvdMatrix.nxdivGDPU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_HdiffU.muz_eps(myi),meanCvdMatrix.data_HdiffU.phitilde_eps(myi),meanCvdMatrix.data_HdiffU.Rstar_eps(myi),meanCvdMatrix.data_HdiffU.pistar_eps(myi),meanCvdMatrix.data_HdiffU.ystar_eps(myi),meanCvdMatrix.data_HdiffU.taumc_eps(myi),meanCvdMatrix.data_HdiffU.taumi_eps(myi),meanCvdMatrix.data_HdiffU.taumx_eps(myi),meanCvdMatrix.data_HdiffU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_wdiffU.muz_eps(myi),meanCvdMatrix.data_wdiffU.phitilde_eps(myi),meanCvdMatrix.data_wdiffU.Rstar_eps(myi),meanCvdMatrix.data_wdiffU.pistar_eps(myi),meanCvdMatrix.data_wdiffU.ystar_eps(myi),meanCvdMatrix.data_wdiffU.taumc_eps(myi),meanCvdMatrix.data_wdiffU.taumi_eps(myi),meanCvdMatrix.data_wdiffU.taumx_eps(myi),meanCvdMatrix.data_wdiffU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_qdiffU.muz_eps(myi),meanCvdMatrix.data_qdiffU.phitilde_eps(myi),meanCvdMatrix.data_qdiffU.Rstar_eps(myi),meanCvdMatrix.data_qdiffU.pistar_eps(myi),meanCvdMatrix.data_qdiffU.ystar_eps(myi),meanCvdMatrix.data_qdiffU.taumc_eps(myi),meanCvdMatrix.data_qdiffU.taumi_eps(myi),meanCvdMatrix.data_qdiffU.taumx_eps(myi),meanCvdMatrix.data_qdiffU.taux_eps(myi)]);...
    ];
end 

clear lowerCvdSelected
for myi=1:4
lowerCvdSelected(myi,:,:)=[...
    lowerCvdMatrix.data_RU.epsilon_eps(myi),...
    lowerCvdMatrix.data_picU.epsilon_eps(myi),...
    lowerCvdMatrix.data_ydiffU.epsilon_eps(myi),...
    lowerCvdMatrix.data_cdiffU.epsilon_eps(myi),...
    lowerCvdMatrix.data_idiffU.epsilon_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.epsilon_eps(myi),...
    lowerCvdMatrix.data_HdiffU.epsilon_eps(myi),...
    lowerCvdMatrix.data_wdiffU.epsilon_eps(myi),...
    lowerCvdMatrix.data_qdiffU.epsilon_eps(myi);...
      lowerCvdMatrix.data_RU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_picU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_ydiffU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_cdiffU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_idiffU.Upsilon_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_HdiffU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_wdiffU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_qdiffU.Upsilon_eps(myi);...
  lowerCvdMatrix.data_RU.zetac_eps(myi),...
    lowerCvdMatrix.data_picU.zetac_eps(myi),...
    lowerCvdMatrix.data_ydiffU.zetac_eps(myi),...
    lowerCvdMatrix.data_cdiffU.zetac_eps(myi),...
    lowerCvdMatrix.data_idiffU.zetac_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.zetac_eps(myi),...
    lowerCvdMatrix.data_HdiffU.zetac_eps(myi),...
    lowerCvdMatrix.data_wdiffU.zetac_eps(myi),...
    lowerCvdMatrix.data_qdiffU.zetac_eps(myi);...
      lowerCvdMatrix.data_RU.zetah_eps(myi),...
    lowerCvdMatrix.data_picU.zetah_eps(myi),...
    lowerCvdMatrix.data_ydiffU.zetah_eps(myi),...
    lowerCvdMatrix.data_cdiffU.zetah_eps(myi),...
    lowerCvdMatrix.data_idiffU.zetah_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.zetah_eps(myi),...
    lowerCvdMatrix.data_HdiffU.zetah_eps(myi),...
    lowerCvdMatrix.data_wdiffU.zetah_eps(myi),...
    lowerCvdMatrix.data_qdiffU.zetah_eps(myi);...
...%       lowerCvdMatrix.data_RU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_picU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_ydiffU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_cdiffU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_idiffU.epsR_eps(myi),...
...%     lowerCvdMatrix.nxdivGDPU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_HdiffU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_wdiffU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_qdiffU.epsR_eps(myi);...
    lowerCvdMatrix.data_RU.taud_eps(myi),...
    lowerCvdMatrix.data_picU.taud_eps(myi),...
    lowerCvdMatrix.data_ydiffU.taud_eps(myi),...
    lowerCvdMatrix.data_cdiffU.taud_eps(myi),...
    lowerCvdMatrix.data_idiffU.taud_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.taud_eps(myi),...
    lowerCvdMatrix.data_HdiffU.taud_eps(myi),...
    lowerCvdMatrix.data_wdiffU.taud_eps(myi),...
    lowerCvdMatrix.data_qdiffU.taud_eps(myi);...
        lowerCvdMatrix.data_RU.taux_eps(myi),...
    lowerCvdMatrix.data_picU.taux_eps(myi),...
    lowerCvdMatrix.data_ydiffU.taux_eps(myi),...
    lowerCvdMatrix.data_cdiffU.taux_eps(myi),...
    lowerCvdMatrix.data_idiffU.taux_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.taux_eps(myi),...
    lowerCvdMatrix.data_HdiffU.taux_eps(myi),...
    lowerCvdMatrix.data_wdiffU.taux_eps(myi),...
    lowerCvdMatrix.data_qdiffU.taux_eps(myi);...
      lowerCvdMatrix.data_RU.taumc_eps(myi),...
    lowerCvdMatrix.data_picU.taumc_eps(myi),...
    lowerCvdMatrix.data_ydiffU.taumc_eps(myi),...
    lowerCvdMatrix.data_cdiffU.taumc_eps(myi),...
    lowerCvdMatrix.data_idiffU.taumc_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.taumc_eps(myi),...
    lowerCvdMatrix.data_HdiffU.taumc_eps(myi),...
    lowerCvdMatrix.data_wdiffU.taumc_eps(myi),...
    lowerCvdMatrix.data_qdiffU.taumc_eps(myi);...
      lowerCvdMatrix.data_RU.taumi_eps(myi),...
    lowerCvdMatrix.data_picU.taumi_eps(myi),...
    lowerCvdMatrix.data_ydiffU.taumi_eps(myi),...
    lowerCvdMatrix.data_cdiffU.taumi_eps(myi),...
    lowerCvdMatrix.data_idiffU.taumi_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.taumi_eps(myi),...
    lowerCvdMatrix.data_HdiffU.taumi_eps(myi),...
    lowerCvdMatrix.data_wdiffU.taumi_eps(myi),...
    lowerCvdMatrix.data_qdiffU.taumi_eps(myi);...
      lowerCvdMatrix.data_RU.taumx_eps(myi),...
    lowerCvdMatrix.data_picU.taumx_eps(myi),...
    lowerCvdMatrix.data_ydiffU.taumx_eps(myi),...
    lowerCvdMatrix.data_cdiffU.taumx_eps(myi),...
    lowerCvdMatrix.data_idiffU.taumx_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.taumx_eps(myi),...
    lowerCvdMatrix.data_HdiffU.taumx_eps(myi),...
    lowerCvdMatrix.data_wdiffU.taumx_eps(myi),...
    lowerCvdMatrix.data_qdiffU.taumx_eps(myi);...
    lowerCvdMatrix.data_RU.phitilde_eps(myi),...
    lowerCvdMatrix.data_picU.phitilde_eps(myi),...
    lowerCvdMatrix.data_ydiffU.phitilde_eps(myi),...
    lowerCvdMatrix.data_cdiffU.phitilde_eps(myi),...
    lowerCvdMatrix.data_idiffU.phitilde_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.phitilde_eps(myi),...
    lowerCvdMatrix.data_HdiffU.phitilde_eps(myi),...
    lowerCvdMatrix.data_wdiffU.phitilde_eps(myi),...
    lowerCvdMatrix.data_qdiffU.phitilde_eps(myi);...      
    lowerCvdMatrix.data_RU.muz_eps(myi),...
    lowerCvdMatrix.data_picU.muz_eps(myi),...
    lowerCvdMatrix.data_ydiffU.muz_eps(myi),...
    lowerCvdMatrix.data_cdiffU.muz_eps(myi),...
    lowerCvdMatrix.data_idiffU.muz_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.muz_eps(myi),...
    lowerCvdMatrix.data_HdiffU.muz_eps(myi),...
    lowerCvdMatrix.data_wdiffU.muz_eps(myi),...
    lowerCvdMatrix.data_qdiffU.muz_eps(myi);...    
     lowerCvdMatrix.data_RU.Rstar_eps(myi),...
     lowerCvdMatrix.data_picU.Rstar_eps(myi),...
     lowerCvdMatrix.data_ydiffU.Rstar_eps(myi),...
     lowerCvdMatrix.data_cdiffU.Rstar_eps(myi),...
     lowerCvdMatrix.data_idiffU.Rstar_eps(myi),...
     lowerCvdMatrix.nxdivGDPU.Rstar_eps(myi),...
     lowerCvdMatrix.data_HdiffU.Rstar_eps(myi),...
     lowerCvdMatrix.data_wdiffU.Rstar_eps(myi),...
     lowerCvdMatrix.data_qdiffU.Rstar_eps(myi);...
     lowerCvdMatrix.data_RU.ystar_eps(myi),...
     lowerCvdMatrix.data_picU.ystar_eps(myi),...
     lowerCvdMatrix.data_ydiffU.ystar_eps(myi),...
     lowerCvdMatrix.data_cdiffU.ystar_eps(myi),...
     lowerCvdMatrix.data_idiffU.ystar_eps(myi),...
     lowerCvdMatrix.nxdivGDPU.ystar_eps(myi),...
     lowerCvdMatrix.data_HdiffU.ystar_eps(myi),...
     lowerCvdMatrix.data_wdiffU.ystar_eps(myi),...
     lowerCvdMatrix.data_qdiffU.ystar_eps(myi);...
     lowerCvdMatrix.data_RU.pistar_eps(myi),...
     lowerCvdMatrix.data_picU.pistar_eps(myi),...
     lowerCvdMatrix.data_ydiffU.pistar_eps(myi),...
     lowerCvdMatrix.data_cdiffU.pistar_eps(myi),...
     lowerCvdMatrix.data_idiffU.pistar_eps(myi),...
     lowerCvdMatrix.nxdivGDPU.pistar_eps(myi),...
     lowerCvdMatrix.data_HdiffU.pistar_eps(myi),...
     lowerCvdMatrix.data_wdiffU.pistar_eps(myi),...
     lowerCvdMatrix.data_qdiffU.pistar_eps(myi);...
%%%%%%%%%  5 foreign %%%%%%%%%%%%%%%%%%%
    sum([lowerCvdMatrix.data_RU.muz_eps(myi),lowerCvdMatrix.data_RU.phitilde_eps(myi),lowerCvdMatrix.data_RU.Rstar_eps(myi),lowerCvdMatrix.data_RU.pistar_eps(myi),lowerCvdMatrix.data_RU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_picU.muz_eps(myi),lowerCvdMatrix.data_picU.phitilde_eps(myi),lowerCvdMatrix.data_picU.Rstar_eps(myi),lowerCvdMatrix.data_picU.pistar_eps(myi),lowerCvdMatrix.data_picU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_ydiffU.muz_eps(myi),lowerCvdMatrix.data_ydiffU.phitilde_eps(myi),lowerCvdMatrix.data_ydiffU.Rstar_eps(myi),lowerCvdMatrix.data_ydiffU.pistar_eps(myi),lowerCvdMatrix.data_ydiffU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_cdiffU.muz_eps(myi),lowerCvdMatrix.data_cdiffU.phitilde_eps(myi),lowerCvdMatrix.data_cdiffU.Rstar_eps(myi),lowerCvdMatrix.data_cdiffU.pistar_eps(myi),lowerCvdMatrix.data_cdiffU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_idiffU.muz_eps(myi),lowerCvdMatrix.data_idiffU.phitilde_eps(myi),lowerCvdMatrix.data_idiffU.Rstar_eps(myi),lowerCvdMatrix.data_idiffU.pistar_eps(myi),lowerCvdMatrix.data_idiffU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.nxdivGDPU.muz_eps(myi),lowerCvdMatrix.nxdivGDPU.phitilde_eps(myi),lowerCvdMatrix.nxdivGDPU.Rstar_eps(myi),lowerCvdMatrix.nxdivGDPU.pistar_eps(myi),lowerCvdMatrix.nxdivGDPU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_HdiffU.muz_eps(myi),lowerCvdMatrix.data_HdiffU.phitilde_eps(myi),lowerCvdMatrix.data_HdiffU.Rstar_eps(myi),lowerCvdMatrix.data_HdiffU.pistar_eps(myi),lowerCvdMatrix.data_HdiffU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_wdiffU.muz_eps(myi),lowerCvdMatrix.data_wdiffU.phitilde_eps(myi),lowerCvdMatrix.data_wdiffU.Rstar_eps(myi),lowerCvdMatrix.data_wdiffU.pistar_eps(myi),lowerCvdMatrix.data_wdiffU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_qdiffU.muz_eps(myi),lowerCvdMatrix.data_qdiffU.phitilde_eps(myi),lowerCvdMatrix.data_qdiffU.Rstar_eps(myi),lowerCvdMatrix.data_qdiffU.pistar_eps(myi),lowerCvdMatrix.data_qdiffU.ystar_eps(myi)]);...
%%%%%%%%%  all foreign %%%%%%%%%%%%%%%%%%%
    sum([lowerCvdMatrix.data_RU.muz_eps(myi),lowerCvdMatrix.data_RU.phitilde_eps(myi),lowerCvdMatrix.data_RU.Rstar_eps(myi),lowerCvdMatrix.data_RU.pistar_eps(myi),lowerCvdMatrix.data_RU.ystar_eps(myi),lowerCvdMatrix.data_RU.taumc_eps(myi),lowerCvdMatrix.data_RU.taumi_eps(myi),lowerCvdMatrix.data_RU.taumx_eps(myi),lowerCvdMatrix.data_RU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_picU.muz_eps(myi),lowerCvdMatrix.data_picU.phitilde_eps(myi),lowerCvdMatrix.data_picU.Rstar_eps(myi),lowerCvdMatrix.data_picU.pistar_eps(myi),lowerCvdMatrix.data_picU.ystar_eps(myi),lowerCvdMatrix.data_picU.taumc_eps(myi),lowerCvdMatrix.data_picU.taumi_eps(myi),lowerCvdMatrix.data_picU.taumx_eps(myi),lowerCvdMatrix.data_picU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_ydiffU.muz_eps(myi),lowerCvdMatrix.data_ydiffU.phitilde_eps(myi),lowerCvdMatrix.data_ydiffU.Rstar_eps(myi),lowerCvdMatrix.data_ydiffU.pistar_eps(myi),lowerCvdMatrix.data_ydiffU.ystar_eps(myi),lowerCvdMatrix.data_ydiffU.taumc_eps(myi),lowerCvdMatrix.data_ydiffU.taumi_eps(myi),lowerCvdMatrix.data_ydiffU.taumx_eps(myi),lowerCvdMatrix.data_ydiffU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_cdiffU.muz_eps(myi),lowerCvdMatrix.data_cdiffU.phitilde_eps(myi),lowerCvdMatrix.data_cdiffU.Rstar_eps(myi),lowerCvdMatrix.data_cdiffU.pistar_eps(myi),lowerCvdMatrix.data_cdiffU.ystar_eps(myi),lowerCvdMatrix.data_cdiffU.taumc_eps(myi),lowerCvdMatrix.data_cdiffU.taumi_eps(myi),lowerCvdMatrix.data_cdiffU.taumx_eps(myi),lowerCvdMatrix.data_cdiffU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_idiffU.muz_eps(myi),lowerCvdMatrix.data_idiffU.phitilde_eps(myi),lowerCvdMatrix.data_idiffU.Rstar_eps(myi),lowerCvdMatrix.data_idiffU.pistar_eps(myi),lowerCvdMatrix.data_idiffU.ystar_eps(myi),lowerCvdMatrix.data_idiffU.taumc_eps(myi),lowerCvdMatrix.data_idiffU.taumi_eps(myi),lowerCvdMatrix.data_idiffU.taumx_eps(myi),lowerCvdMatrix.data_idiffU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.nxdivGDPU.muz_eps(myi),lowerCvdMatrix.nxdivGDPU.phitilde_eps(myi),lowerCvdMatrix.nxdivGDPU.Rstar_eps(myi),lowerCvdMatrix.nxdivGDPU.pistar_eps(myi),lowerCvdMatrix.nxdivGDPU.ystar_eps(myi),lowerCvdMatrix.nxdivGDPU.taumc_eps(myi),lowerCvdMatrix.nxdivGDPU.taumi_eps(myi),lowerCvdMatrix.nxdivGDPU.taumx_eps(myi),lowerCvdMatrix.nxdivGDPU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_HdiffU.muz_eps(myi),lowerCvdMatrix.data_HdiffU.phitilde_eps(myi),lowerCvdMatrix.data_HdiffU.Rstar_eps(myi),lowerCvdMatrix.data_HdiffU.pistar_eps(myi),lowerCvdMatrix.data_HdiffU.ystar_eps(myi),lowerCvdMatrix.data_HdiffU.taumc_eps(myi),lowerCvdMatrix.data_HdiffU.taumi_eps(myi),lowerCvdMatrix.data_HdiffU.taumx_eps(myi),lowerCvdMatrix.data_HdiffU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_wdiffU.muz_eps(myi),lowerCvdMatrix.data_wdiffU.phitilde_eps(myi),lowerCvdMatrix.data_wdiffU.Rstar_eps(myi),lowerCvdMatrix.data_wdiffU.pistar_eps(myi),lowerCvdMatrix.data_wdiffU.ystar_eps(myi),lowerCvdMatrix.data_wdiffU.taumc_eps(myi),lowerCvdMatrix.data_wdiffU.taumi_eps(myi),lowerCvdMatrix.data_wdiffU.taumx_eps(myi),lowerCvdMatrix.data_wdiffU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_qdiffU.muz_eps(myi),lowerCvdMatrix.data_qdiffU.phitilde_eps(myi),lowerCvdMatrix.data_qdiffU.Rstar_eps(myi),lowerCvdMatrix.data_qdiffU.pistar_eps(myi),lowerCvdMatrix.data_qdiffU.ystar_eps(myi),lowerCvdMatrix.data_qdiffU.taumc_eps(myi),lowerCvdMatrix.data_qdiffU.taumi_eps(myi),lowerCvdMatrix.data_qdiffU.taumx_eps(myi),lowerCvdMatrix.data_qdiffU.taux_eps(myi)]);...
    ];
end 

clear upperCvdSelected
for myi=1:4
upperCvdSelected(myi,:,:)=[...
    upperCvdMatrix.data_RU.epsilon_eps(myi),...
    upperCvdMatrix.data_picU.epsilon_eps(myi),...
    upperCvdMatrix.data_ydiffU.epsilon_eps(myi),...
    upperCvdMatrix.data_cdiffU.epsilon_eps(myi),...
    upperCvdMatrix.data_idiffU.epsilon_eps(myi),...
    upperCvdMatrix.nxdivGDPU.epsilon_eps(myi),...
    upperCvdMatrix.data_HdiffU.epsilon_eps(myi),...
    upperCvdMatrix.data_wdiffU.epsilon_eps(myi),...
    upperCvdMatrix.data_qdiffU.epsilon_eps(myi);...
      upperCvdMatrix.data_RU.Upsilon_eps(myi),...
    upperCvdMatrix.data_picU.Upsilon_eps(myi),...
    upperCvdMatrix.data_ydiffU.Upsilon_eps(myi),...
    upperCvdMatrix.data_cdiffU.Upsilon_eps(myi),...
    upperCvdMatrix.data_idiffU.Upsilon_eps(myi),...
    upperCvdMatrix.nxdivGDPU.Upsilon_eps(myi),...
    upperCvdMatrix.data_HdiffU.Upsilon_eps(myi),...
    upperCvdMatrix.data_wdiffU.Upsilon_eps(myi),...
    upperCvdMatrix.data_qdiffU.Upsilon_eps(myi);...
  upperCvdMatrix.data_RU.zetac_eps(myi),...
    upperCvdMatrix.data_picU.zetac_eps(myi),...
    upperCvdMatrix.data_ydiffU.zetac_eps(myi),...
    upperCvdMatrix.data_cdiffU.zetac_eps(myi),...
    upperCvdMatrix.data_idiffU.zetac_eps(myi),...
    upperCvdMatrix.nxdivGDPU.zetac_eps(myi),...
    upperCvdMatrix.data_HdiffU.zetac_eps(myi),...
    upperCvdMatrix.data_wdiffU.zetac_eps(myi),...
    upperCvdMatrix.data_qdiffU.zetac_eps(myi);...
      upperCvdMatrix.data_RU.zetah_eps(myi),...
    upperCvdMatrix.data_picU.zetah_eps(myi),...
    upperCvdMatrix.data_ydiffU.zetah_eps(myi),...
    upperCvdMatrix.data_cdiffU.zetah_eps(myi),...
    upperCvdMatrix.data_idiffU.zetah_eps(myi),...
    upperCvdMatrix.nxdivGDPU.zetah_eps(myi),...
    upperCvdMatrix.data_HdiffU.zetah_eps(myi),...
    upperCvdMatrix.data_wdiffU.zetah_eps(myi),...
    upperCvdMatrix.data_qdiffU.zetah_eps(myi);...
...%       upperCvdMatrix.data_RU.epsR_eps(myi),...
...%     upperCvdMatrix.data_picU.epsR_eps(myi),...
...%     upperCvdMatrix.data_ydiffU.epsR_eps(myi),...
...%     upperCvdMatrix.data_cdiffU.epsR_eps(myi),...
...%     upperCvdMatrix.data_idiffU.epsR_eps(myi),...
...%     upperCvdMatrix.nxdivGDPU.epsR_eps(myi),...
...%     upperCvdMatrix.data_HdiffU.epsR_eps(myi),...
...%     upperCvdMatrix.data_wdiffU.epsR_eps(myi),...
...%     upperCvdMatrix.data_qdiffU.epsR_eps(myi);...
    upperCvdMatrix.data_RU.taud_eps(myi),...
    upperCvdMatrix.data_picU.taud_eps(myi),...
    upperCvdMatrix.data_ydiffU.taud_eps(myi),...
    upperCvdMatrix.data_cdiffU.taud_eps(myi),...
    upperCvdMatrix.data_idiffU.taud_eps(myi),...
    upperCvdMatrix.nxdivGDPU.taud_eps(myi),...
    upperCvdMatrix.data_HdiffU.taud_eps(myi),...
    upperCvdMatrix.data_wdiffU.taud_eps(myi),...
    upperCvdMatrix.data_qdiffU.taud_eps(myi);...
        upperCvdMatrix.data_RU.taux_eps(myi),...
    upperCvdMatrix.data_picU.taux_eps(myi),...
    upperCvdMatrix.data_ydiffU.taux_eps(myi),...
    upperCvdMatrix.data_cdiffU.taux_eps(myi),...
    upperCvdMatrix.data_idiffU.taux_eps(myi),...
    upperCvdMatrix.nxdivGDPU.taux_eps(myi),...
    upperCvdMatrix.data_HdiffU.taux_eps(myi),...
    upperCvdMatrix.data_wdiffU.taux_eps(myi),...
    upperCvdMatrix.data_qdiffU.taux_eps(myi);...
      upperCvdMatrix.data_RU.taumc_eps(myi),...
    upperCvdMatrix.data_picU.taumc_eps(myi),...
    upperCvdMatrix.data_ydiffU.taumc_eps(myi),...
    upperCvdMatrix.data_cdiffU.taumc_eps(myi),...
    upperCvdMatrix.data_idiffU.taumc_eps(myi),...
    upperCvdMatrix.nxdivGDPU.taumc_eps(myi),...
    upperCvdMatrix.data_HdiffU.taumc_eps(myi),...
    upperCvdMatrix.data_wdiffU.taumc_eps(myi),...
    upperCvdMatrix.data_qdiffU.taumc_eps(myi);...
      upperCvdMatrix.data_RU.taumi_eps(myi),...
    upperCvdMatrix.data_picU.taumi_eps(myi),...
    upperCvdMatrix.data_ydiffU.taumi_eps(myi),...
    upperCvdMatrix.data_cdiffU.taumi_eps(myi),...
    upperCvdMatrix.data_idiffU.taumi_eps(myi),...
    upperCvdMatrix.nxdivGDPU.taumi_eps(myi),...
    upperCvdMatrix.data_HdiffU.taumi_eps(myi),...
    upperCvdMatrix.data_wdiffU.taumi_eps(myi),...
    upperCvdMatrix.data_qdiffU.taumi_eps(myi);...
      upperCvdMatrix.data_RU.taumx_eps(myi),...
    upperCvdMatrix.data_picU.taumx_eps(myi),...
    upperCvdMatrix.data_ydiffU.taumx_eps(myi),...
    upperCvdMatrix.data_cdiffU.taumx_eps(myi),...
    upperCvdMatrix.data_idiffU.taumx_eps(myi),...
    upperCvdMatrix.nxdivGDPU.taumx_eps(myi),...
    upperCvdMatrix.data_HdiffU.taumx_eps(myi),...
    upperCvdMatrix.data_wdiffU.taumx_eps(myi),...
    upperCvdMatrix.data_qdiffU.taumx_eps(myi);...
    upperCvdMatrix.data_RU.phitilde_eps(myi),...
    upperCvdMatrix.data_picU.phitilde_eps(myi),...
    upperCvdMatrix.data_ydiffU.phitilde_eps(myi),...
    upperCvdMatrix.data_cdiffU.phitilde_eps(myi),...
    upperCvdMatrix.data_idiffU.phitilde_eps(myi),...
    upperCvdMatrix.nxdivGDPU.phitilde_eps(myi),...
    upperCvdMatrix.data_HdiffU.phitilde_eps(myi),...
    upperCvdMatrix.data_wdiffU.phitilde_eps(myi),...
    upperCvdMatrix.data_qdiffU.phitilde_eps(myi);...      
    upperCvdMatrix.data_RU.muz_eps(myi),...
    upperCvdMatrix.data_picU.muz_eps(myi),...
    upperCvdMatrix.data_ydiffU.muz_eps(myi),...
    upperCvdMatrix.data_cdiffU.muz_eps(myi),...
    upperCvdMatrix.data_idiffU.muz_eps(myi),...
    upperCvdMatrix.nxdivGDPU.muz_eps(myi),...
    upperCvdMatrix.data_HdiffU.muz_eps(myi),...
    upperCvdMatrix.data_wdiffU.muz_eps(myi),...
    upperCvdMatrix.data_qdiffU.muz_eps(myi);...    
     upperCvdMatrix.data_RU.Rstar_eps(myi),...
     upperCvdMatrix.data_picU.Rstar_eps(myi),...
     upperCvdMatrix.data_ydiffU.Rstar_eps(myi),...
     upperCvdMatrix.data_cdiffU.Rstar_eps(myi),...
     upperCvdMatrix.data_idiffU.Rstar_eps(myi),...
     upperCvdMatrix.nxdivGDPU.Rstar_eps(myi),...
     upperCvdMatrix.data_HdiffU.Rstar_eps(myi),...
     upperCvdMatrix.data_wdiffU.Rstar_eps(myi),...
     upperCvdMatrix.data_qdiffU.Rstar_eps(myi);...
     upperCvdMatrix.data_RU.ystar_eps(myi),...
     upperCvdMatrix.data_picU.ystar_eps(myi),...
     upperCvdMatrix.data_ydiffU.ystar_eps(myi),...
     upperCvdMatrix.data_cdiffU.ystar_eps(myi),...
     upperCvdMatrix.data_idiffU.ystar_eps(myi),...
     upperCvdMatrix.nxdivGDPU.ystar_eps(myi),...
     upperCvdMatrix.data_HdiffU.ystar_eps(myi),...
     upperCvdMatrix.data_wdiffU.ystar_eps(myi),...
     upperCvdMatrix.data_qdiffU.ystar_eps(myi);...     
     upperCvdMatrix.data_RU.pistar_eps(myi),...
     upperCvdMatrix.data_picU.pistar_eps(myi),...
     upperCvdMatrix.data_ydiffU.pistar_eps(myi),...
     upperCvdMatrix.data_cdiffU.pistar_eps(myi),...
     upperCvdMatrix.data_idiffU.pistar_eps(myi),...
     upperCvdMatrix.nxdivGDPU.pistar_eps(myi),...
     upperCvdMatrix.data_HdiffU.pistar_eps(myi),...
     upperCvdMatrix.data_wdiffU.pistar_eps(myi),...
     upperCvdMatrix.data_qdiffU.pistar_eps(myi);...
%%%%%%%%%  5 foreign %%%%%%%%%%%%%%%%%%%
    sum([upperCvdMatrix.data_RU.muz_eps(myi),upperCvdMatrix.data_RU.phitilde_eps(myi),upperCvdMatrix.data_RU.Rstar_eps(myi),upperCvdMatrix.data_RU.pistar_eps(myi),upperCvdMatrix.data_RU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_picU.muz_eps(myi),upperCvdMatrix.data_picU.phitilde_eps(myi),upperCvdMatrix.data_picU.Rstar_eps(myi),upperCvdMatrix.data_picU.pistar_eps(myi),upperCvdMatrix.data_picU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_ydiffU.muz_eps(myi),upperCvdMatrix.data_ydiffU.phitilde_eps(myi),upperCvdMatrix.data_ydiffU.Rstar_eps(myi),upperCvdMatrix.data_ydiffU.pistar_eps(myi),upperCvdMatrix.data_ydiffU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_cdiffU.muz_eps(myi),upperCvdMatrix.data_cdiffU.phitilde_eps(myi),upperCvdMatrix.data_cdiffU.Rstar_eps(myi),upperCvdMatrix.data_cdiffU.pistar_eps(myi),upperCvdMatrix.data_cdiffU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_idiffU.muz_eps(myi),upperCvdMatrix.data_idiffU.phitilde_eps(myi),upperCvdMatrix.data_idiffU.Rstar_eps(myi),upperCvdMatrix.data_idiffU.pistar_eps(myi),upperCvdMatrix.data_idiffU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.nxdivGDPU.muz_eps(myi),upperCvdMatrix.nxdivGDPU.phitilde_eps(myi),upperCvdMatrix.nxdivGDPU.Rstar_eps(myi),upperCvdMatrix.nxdivGDPU.pistar_eps(myi),upperCvdMatrix.nxdivGDPU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_HdiffU.muz_eps(myi),upperCvdMatrix.data_HdiffU.phitilde_eps(myi),upperCvdMatrix.data_HdiffU.Rstar_eps(myi),upperCvdMatrix.data_HdiffU.pistar_eps(myi),upperCvdMatrix.data_HdiffU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_wdiffU.muz_eps(myi),upperCvdMatrix.data_wdiffU.phitilde_eps(myi),upperCvdMatrix.data_wdiffU.Rstar_eps(myi),upperCvdMatrix.data_wdiffU.pistar_eps(myi),upperCvdMatrix.data_wdiffU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_qdiffU.muz_eps(myi),upperCvdMatrix.data_qdiffU.phitilde_eps(myi),upperCvdMatrix.data_qdiffU.Rstar_eps(myi),upperCvdMatrix.data_qdiffU.pistar_eps(myi),upperCvdMatrix.data_qdiffU.ystar_eps(myi)]);...
%%%%%%%%%  all foreign %%%%%%%%%%%%%%%%%%%
    sum([upperCvdMatrix.data_RU.muz_eps(myi),upperCvdMatrix.data_RU.phitilde_eps(myi),upperCvdMatrix.data_RU.Rstar_eps(myi),upperCvdMatrix.data_RU.pistar_eps(myi),upperCvdMatrix.data_RU.ystar_eps(myi),upperCvdMatrix.data_RU.taumc_eps(myi),upperCvdMatrix.data_RU.taumi_eps(myi),upperCvdMatrix.data_RU.taumx_eps(myi),upperCvdMatrix.data_RU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_picU.muz_eps(myi),upperCvdMatrix.data_picU.phitilde_eps(myi),upperCvdMatrix.data_picU.Rstar_eps(myi),upperCvdMatrix.data_picU.pistar_eps(myi),upperCvdMatrix.data_picU.ystar_eps(myi),upperCvdMatrix.data_picU.taumc_eps(myi),upperCvdMatrix.data_picU.taumi_eps(myi),upperCvdMatrix.data_picU.taumx_eps(myi),upperCvdMatrix.data_picU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_ydiffU.muz_eps(myi),upperCvdMatrix.data_ydiffU.phitilde_eps(myi),upperCvdMatrix.data_ydiffU.Rstar_eps(myi),upperCvdMatrix.data_ydiffU.pistar_eps(myi),upperCvdMatrix.data_ydiffU.ystar_eps(myi),upperCvdMatrix.data_ydiffU.taumc_eps(myi),upperCvdMatrix.data_ydiffU.taumi_eps(myi),upperCvdMatrix.data_ydiffU.taumx_eps(myi),upperCvdMatrix.data_ydiffU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_cdiffU.muz_eps(myi),upperCvdMatrix.data_cdiffU.phitilde_eps(myi),upperCvdMatrix.data_cdiffU.Rstar_eps(myi),upperCvdMatrix.data_cdiffU.pistar_eps(myi),upperCvdMatrix.data_cdiffU.ystar_eps(myi),upperCvdMatrix.data_cdiffU.taumc_eps(myi),upperCvdMatrix.data_cdiffU.taumi_eps(myi),upperCvdMatrix.data_cdiffU.taumx_eps(myi),upperCvdMatrix.data_cdiffU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_idiffU.muz_eps(myi),upperCvdMatrix.data_idiffU.phitilde_eps(myi),upperCvdMatrix.data_idiffU.Rstar_eps(myi),upperCvdMatrix.data_idiffU.pistar_eps(myi),upperCvdMatrix.data_idiffU.ystar_eps(myi),upperCvdMatrix.data_idiffU.taumc_eps(myi),upperCvdMatrix.data_idiffU.taumi_eps(myi),upperCvdMatrix.data_idiffU.taumx_eps(myi),upperCvdMatrix.data_idiffU.taux_eps(myi)]),...
    sum([upperCvdMatrix.nxdivGDPU.muz_eps(myi),upperCvdMatrix.nxdivGDPU.phitilde_eps(myi),upperCvdMatrix.nxdivGDPU.Rstar_eps(myi),upperCvdMatrix.nxdivGDPU.pistar_eps(myi),upperCvdMatrix.nxdivGDPU.ystar_eps(myi),upperCvdMatrix.nxdivGDPU.taumc_eps(myi),upperCvdMatrix.nxdivGDPU.taumi_eps(myi),upperCvdMatrix.nxdivGDPU.taumx_eps(myi),upperCvdMatrix.nxdivGDPU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_HdiffU.muz_eps(myi),upperCvdMatrix.data_HdiffU.phitilde_eps(myi),upperCvdMatrix.data_HdiffU.Rstar_eps(myi),upperCvdMatrix.data_HdiffU.pistar_eps(myi),upperCvdMatrix.data_HdiffU.ystar_eps(myi),upperCvdMatrix.data_HdiffU.taumc_eps(myi),upperCvdMatrix.data_HdiffU.taumi_eps(myi),upperCvdMatrix.data_HdiffU.taumx_eps(myi),upperCvdMatrix.data_HdiffU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_wdiffU.muz_eps(myi),upperCvdMatrix.data_wdiffU.phitilde_eps(myi),upperCvdMatrix.data_wdiffU.Rstar_eps(myi),upperCvdMatrix.data_wdiffU.pistar_eps(myi),upperCvdMatrix.data_wdiffU.ystar_eps(myi),upperCvdMatrix.data_wdiffU.taumc_eps(myi),upperCvdMatrix.data_wdiffU.taumi_eps(myi),upperCvdMatrix.data_wdiffU.taumx_eps(myi),upperCvdMatrix.data_wdiffU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_qdiffU.muz_eps(myi),upperCvdMatrix.data_qdiffU.phitilde_eps(myi),upperCvdMatrix.data_qdiffU.Rstar_eps(myi),upperCvdMatrix.data_qdiffU.pistar_eps(myi),upperCvdMatrix.data_qdiffU.ystar_eps(myi),upperCvdMatrix.data_qdiffU.taumc_eps(myi),upperCvdMatrix.data_qdiffU.taumi_eps(myi),upperCvdMatrix.data_qdiffU.taumx_eps(myi),upperCvdMatrix.data_qdiffU.taux_eps(myi)]);...
    ];
end 

% 8 year horizon
% squeeze(round(meanCvdSelected(3,:,:)*1000)/10)  % in percent
% round(lowerCvdSelected(3,:,:)*1000)/10
% round(upperCvdSelected(3,:,:)*1000)/10

myHorizon={'1','4','8','20'};

% mean cvd
for myI=1:length(myHorizon)
    myCvdMatrix=squeeze(meanCvdSelected(myI,:,:)*100);
    for myJ=1:size(myCvdMatrix,1)
        matrix2latexNS(myCvdMatrix(myJ,:),[myLatexPath '\BMeanCvd_' myHorizon{myI} '_' num2str(myJ) '.tex'],'format', '%-6.1f');
    end
end

% HPD int.
for myI=1:length(myHorizon)
    myCvdMatrix1=squeeze(lowerCvdSelected(myI,:,:)*100);
    myCvdMatrix2=squeeze(upperCvdSelected(myI,:,:)*100);
    myHPDIntMat=[myCvdMatrix1;myCvdMatrix2];
    myHPDIntMat=reshape(myHPDIntMat(:),size(myCvdMatrix1,1),[]);
    for myJ=1:size(myCvdMatrix,1)
        matrix2latexNS(myHPDIntMat(myJ,:),[myLatexPath '\BHPDCvd_' myHorizon{myI} '_' num2str(myJ) '.tex'],'format', '%-6.1f');
    end
end


%%%%%%%%%%%% finfric %%%%%%%%%%%%%%%%%%%
% mean conditional variance decomposition .i.e. taking parameter
% uncertainty
meanCvdMatrix=finfric_oo_.PosteriorTheoreticalMoments.dsge.ConditionalVarianceDecomposition.Mean;
%confidence interval
lowerCvdMatrix=finfric_oo_.PosteriorTheoreticalMoments.dsge.ConditionalVarianceDecomposition.HPDinf;
upperCvdMatrix=finfric_oo_.PosteriorTheoreticalMoments.dsge.ConditionalVarianceDecomposition.HPDsup;

clear meanCvdSelected
for myi=1:4
meanCvdSelected(myi,:,:)=[...
    meanCvdMatrix.data_RU.epsilon_eps(myi),...
    meanCvdMatrix.data_picU.epsilon_eps(myi),...
    meanCvdMatrix.data_ydiffU.epsilon_eps(myi),...
    meanCvdMatrix.data_cdiffU.epsilon_eps(myi),...
    meanCvdMatrix.data_idiffU.epsilon_eps(myi),...
    meanCvdMatrix.nxdivGDPU.epsilon_eps(myi),...
    meanCvdMatrix.data_HdiffU.epsilon_eps(myi),...
    meanCvdMatrix.data_wdiffU.epsilon_eps(myi),...
    meanCvdMatrix.data_qdiffU.epsilon_eps(myi),...
    meanCvdMatrix.data_ndiffU.epsilon_eps(myi),...
    meanCvdMatrix.data_spreadU.epsilon_eps(myi);...
      meanCvdMatrix.data_RU.Upsilon_eps(myi),...
    meanCvdMatrix.data_picU.Upsilon_eps(myi),...
    meanCvdMatrix.data_ydiffU.Upsilon_eps(myi),...
    meanCvdMatrix.data_cdiffU.Upsilon_eps(myi),...
    meanCvdMatrix.data_idiffU.Upsilon_eps(myi),...
    meanCvdMatrix.nxdivGDPU.Upsilon_eps(myi),...
    meanCvdMatrix.data_HdiffU.Upsilon_eps(myi),...
    meanCvdMatrix.data_wdiffU.Upsilon_eps(myi),...
    meanCvdMatrix.data_qdiffU.Upsilon_eps(myi),...
    meanCvdMatrix.data_ndiffU.Upsilon_eps(myi),...
    meanCvdMatrix.data_spreadU.Upsilon_eps(myi);...
  meanCvdMatrix.data_RU.zetac_eps(myi),...
    meanCvdMatrix.data_picU.zetac_eps(myi),...
    meanCvdMatrix.data_ydiffU.zetac_eps(myi),...
    meanCvdMatrix.data_cdiffU.zetac_eps(myi),...
    meanCvdMatrix.data_idiffU.zetac_eps(myi),...
    meanCvdMatrix.nxdivGDPU.zetac_eps(myi),...
    meanCvdMatrix.data_HdiffU.zetac_eps(myi),...
    meanCvdMatrix.data_wdiffU.zetac_eps(myi),...
    meanCvdMatrix.data_qdiffU.zetac_eps(myi),...
        meanCvdMatrix.data_ndiffU.zetac_eps(myi),...
    meanCvdMatrix.data_spreadU.zetac_eps(myi);...
      meanCvdMatrix.data_RU.zetah_eps(myi),...
    meanCvdMatrix.data_picU.zetah_eps(myi),...
    meanCvdMatrix.data_ydiffU.zetah_eps(myi),...
    meanCvdMatrix.data_cdiffU.zetah_eps(myi),...
    meanCvdMatrix.data_idiffU.zetah_eps(myi),...
    meanCvdMatrix.nxdivGDPU.zetah_eps(myi),...
    meanCvdMatrix.data_HdiffU.zetah_eps(myi),...
    meanCvdMatrix.data_wdiffU.zetah_eps(myi),...
    meanCvdMatrix.data_qdiffU.zetah_eps(myi),...
        meanCvdMatrix.data_ndiffU.zetah_eps(myi),...
    meanCvdMatrix.data_spreadU.zetah_eps(myi);...
...%       meanCvdMatrix.data_RU.epsR_eps(myi),...
...%     meanCvdMatrix.data_picU.epsR_eps(myi),...
...%     meanCvdMatrix.data_ydiffU.epsR_eps(myi),...
...%     meanCvdMatrix.data_cdiffU.epsR_eps(myi),...
...%     meanCvdMatrix.data_idiffU.epsR_eps(myi),...
...%     meanCvdMatrix.nxdivGDPU.epsR_eps(myi),...
...%     meanCvdMatrix.data_HdiffU.epsR_eps(myi),...
...%     meanCvdMatrix.data_wdiffU.epsR_eps(myi),...
...%     meanCvdMatrix.data_qdiffU.epsR_eps(myi),...
...%         meanCvdMatrix.data_ndiffU.epsR_eps(myi),...
...%     meanCvdMatrix.data_spreadU.epsR_eps(myi);...
    meanCvdMatrix.data_RU.taud_eps(myi),...
    meanCvdMatrix.data_picU.taud_eps(myi),...
    meanCvdMatrix.data_ydiffU.taud_eps(myi),...
    meanCvdMatrix.data_cdiffU.taud_eps(myi),...
    meanCvdMatrix.data_idiffU.taud_eps(myi),...
    meanCvdMatrix.nxdivGDPU.taud_eps(myi),...
    meanCvdMatrix.data_HdiffU.taud_eps(myi),...
    meanCvdMatrix.data_wdiffU.taud_eps(myi),...
    meanCvdMatrix.data_qdiffU.taud_eps(myi),...
        meanCvdMatrix.data_ndiffU.taud_eps(myi),...
    meanCvdMatrix.data_spreadU.taud_eps(myi);...
        meanCvdMatrix.data_RU.taux_eps(myi),...
    meanCvdMatrix.data_picU.taux_eps(myi),...
    meanCvdMatrix.data_ydiffU.taux_eps(myi),...
    meanCvdMatrix.data_cdiffU.taux_eps(myi),...
    meanCvdMatrix.data_idiffU.taux_eps(myi),...
    meanCvdMatrix.nxdivGDPU.taux_eps(myi),...
    meanCvdMatrix.data_HdiffU.taux_eps(myi),...
    meanCvdMatrix.data_wdiffU.taux_eps(myi),...
    meanCvdMatrix.data_qdiffU.taux_eps(myi),...
        meanCvdMatrix.data_ndiffU.taux_eps(myi),...
    meanCvdMatrix.data_spreadU.taux_eps(myi);...
      meanCvdMatrix.data_RU.taumc_eps(myi),...
    meanCvdMatrix.data_picU.taumc_eps(myi),...
    meanCvdMatrix.data_ydiffU.taumc_eps(myi),...
    meanCvdMatrix.data_cdiffU.taumc_eps(myi),...
    meanCvdMatrix.data_idiffU.taumc_eps(myi),...
    meanCvdMatrix.nxdivGDPU.taumc_eps(myi),...
    meanCvdMatrix.data_HdiffU.taumc_eps(myi),...
    meanCvdMatrix.data_wdiffU.taumc_eps(myi),...
    meanCvdMatrix.data_qdiffU.taumc_eps(myi),...
        meanCvdMatrix.data_ndiffU.taumc_eps(myi),...
    meanCvdMatrix.data_spreadU.taumc_eps(myi);...
      meanCvdMatrix.data_RU.taumi_eps(myi),...
    meanCvdMatrix.data_picU.taumi_eps(myi),...
    meanCvdMatrix.data_ydiffU.taumi_eps(myi),...
    meanCvdMatrix.data_cdiffU.taumi_eps(myi),...
    meanCvdMatrix.data_idiffU.taumi_eps(myi),...
    meanCvdMatrix.nxdivGDPU.taumi_eps(myi),...
    meanCvdMatrix.data_HdiffU.taumi_eps(myi),...
    meanCvdMatrix.data_wdiffU.taumi_eps(myi),...
    meanCvdMatrix.data_qdiffU.taumi_eps(myi),...
        meanCvdMatrix.data_ndiffU.taumi_eps(myi),...
    meanCvdMatrix.data_spreadU.taumi_eps(myi);...
      meanCvdMatrix.data_RU.taumx_eps(myi),...
    meanCvdMatrix.data_picU.taumx_eps(myi),...
    meanCvdMatrix.data_ydiffU.taumx_eps(myi),...
    meanCvdMatrix.data_cdiffU.taumx_eps(myi),...
    meanCvdMatrix.data_idiffU.taumx_eps(myi),...
    meanCvdMatrix.nxdivGDPU.taumx_eps(myi),...
    meanCvdMatrix.data_HdiffU.taumx_eps(myi),...
    meanCvdMatrix.data_wdiffU.taumx_eps(myi),...
    meanCvdMatrix.data_qdiffU.taumx_eps(myi),...
        meanCvdMatrix.data_ndiffU.taumx_eps(myi),...
    meanCvdMatrix.data_spreadU.taumx_eps(myi);...
    meanCvdMatrix.data_RU.gamma_eps(myi),...
    meanCvdMatrix.data_picU.gamma_eps(myi),...
    meanCvdMatrix.data_ydiffU.gamma_eps(myi),...
    meanCvdMatrix.data_cdiffU.gamma_eps(myi),...
    meanCvdMatrix.data_idiffU.gamma_eps(myi),...
    meanCvdMatrix.nxdivGDPU.gamma_eps(myi),...
    meanCvdMatrix.data_HdiffU.gamma_eps(myi),...
    meanCvdMatrix.data_wdiffU.gamma_eps(myi),...
    meanCvdMatrix.data_qdiffU.gamma_eps(myi),...
        meanCvdMatrix.data_ndiffU.gamma_eps(myi),...
    meanCvdMatrix.data_spreadU.gamma_eps(myi);...
    meanCvdMatrix.data_RU.phitilde_eps(myi),...
    meanCvdMatrix.data_picU.phitilde_eps(myi),...
    meanCvdMatrix.data_ydiffU.phitilde_eps(myi),...
    meanCvdMatrix.data_cdiffU.phitilde_eps(myi),...
    meanCvdMatrix.data_idiffU.phitilde_eps(myi),...
    meanCvdMatrix.nxdivGDPU.phitilde_eps(myi),...
    meanCvdMatrix.data_HdiffU.phitilde_eps(myi),...
    meanCvdMatrix.data_wdiffU.phitilde_eps(myi),...
    meanCvdMatrix.data_qdiffU.phitilde_eps(myi),...
        meanCvdMatrix.data_ndiffU.phitilde_eps(myi),...
    meanCvdMatrix.data_spreadU.phitilde_eps(myi);...
    meanCvdMatrix.data_RU.muz_eps(myi),...
    meanCvdMatrix.data_picU.muz_eps(myi),...
    meanCvdMatrix.data_ydiffU.muz_eps(myi),...
    meanCvdMatrix.data_cdiffU.muz_eps(myi),...
    meanCvdMatrix.data_idiffU.muz_eps(myi),...
    meanCvdMatrix.nxdivGDPU.muz_eps(myi),...
    meanCvdMatrix.data_HdiffU.muz_eps(myi),...
    meanCvdMatrix.data_wdiffU.muz_eps(myi),...
    meanCvdMatrix.data_qdiffU.muz_eps(myi),... 
        meanCvdMatrix.data_ndiffU.muz_eps(myi),...
    meanCvdMatrix.data_spreadU.muz_eps(myi);...
     meanCvdMatrix.data_RU.Rstar_eps(myi),...
     meanCvdMatrix.data_picU.Rstar_eps(myi),...
     meanCvdMatrix.data_ydiffU.Rstar_eps(myi),...
     meanCvdMatrix.data_cdiffU.Rstar_eps(myi),...
     meanCvdMatrix.data_idiffU.Rstar_eps(myi),...
     meanCvdMatrix.nxdivGDPU.Rstar_eps(myi),...
     meanCvdMatrix.data_HdiffU.Rstar_eps(myi),...
     meanCvdMatrix.data_wdiffU.Rstar_eps(myi),...
     meanCvdMatrix.data_qdiffU.Rstar_eps(myi),...
   meanCvdMatrix.data_ndiffU.Rstar_eps(myi),...
   meanCvdMatrix.data_spreadU.Rstar_eps(myi);...
        meanCvdMatrix.data_RU.ystar_eps(myi),...
     meanCvdMatrix.data_picU.ystar_eps(myi),...
     meanCvdMatrix.data_ydiffU.ystar_eps(myi),...
     meanCvdMatrix.data_cdiffU.ystar_eps(myi),...
     meanCvdMatrix.data_idiffU.ystar_eps(myi),...
     meanCvdMatrix.nxdivGDPU.ystar_eps(myi),...
     meanCvdMatrix.data_HdiffU.ystar_eps(myi),...
     meanCvdMatrix.data_wdiffU.ystar_eps(myi),...
     meanCvdMatrix.data_qdiffU.ystar_eps(myi),...
   meanCvdMatrix.data_ndiffU.ystar_eps(myi),...
   meanCvdMatrix.data_spreadU.ystar_eps(myi);...
     meanCvdMatrix.data_RU.pistar_eps(myi),...
     meanCvdMatrix.data_picU.pistar_eps(myi),...
     meanCvdMatrix.data_ydiffU.pistar_eps(myi),...
     meanCvdMatrix.data_cdiffU.pistar_eps(myi),...
     meanCvdMatrix.data_idiffU.pistar_eps(myi),...
     meanCvdMatrix.nxdivGDPU.pistar_eps(myi),...
     meanCvdMatrix.data_HdiffU.pistar_eps(myi),...
     meanCvdMatrix.data_wdiffU.pistar_eps(myi),...
     meanCvdMatrix.data_qdiffU.pistar_eps(myi),...
   meanCvdMatrix.data_ndiffU.pistar_eps(myi),...
   meanCvdMatrix.data_spreadU.pistar_eps(myi);...
%%%%%%%%%  5 foreign %%%%%%%%%%%%%%%%%%%
    sum([meanCvdMatrix.data_RU.muz_eps(myi),meanCvdMatrix.data_RU.phitilde_eps(myi),meanCvdMatrix.data_RU.Rstar_eps(myi),meanCvdMatrix.data_RU.pistar_eps(myi),meanCvdMatrix.data_RU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_picU.muz_eps(myi),meanCvdMatrix.data_picU.phitilde_eps(myi),meanCvdMatrix.data_picU.Rstar_eps(myi),meanCvdMatrix.data_picU.pistar_eps(myi),meanCvdMatrix.data_picU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_ydiffU.muz_eps(myi),meanCvdMatrix.data_ydiffU.phitilde_eps(myi),meanCvdMatrix.data_ydiffU.Rstar_eps(myi),meanCvdMatrix.data_ydiffU.pistar_eps(myi),meanCvdMatrix.data_ydiffU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_cdiffU.muz_eps(myi),meanCvdMatrix.data_cdiffU.phitilde_eps(myi),meanCvdMatrix.data_cdiffU.Rstar_eps(myi),meanCvdMatrix.data_cdiffU.pistar_eps(myi),meanCvdMatrix.data_cdiffU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_idiffU.muz_eps(myi),meanCvdMatrix.data_idiffU.phitilde_eps(myi),meanCvdMatrix.data_idiffU.Rstar_eps(myi),meanCvdMatrix.data_idiffU.pistar_eps(myi),meanCvdMatrix.data_idiffU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.nxdivGDPU.muz_eps(myi),meanCvdMatrix.nxdivGDPU.phitilde_eps(myi),meanCvdMatrix.nxdivGDPU.Rstar_eps(myi),meanCvdMatrix.nxdivGDPU.pistar_eps(myi),meanCvdMatrix.nxdivGDPU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_HdiffU.muz_eps(myi),meanCvdMatrix.data_HdiffU.phitilde_eps(myi),meanCvdMatrix.data_HdiffU.Rstar_eps(myi),meanCvdMatrix.data_HdiffU.pistar_eps(myi),meanCvdMatrix.data_HdiffU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_wdiffU.muz_eps(myi),meanCvdMatrix.data_wdiffU.phitilde_eps(myi),meanCvdMatrix.data_wdiffU.Rstar_eps(myi),meanCvdMatrix.data_wdiffU.pistar_eps(myi),meanCvdMatrix.data_wdiffU.ystar_eps(myi)]),...
    sum([meanCvdMatrix.data_qdiffU.muz_eps(myi),meanCvdMatrix.data_qdiffU.phitilde_eps(myi),meanCvdMatrix.data_qdiffU.Rstar_eps(myi),meanCvdMatrix.data_qdiffU.pistar_eps(myi),meanCvdMatrix.data_qdiffU.ystar_eps(myi)]),...
sum([meanCvdMatrix.data_ndiffU.muz_eps(myi),meanCvdMatrix.data_ndiffU.phitilde_eps(myi),meanCvdMatrix.data_ndiffU.Rstar_eps(myi),meanCvdMatrix.data_ndiffU.pistar_eps(myi),meanCvdMatrix.data_ndiffU.ystar_eps(myi)]),...
sum([meanCvdMatrix.data_spreadU.muz_eps(myi),meanCvdMatrix.data_spreadU.phitilde_eps(myi),meanCvdMatrix.data_spreadU.Rstar_eps(myi),meanCvdMatrix.data_spreadU.pistar_eps(myi),meanCvdMatrix.data_spreadU.ystar_eps(myi)]);...
%%%%%%%%%  all foreign %%%%%%%%%%%%%%%%%%%
    sum([meanCvdMatrix.data_RU.muz_eps(myi),meanCvdMatrix.data_RU.phitilde_eps(myi),meanCvdMatrix.data_RU.Rstar_eps(myi),meanCvdMatrix.data_RU.pistar_eps(myi),meanCvdMatrix.data_RU.ystar_eps(myi),meanCvdMatrix.data_RU.taumc_eps(myi),meanCvdMatrix.data_RU.taumi_eps(myi),meanCvdMatrix.data_RU.taumx_eps(myi),meanCvdMatrix.data_RU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_picU.muz_eps(myi),meanCvdMatrix.data_picU.phitilde_eps(myi),meanCvdMatrix.data_picU.Rstar_eps(myi),meanCvdMatrix.data_picU.pistar_eps(myi),meanCvdMatrix.data_picU.ystar_eps(myi),meanCvdMatrix.data_picU.taumc_eps(myi),meanCvdMatrix.data_picU.taumi_eps(myi),meanCvdMatrix.data_picU.taumx_eps(myi),meanCvdMatrix.data_picU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_ydiffU.muz_eps(myi),meanCvdMatrix.data_ydiffU.phitilde_eps(myi),meanCvdMatrix.data_ydiffU.Rstar_eps(myi),meanCvdMatrix.data_ydiffU.pistar_eps(myi),meanCvdMatrix.data_ydiffU.ystar_eps(myi),meanCvdMatrix.data_ydiffU.taumc_eps(myi),meanCvdMatrix.data_ydiffU.taumi_eps(myi),meanCvdMatrix.data_ydiffU.taumx_eps(myi),meanCvdMatrix.data_ydiffU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_cdiffU.muz_eps(myi),meanCvdMatrix.data_cdiffU.phitilde_eps(myi),meanCvdMatrix.data_cdiffU.Rstar_eps(myi),meanCvdMatrix.data_cdiffU.pistar_eps(myi),meanCvdMatrix.data_cdiffU.ystar_eps(myi),meanCvdMatrix.data_cdiffU.taumc_eps(myi),meanCvdMatrix.data_cdiffU.taumi_eps(myi),meanCvdMatrix.data_cdiffU.taumx_eps(myi),meanCvdMatrix.data_cdiffU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_idiffU.muz_eps(myi),meanCvdMatrix.data_idiffU.phitilde_eps(myi),meanCvdMatrix.data_idiffU.Rstar_eps(myi),meanCvdMatrix.data_idiffU.pistar_eps(myi),meanCvdMatrix.data_idiffU.ystar_eps(myi),meanCvdMatrix.data_idiffU.taumc_eps(myi),meanCvdMatrix.data_idiffU.taumi_eps(myi),meanCvdMatrix.data_idiffU.taumx_eps(myi),meanCvdMatrix.data_idiffU.taux_eps(myi)]),...
    sum([meanCvdMatrix.nxdivGDPU.muz_eps(myi),meanCvdMatrix.nxdivGDPU.phitilde_eps(myi),meanCvdMatrix.nxdivGDPU.Rstar_eps(myi),meanCvdMatrix.nxdivGDPU.pistar_eps(myi),meanCvdMatrix.nxdivGDPU.ystar_eps(myi),meanCvdMatrix.nxdivGDPU.taumc_eps(myi),meanCvdMatrix.nxdivGDPU.taumi_eps(myi),meanCvdMatrix.nxdivGDPU.taumx_eps(myi),meanCvdMatrix.nxdivGDPU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_HdiffU.muz_eps(myi),meanCvdMatrix.data_HdiffU.phitilde_eps(myi),meanCvdMatrix.data_HdiffU.Rstar_eps(myi),meanCvdMatrix.data_HdiffU.pistar_eps(myi),meanCvdMatrix.data_HdiffU.ystar_eps(myi),meanCvdMatrix.data_HdiffU.taumc_eps(myi),meanCvdMatrix.data_HdiffU.taumi_eps(myi),meanCvdMatrix.data_HdiffU.taumx_eps(myi),meanCvdMatrix.data_HdiffU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_wdiffU.muz_eps(myi),meanCvdMatrix.data_wdiffU.phitilde_eps(myi),meanCvdMatrix.data_wdiffU.Rstar_eps(myi),meanCvdMatrix.data_wdiffU.pistar_eps(myi),meanCvdMatrix.data_wdiffU.ystar_eps(myi),meanCvdMatrix.data_wdiffU.taumc_eps(myi),meanCvdMatrix.data_wdiffU.taumi_eps(myi),meanCvdMatrix.data_wdiffU.taumx_eps(myi),meanCvdMatrix.data_wdiffU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_qdiffU.muz_eps(myi),meanCvdMatrix.data_qdiffU.phitilde_eps(myi),meanCvdMatrix.data_qdiffU.Rstar_eps(myi),meanCvdMatrix.data_qdiffU.pistar_eps(myi),meanCvdMatrix.data_qdiffU.ystar_eps(myi),meanCvdMatrix.data_qdiffU.taumc_eps(myi),meanCvdMatrix.data_qdiffU.taumi_eps(myi),meanCvdMatrix.data_qdiffU.taumx_eps(myi),meanCvdMatrix.data_qdiffU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_ndiffU.muz_eps(myi),meanCvdMatrix.data_ndiffU.phitilde_eps(myi),meanCvdMatrix.data_ndiffU.Rstar_eps(myi),meanCvdMatrix.data_ndiffU.pistar_eps(myi),meanCvdMatrix.data_ndiffU.ystar_eps(myi),meanCvdMatrix.data_ndiffU.taumc_eps(myi),meanCvdMatrix.data_ndiffU.taumi_eps(myi),meanCvdMatrix.data_ndiffU.taumx_eps(myi),meanCvdMatrix.data_ndiffU.taux_eps(myi)]),...
    sum([meanCvdMatrix.data_spreadU.muz_eps(myi),meanCvdMatrix.data_spreadU.phitilde_eps(myi),meanCvdMatrix.data_spreadU.Rstar_eps(myi),meanCvdMatrix.data_spreadU.pistar_eps(myi),meanCvdMatrix.data_spreadU.ystar_eps(myi),meanCvdMatrix.data_spreadU.taumc_eps(myi),meanCvdMatrix.data_spreadU.taumi_eps(myi),meanCvdMatrix.data_spreadU.taumx_eps(myi),meanCvdMatrix.data_spreadU.taux_eps(myi)]);...
    ];
end 

clear lowerCvdSelected
for myi=1:4
lowerCvdSelected(myi,:,:)=[...
    lowerCvdMatrix.data_RU.epsilon_eps(myi),...
    lowerCvdMatrix.data_picU.epsilon_eps(myi),...
    lowerCvdMatrix.data_ydiffU.epsilon_eps(myi),...
    lowerCvdMatrix.data_cdiffU.epsilon_eps(myi),...
    lowerCvdMatrix.data_idiffU.epsilon_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.epsilon_eps(myi),...
    lowerCvdMatrix.data_HdiffU.epsilon_eps(myi),...
    lowerCvdMatrix.data_wdiffU.epsilon_eps(myi),...
    lowerCvdMatrix.data_qdiffU.epsilon_eps(myi),...
    lowerCvdMatrix.data_ndiffU.epsilon_eps(myi),...
    lowerCvdMatrix.data_spreadU.epsilon_eps(myi);...
      lowerCvdMatrix.data_RU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_picU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_ydiffU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_cdiffU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_idiffU.Upsilon_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_HdiffU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_wdiffU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_qdiffU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_ndiffU.Upsilon_eps(myi),...
    lowerCvdMatrix.data_spreadU.Upsilon_eps(myi);...
  lowerCvdMatrix.data_RU.zetac_eps(myi),...
    lowerCvdMatrix.data_picU.zetac_eps(myi),...
    lowerCvdMatrix.data_ydiffU.zetac_eps(myi),...
    lowerCvdMatrix.data_cdiffU.zetac_eps(myi),...
    lowerCvdMatrix.data_idiffU.zetac_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.zetac_eps(myi),...
    lowerCvdMatrix.data_HdiffU.zetac_eps(myi),...
    lowerCvdMatrix.data_wdiffU.zetac_eps(myi),...
    lowerCvdMatrix.data_qdiffU.zetac_eps(myi),...
        lowerCvdMatrix.data_ndiffU.zetac_eps(myi),...
    lowerCvdMatrix.data_spreadU.zetac_eps(myi);...
      lowerCvdMatrix.data_RU.zetah_eps(myi),...
    lowerCvdMatrix.data_picU.zetah_eps(myi),...
    lowerCvdMatrix.data_ydiffU.zetah_eps(myi),...
    lowerCvdMatrix.data_cdiffU.zetah_eps(myi),...
    lowerCvdMatrix.data_idiffU.zetah_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.zetah_eps(myi),...
    lowerCvdMatrix.data_HdiffU.zetah_eps(myi),...
    lowerCvdMatrix.data_wdiffU.zetah_eps(myi),...
    lowerCvdMatrix.data_qdiffU.zetah_eps(myi),...
        lowerCvdMatrix.data_ndiffU.zetah_eps(myi),...
    lowerCvdMatrix.data_spreadU.zetah_eps(myi);...
...%       lowerCvdMatrix.data_RU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_picU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_ydiffU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_cdiffU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_idiffU.epsR_eps(myi),...
...%     lowerCvdMatrix.nxdivGDPU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_HdiffU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_wdiffU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_qdiffU.epsR_eps(myi),...
...%         lowerCvdMatrix.data_ndiffU.epsR_eps(myi),...
...%     lowerCvdMatrix.data_spreadU.epsR_eps(myi);...
    lowerCvdMatrix.data_RU.taud_eps(myi),...
    lowerCvdMatrix.data_picU.taud_eps(myi),...
    lowerCvdMatrix.data_ydiffU.taud_eps(myi),...
    lowerCvdMatrix.data_cdiffU.taud_eps(myi),...
    lowerCvdMatrix.data_idiffU.taud_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.taud_eps(myi),...
    lowerCvdMatrix.data_HdiffU.taud_eps(myi),...
    lowerCvdMatrix.data_wdiffU.taud_eps(myi),...
    lowerCvdMatrix.data_qdiffU.taud_eps(myi),...
        lowerCvdMatrix.data_ndiffU.taud_eps(myi),...
    lowerCvdMatrix.data_spreadU.taud_eps(myi);...
        lowerCvdMatrix.data_RU.taux_eps(myi),...
    lowerCvdMatrix.data_picU.taux_eps(myi),...
    lowerCvdMatrix.data_ydiffU.taux_eps(myi),...
    lowerCvdMatrix.data_cdiffU.taux_eps(myi),...
    lowerCvdMatrix.data_idiffU.taux_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.taux_eps(myi),...
    lowerCvdMatrix.data_HdiffU.taux_eps(myi),...
    lowerCvdMatrix.data_wdiffU.taux_eps(myi),...
    lowerCvdMatrix.data_qdiffU.taux_eps(myi),...
        lowerCvdMatrix.data_ndiffU.taux_eps(myi),...
    lowerCvdMatrix.data_spreadU.taux_eps(myi);...
      lowerCvdMatrix.data_RU.taumc_eps(myi),...
    lowerCvdMatrix.data_picU.taumc_eps(myi),...
    lowerCvdMatrix.data_ydiffU.taumc_eps(myi),...
    lowerCvdMatrix.data_cdiffU.taumc_eps(myi),...
    lowerCvdMatrix.data_idiffU.taumc_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.taumc_eps(myi),...
    lowerCvdMatrix.data_HdiffU.taumc_eps(myi),...
    lowerCvdMatrix.data_wdiffU.taumc_eps(myi),...
    lowerCvdMatrix.data_qdiffU.taumc_eps(myi),...
        lowerCvdMatrix.data_ndiffU.taumc_eps(myi),...
    lowerCvdMatrix.data_spreadU.taumc_eps(myi);...
      lowerCvdMatrix.data_RU.taumi_eps(myi),...
    lowerCvdMatrix.data_picU.taumi_eps(myi),...
    lowerCvdMatrix.data_ydiffU.taumi_eps(myi),...
    lowerCvdMatrix.data_cdiffU.taumi_eps(myi),...
    lowerCvdMatrix.data_idiffU.taumi_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.taumi_eps(myi),...
    lowerCvdMatrix.data_HdiffU.taumi_eps(myi),...
    lowerCvdMatrix.data_wdiffU.taumi_eps(myi),...
    lowerCvdMatrix.data_qdiffU.taumi_eps(myi),...
        lowerCvdMatrix.data_ndiffU.taumi_eps(myi),...
    lowerCvdMatrix.data_spreadU.taumi_eps(myi);...
      lowerCvdMatrix.data_RU.taumx_eps(myi),...
    lowerCvdMatrix.data_picU.taumx_eps(myi),...
    lowerCvdMatrix.data_ydiffU.taumx_eps(myi),...
    lowerCvdMatrix.data_cdiffU.taumx_eps(myi),...
    lowerCvdMatrix.data_idiffU.taumx_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.taumx_eps(myi),...
    lowerCvdMatrix.data_HdiffU.taumx_eps(myi),...
    lowerCvdMatrix.data_wdiffU.taumx_eps(myi),...
    lowerCvdMatrix.data_qdiffU.taumx_eps(myi),...
        lowerCvdMatrix.data_ndiffU.taumx_eps(myi),...
    lowerCvdMatrix.data_spreadU.taumx_eps(myi);...
    lowerCvdMatrix.data_RU.gamma_eps(myi),...
    lowerCvdMatrix.data_picU.gamma_eps(myi),...
    lowerCvdMatrix.data_ydiffU.gamma_eps(myi),...
    lowerCvdMatrix.data_cdiffU.gamma_eps(myi),...
    lowerCvdMatrix.data_idiffU.gamma_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.gamma_eps(myi),...
    lowerCvdMatrix.data_HdiffU.gamma_eps(myi),...
    lowerCvdMatrix.data_wdiffU.gamma_eps(myi),...
    lowerCvdMatrix.data_qdiffU.gamma_eps(myi),...
        lowerCvdMatrix.data_ndiffU.gamma_eps(myi),...
    lowerCvdMatrix.data_spreadU.gamma_eps(myi);...
    lowerCvdMatrix.data_RU.phitilde_eps(myi),...
    lowerCvdMatrix.data_picU.phitilde_eps(myi),...
    lowerCvdMatrix.data_ydiffU.phitilde_eps(myi),...
    lowerCvdMatrix.data_cdiffU.phitilde_eps(myi),...
    lowerCvdMatrix.data_idiffU.phitilde_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.phitilde_eps(myi),...
    lowerCvdMatrix.data_HdiffU.phitilde_eps(myi),...
    lowerCvdMatrix.data_wdiffU.phitilde_eps(myi),...
    lowerCvdMatrix.data_qdiffU.phitilde_eps(myi),...
        lowerCvdMatrix.data_ndiffU.phitilde_eps(myi),...
    lowerCvdMatrix.data_spreadU.phitilde_eps(myi);...
    lowerCvdMatrix.data_RU.muz_eps(myi),...
    lowerCvdMatrix.data_picU.muz_eps(myi),...
    lowerCvdMatrix.data_ydiffU.muz_eps(myi),...
    lowerCvdMatrix.data_cdiffU.muz_eps(myi),...
    lowerCvdMatrix.data_idiffU.muz_eps(myi),...
    lowerCvdMatrix.nxdivGDPU.muz_eps(myi),...
    lowerCvdMatrix.data_HdiffU.muz_eps(myi),...
    lowerCvdMatrix.data_wdiffU.muz_eps(myi),...
    lowerCvdMatrix.data_qdiffU.muz_eps(myi),... 
        lowerCvdMatrix.data_ndiffU.muz_eps(myi),...
    lowerCvdMatrix.data_spreadU.muz_eps(myi);...
     lowerCvdMatrix.data_RU.Rstar_eps(myi),...
     lowerCvdMatrix.data_picU.Rstar_eps(myi),...
     lowerCvdMatrix.data_ydiffU.Rstar_eps(myi),...
     lowerCvdMatrix.data_cdiffU.Rstar_eps(myi),...
     lowerCvdMatrix.data_idiffU.Rstar_eps(myi),...
     lowerCvdMatrix.nxdivGDPU.Rstar_eps(myi),...
     lowerCvdMatrix.data_HdiffU.Rstar_eps(myi),...
     lowerCvdMatrix.data_wdiffU.Rstar_eps(myi),...
     lowerCvdMatrix.data_qdiffU.Rstar_eps(myi),...
   lowerCvdMatrix.data_ndiffU.Rstar_eps(myi),...
   lowerCvdMatrix.data_spreadU.Rstar_eps(myi);...
       lowerCvdMatrix.data_RU.ystar_eps(myi),...
     lowerCvdMatrix.data_picU.ystar_eps(myi),...
     lowerCvdMatrix.data_ydiffU.ystar_eps(myi),...
     lowerCvdMatrix.data_cdiffU.ystar_eps(myi),...
     lowerCvdMatrix.data_idiffU.ystar_eps(myi),...
     lowerCvdMatrix.nxdivGDPU.ystar_eps(myi),...
     lowerCvdMatrix.data_HdiffU.ystar_eps(myi),...
     lowerCvdMatrix.data_wdiffU.ystar_eps(myi),...
     lowerCvdMatrix.data_qdiffU.ystar_eps(myi),...
   lowerCvdMatrix.data_ndiffU.ystar_eps(myi),...
   lowerCvdMatrix.data_spreadU.ystar_eps(myi);...
       lowerCvdMatrix.data_RU.pistar_eps(myi),...
     lowerCvdMatrix.data_picU.pistar_eps(myi),...
     lowerCvdMatrix.data_ydiffU.pistar_eps(myi),...
     lowerCvdMatrix.data_cdiffU.pistar_eps(myi),...
     lowerCvdMatrix.data_idiffU.pistar_eps(myi),...
     lowerCvdMatrix.nxdivGDPU.pistar_eps(myi),...
     lowerCvdMatrix.data_HdiffU.pistar_eps(myi),...
     lowerCvdMatrix.data_wdiffU.pistar_eps(myi),...
     lowerCvdMatrix.data_qdiffU.pistar_eps(myi),...
   lowerCvdMatrix.data_ndiffU.pistar_eps(myi),...
   lowerCvdMatrix.data_spreadU.pistar_eps(myi);...
%%%%%%%%%  5 foreign %%%%%%%%%%%%%%%%%%%
    sum([lowerCvdMatrix.data_RU.muz_eps(myi),lowerCvdMatrix.data_RU.phitilde_eps(myi),lowerCvdMatrix.data_RU.Rstar_eps(myi),lowerCvdMatrix.data_RU.pistar_eps(myi),lowerCvdMatrix.data_RU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_picU.muz_eps(myi),lowerCvdMatrix.data_picU.phitilde_eps(myi),lowerCvdMatrix.data_picU.Rstar_eps(myi),lowerCvdMatrix.data_picU.pistar_eps(myi),lowerCvdMatrix.data_picU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_ydiffU.muz_eps(myi),lowerCvdMatrix.data_ydiffU.phitilde_eps(myi),lowerCvdMatrix.data_ydiffU.Rstar_eps(myi),lowerCvdMatrix.data_ydiffU.pistar_eps(myi),lowerCvdMatrix.data_ydiffU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_cdiffU.muz_eps(myi),lowerCvdMatrix.data_cdiffU.phitilde_eps(myi),lowerCvdMatrix.data_cdiffU.Rstar_eps(myi),lowerCvdMatrix.data_cdiffU.pistar_eps(myi),lowerCvdMatrix.data_cdiffU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_idiffU.muz_eps(myi),lowerCvdMatrix.data_idiffU.phitilde_eps(myi),lowerCvdMatrix.data_idiffU.Rstar_eps(myi),lowerCvdMatrix.data_idiffU.pistar_eps(myi),lowerCvdMatrix.data_idiffU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.nxdivGDPU.muz_eps(myi),lowerCvdMatrix.nxdivGDPU.phitilde_eps(myi),lowerCvdMatrix.nxdivGDPU.Rstar_eps(myi),lowerCvdMatrix.nxdivGDPU.pistar_eps(myi),lowerCvdMatrix.nxdivGDPU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_HdiffU.muz_eps(myi),lowerCvdMatrix.data_HdiffU.phitilde_eps(myi),lowerCvdMatrix.data_HdiffU.Rstar_eps(myi),lowerCvdMatrix.data_HdiffU.pistar_eps(myi),lowerCvdMatrix.data_HdiffU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_wdiffU.muz_eps(myi),lowerCvdMatrix.data_wdiffU.phitilde_eps(myi),lowerCvdMatrix.data_wdiffU.Rstar_eps(myi),lowerCvdMatrix.data_wdiffU.pistar_eps(myi),lowerCvdMatrix.data_wdiffU.ystar_eps(myi)]),...
    sum([lowerCvdMatrix.data_qdiffU.muz_eps(myi),lowerCvdMatrix.data_qdiffU.phitilde_eps(myi),lowerCvdMatrix.data_qdiffU.Rstar_eps(myi),lowerCvdMatrix.data_qdiffU.pistar_eps(myi),lowerCvdMatrix.data_qdiffU.ystar_eps(myi)]),...
sum([lowerCvdMatrix.data_ndiffU.muz_eps(myi),lowerCvdMatrix.data_ndiffU.phitilde_eps(myi),lowerCvdMatrix.data_ndiffU.Rstar_eps(myi),lowerCvdMatrix.data_ndiffU.pistar_eps(myi),lowerCvdMatrix.data_ndiffU.ystar_eps(myi)]),...
sum([lowerCvdMatrix.data_spreadU.muz_eps(myi),lowerCvdMatrix.data_spreadU.phitilde_eps(myi),lowerCvdMatrix.data_spreadU.Rstar_eps(myi),lowerCvdMatrix.data_spreadU.pistar_eps(myi),lowerCvdMatrix.data_spreadU.ystar_eps(myi)]);...
%%%%%%%%%  all foreign %%%%%%%%%%%%%%%%%%%
    sum([lowerCvdMatrix.data_RU.muz_eps(myi),lowerCvdMatrix.data_RU.phitilde_eps(myi),lowerCvdMatrix.data_RU.Rstar_eps(myi),lowerCvdMatrix.data_RU.pistar_eps(myi),lowerCvdMatrix.data_RU.ystar_eps(myi),lowerCvdMatrix.data_RU.taumc_eps(myi),lowerCvdMatrix.data_RU.taumi_eps(myi),lowerCvdMatrix.data_RU.taumx_eps(myi),lowerCvdMatrix.data_RU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_picU.muz_eps(myi),lowerCvdMatrix.data_picU.phitilde_eps(myi),lowerCvdMatrix.data_picU.Rstar_eps(myi),lowerCvdMatrix.data_picU.pistar_eps(myi),lowerCvdMatrix.data_picU.ystar_eps(myi),lowerCvdMatrix.data_picU.taumc_eps(myi),lowerCvdMatrix.data_picU.taumi_eps(myi),lowerCvdMatrix.data_picU.taumx_eps(myi),lowerCvdMatrix.data_picU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_ydiffU.muz_eps(myi),lowerCvdMatrix.data_ydiffU.phitilde_eps(myi),lowerCvdMatrix.data_ydiffU.Rstar_eps(myi),lowerCvdMatrix.data_ydiffU.pistar_eps(myi),lowerCvdMatrix.data_ydiffU.ystar_eps(myi),lowerCvdMatrix.data_ydiffU.taumc_eps(myi),lowerCvdMatrix.data_ydiffU.taumi_eps(myi),lowerCvdMatrix.data_ydiffU.taumx_eps(myi),lowerCvdMatrix.data_ydiffU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_cdiffU.muz_eps(myi),lowerCvdMatrix.data_cdiffU.phitilde_eps(myi),lowerCvdMatrix.data_cdiffU.Rstar_eps(myi),lowerCvdMatrix.data_cdiffU.pistar_eps(myi),lowerCvdMatrix.data_cdiffU.ystar_eps(myi),lowerCvdMatrix.data_cdiffU.taumc_eps(myi),lowerCvdMatrix.data_cdiffU.taumi_eps(myi),lowerCvdMatrix.data_cdiffU.taumx_eps(myi),lowerCvdMatrix.data_cdiffU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_idiffU.muz_eps(myi),lowerCvdMatrix.data_idiffU.phitilde_eps(myi),lowerCvdMatrix.data_idiffU.Rstar_eps(myi),lowerCvdMatrix.data_idiffU.pistar_eps(myi),lowerCvdMatrix.data_idiffU.ystar_eps(myi),lowerCvdMatrix.data_idiffU.taumc_eps(myi),lowerCvdMatrix.data_idiffU.taumi_eps(myi),lowerCvdMatrix.data_idiffU.taumx_eps(myi),lowerCvdMatrix.data_idiffU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.nxdivGDPU.muz_eps(myi),lowerCvdMatrix.nxdivGDPU.phitilde_eps(myi),lowerCvdMatrix.nxdivGDPU.Rstar_eps(myi),lowerCvdMatrix.nxdivGDPU.pistar_eps(myi),lowerCvdMatrix.nxdivGDPU.ystar_eps(myi),lowerCvdMatrix.nxdivGDPU.taumc_eps(myi),lowerCvdMatrix.nxdivGDPU.taumi_eps(myi),lowerCvdMatrix.nxdivGDPU.taumx_eps(myi),lowerCvdMatrix.nxdivGDPU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_HdiffU.muz_eps(myi),lowerCvdMatrix.data_HdiffU.phitilde_eps(myi),lowerCvdMatrix.data_HdiffU.Rstar_eps(myi),lowerCvdMatrix.data_HdiffU.pistar_eps(myi),lowerCvdMatrix.data_HdiffU.ystar_eps(myi),lowerCvdMatrix.data_HdiffU.taumc_eps(myi),lowerCvdMatrix.data_HdiffU.taumi_eps(myi),lowerCvdMatrix.data_HdiffU.taumx_eps(myi),lowerCvdMatrix.data_HdiffU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_wdiffU.muz_eps(myi),lowerCvdMatrix.data_wdiffU.phitilde_eps(myi),lowerCvdMatrix.data_wdiffU.Rstar_eps(myi),lowerCvdMatrix.data_wdiffU.pistar_eps(myi),lowerCvdMatrix.data_wdiffU.ystar_eps(myi),lowerCvdMatrix.data_wdiffU.taumc_eps(myi),lowerCvdMatrix.data_wdiffU.taumi_eps(myi),lowerCvdMatrix.data_wdiffU.taumx_eps(myi),lowerCvdMatrix.data_wdiffU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_qdiffU.muz_eps(myi),lowerCvdMatrix.data_qdiffU.phitilde_eps(myi),lowerCvdMatrix.data_qdiffU.Rstar_eps(myi),lowerCvdMatrix.data_qdiffU.pistar_eps(myi),lowerCvdMatrix.data_qdiffU.ystar_eps(myi),lowerCvdMatrix.data_qdiffU.taumc_eps(myi),lowerCvdMatrix.data_qdiffU.taumi_eps(myi),lowerCvdMatrix.data_qdiffU.taumx_eps(myi),lowerCvdMatrix.data_qdiffU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_ndiffU.muz_eps(myi),lowerCvdMatrix.data_ndiffU.phitilde_eps(myi),lowerCvdMatrix.data_ndiffU.Rstar_eps(myi),lowerCvdMatrix.data_ndiffU.pistar_eps(myi),lowerCvdMatrix.data_ndiffU.ystar_eps(myi),lowerCvdMatrix.data_ndiffU.taumc_eps(myi),lowerCvdMatrix.data_ndiffU.taumi_eps(myi),lowerCvdMatrix.data_ndiffU.taumx_eps(myi),lowerCvdMatrix.data_ndiffU.taux_eps(myi)]),...
    sum([lowerCvdMatrix.data_spreadU.muz_eps(myi),lowerCvdMatrix.data_spreadU.phitilde_eps(myi),lowerCvdMatrix.data_spreadU.Rstar_eps(myi),lowerCvdMatrix.data_spreadU.pistar_eps(myi),lowerCvdMatrix.data_spreadU.ystar_eps(myi),lowerCvdMatrix.data_spreadU.taumc_eps(myi),lowerCvdMatrix.data_spreadU.taumi_eps(myi),lowerCvdMatrix.data_spreadU.taumx_eps(myi),lowerCvdMatrix.data_spreadU.taux_eps(myi)]);...
    ];
end 

clear upperCvdSelected
for myi=1:4
upperCvdSelected(myi,:,:)=[...
    upperCvdMatrix.data_RU.epsilon_eps(myi),...
    upperCvdMatrix.data_picU.epsilon_eps(myi),...
    upperCvdMatrix.data_ydiffU.epsilon_eps(myi),...
    upperCvdMatrix.data_cdiffU.epsilon_eps(myi),...
    upperCvdMatrix.data_idiffU.epsilon_eps(myi),...
    upperCvdMatrix.nxdivGDPU.epsilon_eps(myi),...
    upperCvdMatrix.data_HdiffU.epsilon_eps(myi),...
    upperCvdMatrix.data_wdiffU.epsilon_eps(myi),...
    upperCvdMatrix.data_qdiffU.epsilon_eps(myi),...
    upperCvdMatrix.data_ndiffU.epsilon_eps(myi),...
    upperCvdMatrix.data_spreadU.epsilon_eps(myi);...
      upperCvdMatrix.data_RU.Upsilon_eps(myi),...
    upperCvdMatrix.data_picU.Upsilon_eps(myi),...
    upperCvdMatrix.data_ydiffU.Upsilon_eps(myi),...
    upperCvdMatrix.data_cdiffU.Upsilon_eps(myi),...
    upperCvdMatrix.data_idiffU.Upsilon_eps(myi),...
    upperCvdMatrix.nxdivGDPU.Upsilon_eps(myi),...
    upperCvdMatrix.data_HdiffU.Upsilon_eps(myi),...
    upperCvdMatrix.data_wdiffU.Upsilon_eps(myi),...
    upperCvdMatrix.data_qdiffU.Upsilon_eps(myi),...
    upperCvdMatrix.data_ndiffU.Upsilon_eps(myi),...
    upperCvdMatrix.data_spreadU.Upsilon_eps(myi);...
  upperCvdMatrix.data_RU.zetac_eps(myi),...
    upperCvdMatrix.data_picU.zetac_eps(myi),...
    upperCvdMatrix.data_ydiffU.zetac_eps(myi),...
    upperCvdMatrix.data_cdiffU.zetac_eps(myi),...
    upperCvdMatrix.data_idiffU.zetac_eps(myi),...
    upperCvdMatrix.nxdivGDPU.zetac_eps(myi),...
    upperCvdMatrix.data_HdiffU.zetac_eps(myi),...
    upperCvdMatrix.data_wdiffU.zetac_eps(myi),...
    upperCvdMatrix.data_qdiffU.zetac_eps(myi),...
        upperCvdMatrix.data_ndiffU.zetac_eps(myi),...
    upperCvdMatrix.data_spreadU.zetac_eps(myi);...
      upperCvdMatrix.data_RU.zetah_eps(myi),...
    upperCvdMatrix.data_picU.zetah_eps(myi),...
    upperCvdMatrix.data_ydiffU.zetah_eps(myi),...
    upperCvdMatrix.data_cdiffU.zetah_eps(myi),...
    upperCvdMatrix.data_idiffU.zetah_eps(myi),...
    upperCvdMatrix.nxdivGDPU.zetah_eps(myi),...
    upperCvdMatrix.data_HdiffU.zetah_eps(myi),...
    upperCvdMatrix.data_wdiffU.zetah_eps(myi),...
    upperCvdMatrix.data_qdiffU.zetah_eps(myi),...
        upperCvdMatrix.data_ndiffU.zetah_eps(myi),...
    upperCvdMatrix.data_spreadU.zetah_eps(myi);...
...%       upperCvdMatrix.data_RU.epsR_eps(myi),...
...%     upperCvdMatrix.data_picU.epsR_eps(myi),...
...%     upperCvdMatrix.data_ydiffU.epsR_eps(myi),...
...%     upperCvdMatrix.data_cdiffU.epsR_eps(myi),...
...%     upperCvdMatrix.data_idiffU.epsR_eps(myi),...
...%     upperCvdMatrix.nxdivGDPU.epsR_eps(myi),...
...%     upperCvdMatrix.data_HdiffU.epsR_eps(myi),...
...%     upperCvdMatrix.data_wdiffU.epsR_eps(myi),...
...%     upperCvdMatrix.data_qdiffU.epsR_eps(myi),...
...%         upperCvdMatrix.data_ndiffU.epsR_eps(myi),...
...%     upperCvdMatrix.data_spreadU.epsR_eps(myi);...
    upperCvdMatrix.data_RU.taud_eps(myi),...
    upperCvdMatrix.data_picU.taud_eps(myi),...
    upperCvdMatrix.data_ydiffU.taud_eps(myi),...
    upperCvdMatrix.data_cdiffU.taud_eps(myi),...
    upperCvdMatrix.data_idiffU.taud_eps(myi),...
    upperCvdMatrix.nxdivGDPU.taud_eps(myi),...
    upperCvdMatrix.data_HdiffU.taud_eps(myi),...
    upperCvdMatrix.data_wdiffU.taud_eps(myi),...
    upperCvdMatrix.data_qdiffU.taud_eps(myi),...
        upperCvdMatrix.data_ndiffU.taud_eps(myi),...
    upperCvdMatrix.data_spreadU.taud_eps(myi);...
        upperCvdMatrix.data_RU.taux_eps(myi),...
    upperCvdMatrix.data_picU.taux_eps(myi),...
    upperCvdMatrix.data_ydiffU.taux_eps(myi),...
    upperCvdMatrix.data_cdiffU.taux_eps(myi),...
    upperCvdMatrix.data_idiffU.taux_eps(myi),...
    upperCvdMatrix.nxdivGDPU.taux_eps(myi),...
    upperCvdMatrix.data_HdiffU.taux_eps(myi),...
    upperCvdMatrix.data_wdiffU.taux_eps(myi),...
    upperCvdMatrix.data_qdiffU.taux_eps(myi),...
        upperCvdMatrix.data_ndiffU.taux_eps(myi),...
    upperCvdMatrix.data_spreadU.taux_eps(myi);...
      upperCvdMatrix.data_RU.taumc_eps(myi),...
    upperCvdMatrix.data_picU.taumc_eps(myi),...
    upperCvdMatrix.data_ydiffU.taumc_eps(myi),...
    upperCvdMatrix.data_cdiffU.taumc_eps(myi),...
    upperCvdMatrix.data_idiffU.taumc_eps(myi),...
    upperCvdMatrix.nxdivGDPU.taumc_eps(myi),...
    upperCvdMatrix.data_HdiffU.taumc_eps(myi),...
    upperCvdMatrix.data_wdiffU.taumc_eps(myi),...
    upperCvdMatrix.data_qdiffU.taumc_eps(myi),...
        upperCvdMatrix.data_ndiffU.taumc_eps(myi),...
    upperCvdMatrix.data_spreadU.taumc_eps(myi);...
      upperCvdMatrix.data_RU.taumi_eps(myi),...
    upperCvdMatrix.data_picU.taumi_eps(myi),...
    upperCvdMatrix.data_ydiffU.taumi_eps(myi),...
    upperCvdMatrix.data_cdiffU.taumi_eps(myi),...
    upperCvdMatrix.data_idiffU.taumi_eps(myi),...
    upperCvdMatrix.nxdivGDPU.taumi_eps(myi),...
    upperCvdMatrix.data_HdiffU.taumi_eps(myi),...
    upperCvdMatrix.data_wdiffU.taumi_eps(myi),...
    upperCvdMatrix.data_qdiffU.taumi_eps(myi),...
        upperCvdMatrix.data_ndiffU.taumi_eps(myi),...
    upperCvdMatrix.data_spreadU.taumi_eps(myi);...
      upperCvdMatrix.data_RU.taumx_eps(myi),...
    upperCvdMatrix.data_picU.taumx_eps(myi),...
    upperCvdMatrix.data_ydiffU.taumx_eps(myi),...
    upperCvdMatrix.data_cdiffU.taumx_eps(myi),...
    upperCvdMatrix.data_idiffU.taumx_eps(myi),...
    upperCvdMatrix.nxdivGDPU.taumx_eps(myi),...
    upperCvdMatrix.data_HdiffU.taumx_eps(myi),...
    upperCvdMatrix.data_wdiffU.taumx_eps(myi),...
    upperCvdMatrix.data_qdiffU.taumx_eps(myi),...
        upperCvdMatrix.data_ndiffU.taumx_eps(myi),...
    upperCvdMatrix.data_spreadU.taumx_eps(myi);...
    upperCvdMatrix.data_RU.gamma_eps(myi),...
    upperCvdMatrix.data_picU.gamma_eps(myi),...
    upperCvdMatrix.data_ydiffU.gamma_eps(myi),...
    upperCvdMatrix.data_cdiffU.gamma_eps(myi),...
    upperCvdMatrix.data_idiffU.gamma_eps(myi),...
    upperCvdMatrix.nxdivGDPU.gamma_eps(myi),...
    upperCvdMatrix.data_HdiffU.gamma_eps(myi),...
    upperCvdMatrix.data_wdiffU.gamma_eps(myi),...
    upperCvdMatrix.data_qdiffU.gamma_eps(myi),...
        upperCvdMatrix.data_ndiffU.gamma_eps(myi),...
    upperCvdMatrix.data_spreadU.gamma_eps(myi);...
    upperCvdMatrix.data_RU.phitilde_eps(myi),...
    upperCvdMatrix.data_picU.phitilde_eps(myi),...
    upperCvdMatrix.data_ydiffU.phitilde_eps(myi),...
    upperCvdMatrix.data_cdiffU.phitilde_eps(myi),...
    upperCvdMatrix.data_idiffU.phitilde_eps(myi),...
    upperCvdMatrix.nxdivGDPU.phitilde_eps(myi),...
    upperCvdMatrix.data_HdiffU.phitilde_eps(myi),...
    upperCvdMatrix.data_wdiffU.phitilde_eps(myi),...
    upperCvdMatrix.data_qdiffU.phitilde_eps(myi),...
        upperCvdMatrix.data_ndiffU.phitilde_eps(myi),...
    upperCvdMatrix.data_spreadU.phitilde_eps(myi);...
    upperCvdMatrix.data_RU.muz_eps(myi),...
    upperCvdMatrix.data_picU.muz_eps(myi),...
    upperCvdMatrix.data_ydiffU.muz_eps(myi),...
    upperCvdMatrix.data_cdiffU.muz_eps(myi),...
    upperCvdMatrix.data_idiffU.muz_eps(myi),...
    upperCvdMatrix.nxdivGDPU.muz_eps(myi),...
    upperCvdMatrix.data_HdiffU.muz_eps(myi),...
    upperCvdMatrix.data_wdiffU.muz_eps(myi),...
    upperCvdMatrix.data_qdiffU.muz_eps(myi),... 
        upperCvdMatrix.data_ndiffU.muz_eps(myi),...
    upperCvdMatrix.data_spreadU.muz_eps(myi);...
     upperCvdMatrix.data_RU.Rstar_eps(myi),...
     upperCvdMatrix.data_picU.Rstar_eps(myi),...
     upperCvdMatrix.data_ydiffU.Rstar_eps(myi),...
     upperCvdMatrix.data_cdiffU.Rstar_eps(myi),...
     upperCvdMatrix.data_idiffU.Rstar_eps(myi),...
     upperCvdMatrix.nxdivGDPU.Rstar_eps(myi),...
     upperCvdMatrix.data_HdiffU.Rstar_eps(myi),...
     upperCvdMatrix.data_wdiffU.Rstar_eps(myi),...
     upperCvdMatrix.data_qdiffU.Rstar_eps(myi),...
   upperCvdMatrix.data_ndiffU.Rstar_eps(myi),...
   upperCvdMatrix.data_spreadU.Rstar_eps(myi);...
       upperCvdMatrix.data_RU.ystar_eps(myi),...
     upperCvdMatrix.data_picU.ystar_eps(myi),...
     upperCvdMatrix.data_ydiffU.ystar_eps(myi),...
     upperCvdMatrix.data_cdiffU.ystar_eps(myi),...
     upperCvdMatrix.data_idiffU.ystar_eps(myi),...
     upperCvdMatrix.nxdivGDPU.ystar_eps(myi),...
     upperCvdMatrix.data_HdiffU.ystar_eps(myi),...
     upperCvdMatrix.data_wdiffU.ystar_eps(myi),...
     upperCvdMatrix.data_qdiffU.ystar_eps(myi),...
   upperCvdMatrix.data_ndiffU.ystar_eps(myi),...
   upperCvdMatrix.data_spreadU.ystar_eps(myi);...
     upperCvdMatrix.data_RU.pistar_eps(myi),...
     upperCvdMatrix.data_picU.pistar_eps(myi),...
     upperCvdMatrix.data_ydiffU.pistar_eps(myi),...
     upperCvdMatrix.data_cdiffU.pistar_eps(myi),...
     upperCvdMatrix.data_idiffU.pistar_eps(myi),...
     upperCvdMatrix.nxdivGDPU.pistar_eps(myi),...
     upperCvdMatrix.data_HdiffU.pistar_eps(myi),...
     upperCvdMatrix.data_wdiffU.pistar_eps(myi),...
     upperCvdMatrix.data_qdiffU.pistar_eps(myi),...
   upperCvdMatrix.data_ndiffU.pistar_eps(myi),...
   upperCvdMatrix.data_spreadU.pistar_eps(myi);...
%%%%%%%%%  5 foreign %%%%%%%%%%%%%%%%%%%
    sum([upperCvdMatrix.data_RU.muz_eps(myi),upperCvdMatrix.data_RU.phitilde_eps(myi),upperCvdMatrix.data_RU.Rstar_eps(myi),upperCvdMatrix.data_RU.pistar_eps(myi),upperCvdMatrix.data_RU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_picU.muz_eps(myi),upperCvdMatrix.data_picU.phitilde_eps(myi),upperCvdMatrix.data_picU.Rstar_eps(myi),upperCvdMatrix.data_picU.pistar_eps(myi),upperCvdMatrix.data_picU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_ydiffU.muz_eps(myi),upperCvdMatrix.data_ydiffU.phitilde_eps(myi),upperCvdMatrix.data_ydiffU.Rstar_eps(myi),upperCvdMatrix.data_ydiffU.pistar_eps(myi),upperCvdMatrix.data_ydiffU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_cdiffU.muz_eps(myi),upperCvdMatrix.data_cdiffU.phitilde_eps(myi),upperCvdMatrix.data_cdiffU.Rstar_eps(myi),upperCvdMatrix.data_cdiffU.pistar_eps(myi),upperCvdMatrix.data_cdiffU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_idiffU.muz_eps(myi),upperCvdMatrix.data_idiffU.phitilde_eps(myi),upperCvdMatrix.data_idiffU.Rstar_eps(myi),upperCvdMatrix.data_idiffU.pistar_eps(myi),upperCvdMatrix.data_idiffU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.nxdivGDPU.muz_eps(myi),upperCvdMatrix.nxdivGDPU.phitilde_eps(myi),upperCvdMatrix.nxdivGDPU.Rstar_eps(myi),upperCvdMatrix.nxdivGDPU.pistar_eps(myi),upperCvdMatrix.nxdivGDPU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_HdiffU.muz_eps(myi),upperCvdMatrix.data_HdiffU.phitilde_eps(myi),upperCvdMatrix.data_HdiffU.Rstar_eps(myi),upperCvdMatrix.data_HdiffU.pistar_eps(myi),upperCvdMatrix.data_HdiffU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_wdiffU.muz_eps(myi),upperCvdMatrix.data_wdiffU.phitilde_eps(myi),upperCvdMatrix.data_wdiffU.Rstar_eps(myi),upperCvdMatrix.data_wdiffU.pistar_eps(myi),upperCvdMatrix.data_wdiffU.ystar_eps(myi)]),...
    sum([upperCvdMatrix.data_qdiffU.muz_eps(myi),upperCvdMatrix.data_qdiffU.phitilde_eps(myi),upperCvdMatrix.data_qdiffU.Rstar_eps(myi),upperCvdMatrix.data_qdiffU.pistar_eps(myi),upperCvdMatrix.data_qdiffU.ystar_eps(myi)]),...
sum([upperCvdMatrix.data_ndiffU.muz_eps(myi),upperCvdMatrix.data_ndiffU.phitilde_eps(myi),upperCvdMatrix.data_ndiffU.Rstar_eps(myi),upperCvdMatrix.data_ndiffU.pistar_eps(myi),upperCvdMatrix.data_ndiffU.ystar_eps(myi)]),...
sum([upperCvdMatrix.data_spreadU.muz_eps(myi),upperCvdMatrix.data_spreadU.phitilde_eps(myi),upperCvdMatrix.data_spreadU.Rstar_eps(myi),upperCvdMatrix.data_spreadU.pistar_eps(myi),upperCvdMatrix.data_spreadU.ystar_eps(myi)]);...
%%%%%%%%%  all foreign %%%%%%%%%%%%%%%%%%%
    sum([upperCvdMatrix.data_RU.muz_eps(myi),upperCvdMatrix.data_RU.phitilde_eps(myi),upperCvdMatrix.data_RU.Rstar_eps(myi),upperCvdMatrix.data_RU.pistar_eps(myi),upperCvdMatrix.data_RU.ystar_eps(myi),upperCvdMatrix.data_RU.taumc_eps(myi),upperCvdMatrix.data_RU.taumi_eps(myi),upperCvdMatrix.data_RU.taumx_eps(myi),upperCvdMatrix.data_RU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_picU.muz_eps(myi),upperCvdMatrix.data_picU.phitilde_eps(myi),upperCvdMatrix.data_picU.Rstar_eps(myi),upperCvdMatrix.data_picU.pistar_eps(myi),upperCvdMatrix.data_picU.ystar_eps(myi),upperCvdMatrix.data_picU.taumc_eps(myi),upperCvdMatrix.data_picU.taumi_eps(myi),upperCvdMatrix.data_picU.taumx_eps(myi),upperCvdMatrix.data_picU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_ydiffU.muz_eps(myi),upperCvdMatrix.data_ydiffU.phitilde_eps(myi),upperCvdMatrix.data_ydiffU.Rstar_eps(myi),upperCvdMatrix.data_ydiffU.pistar_eps(myi),upperCvdMatrix.data_ydiffU.ystar_eps(myi),upperCvdMatrix.data_ydiffU.taumc_eps(myi),upperCvdMatrix.data_ydiffU.taumi_eps(myi),upperCvdMatrix.data_ydiffU.taumx_eps(myi),upperCvdMatrix.data_ydiffU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_cdiffU.muz_eps(myi),upperCvdMatrix.data_cdiffU.phitilde_eps(myi),upperCvdMatrix.data_cdiffU.Rstar_eps(myi),upperCvdMatrix.data_cdiffU.pistar_eps(myi),upperCvdMatrix.data_cdiffU.ystar_eps(myi),upperCvdMatrix.data_cdiffU.taumc_eps(myi),upperCvdMatrix.data_cdiffU.taumi_eps(myi),upperCvdMatrix.data_cdiffU.taumx_eps(myi),upperCvdMatrix.data_cdiffU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_idiffU.muz_eps(myi),upperCvdMatrix.data_idiffU.phitilde_eps(myi),upperCvdMatrix.data_idiffU.Rstar_eps(myi),upperCvdMatrix.data_idiffU.pistar_eps(myi),upperCvdMatrix.data_idiffU.ystar_eps(myi),upperCvdMatrix.data_idiffU.taumc_eps(myi),upperCvdMatrix.data_idiffU.taumi_eps(myi),upperCvdMatrix.data_idiffU.taumx_eps(myi),upperCvdMatrix.data_idiffU.taux_eps(myi)]),...
    sum([upperCvdMatrix.nxdivGDPU.muz_eps(myi),upperCvdMatrix.nxdivGDPU.phitilde_eps(myi),upperCvdMatrix.nxdivGDPU.Rstar_eps(myi),upperCvdMatrix.nxdivGDPU.pistar_eps(myi),upperCvdMatrix.nxdivGDPU.ystar_eps(myi),upperCvdMatrix.nxdivGDPU.taumc_eps(myi),upperCvdMatrix.nxdivGDPU.taumi_eps(myi),upperCvdMatrix.nxdivGDPU.taumx_eps(myi),upperCvdMatrix.nxdivGDPU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_HdiffU.muz_eps(myi),upperCvdMatrix.data_HdiffU.phitilde_eps(myi),upperCvdMatrix.data_HdiffU.Rstar_eps(myi),upperCvdMatrix.data_HdiffU.pistar_eps(myi),upperCvdMatrix.data_HdiffU.ystar_eps(myi),upperCvdMatrix.data_HdiffU.taumc_eps(myi),upperCvdMatrix.data_HdiffU.taumi_eps(myi),upperCvdMatrix.data_HdiffU.taumx_eps(myi),upperCvdMatrix.data_HdiffU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_wdiffU.muz_eps(myi),upperCvdMatrix.data_wdiffU.phitilde_eps(myi),upperCvdMatrix.data_wdiffU.Rstar_eps(myi),upperCvdMatrix.data_wdiffU.pistar_eps(myi),upperCvdMatrix.data_wdiffU.ystar_eps(myi),upperCvdMatrix.data_wdiffU.taumc_eps(myi),upperCvdMatrix.data_wdiffU.taumi_eps(myi),upperCvdMatrix.data_wdiffU.taumx_eps(myi),upperCvdMatrix.data_wdiffU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_qdiffU.muz_eps(myi),upperCvdMatrix.data_qdiffU.phitilde_eps(myi),upperCvdMatrix.data_qdiffU.Rstar_eps(myi),upperCvdMatrix.data_qdiffU.pistar_eps(myi),upperCvdMatrix.data_qdiffU.ystar_eps(myi),upperCvdMatrix.data_qdiffU.taumc_eps(myi),upperCvdMatrix.data_qdiffU.taumi_eps(myi),upperCvdMatrix.data_qdiffU.taumx_eps(myi),upperCvdMatrix.data_qdiffU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_ndiffU.muz_eps(myi),upperCvdMatrix.data_ndiffU.phitilde_eps(myi),upperCvdMatrix.data_ndiffU.Rstar_eps(myi),upperCvdMatrix.data_ndiffU.pistar_eps(myi),upperCvdMatrix.data_ndiffU.ystar_eps(myi),upperCvdMatrix.data_ndiffU.taumc_eps(myi),upperCvdMatrix.data_ndiffU.taumi_eps(myi),upperCvdMatrix.data_ndiffU.taumx_eps(myi),upperCvdMatrix.data_ndiffU.taux_eps(myi)]),...
    sum([upperCvdMatrix.data_spreadU.muz_eps(myi),upperCvdMatrix.data_spreadU.phitilde_eps(myi),upperCvdMatrix.data_spreadU.Rstar_eps(myi),upperCvdMatrix.data_spreadU.pistar_eps(myi),upperCvdMatrix.data_spreadU.ystar_eps(myi),upperCvdMatrix.data_spreadU.taumc_eps(myi),upperCvdMatrix.data_spreadU.taumi_eps(myi),upperCvdMatrix.data_spreadU.taumx_eps(myi),upperCvdMatrix.data_spreadU.taux_eps(myi)]);...
    ];
end 
% 8 year horizon
% squeeze(round(meanCvdSelected(3,:,:)*1000)/10)  % in percent
% round(lowerCvdSelected(3,:,:)*1000)/10
% round(upperCvdSelected(3,:,:)*1000)/10

myHorizon={'1','4','8','20'};

% mean cvd
for myI=1:length(myHorizon)
    myCvdMatrix=squeeze(meanCvdSelected(myI,:,:)*100);
    for myJ=1:size(myCvdMatrix,1)
        matrix2latex(myCvdMatrix(myJ,:),[myLatexPath '\FMeanCvd_' myHorizon{myI} '_' num2str(myJ) '.tex'],'format', '%-6.1f');
    end
end

% HPD int.
for myI=1:length(myHorizon)
    myCvdMatrix1=squeeze(lowerCvdSelected(myI,:,:)*100);
    myCvdMatrix2=squeeze(upperCvdSelected(myI,:,:)*100);
    myHPDIntMat=[myCvdMatrix1;myCvdMatrix2];
    myHPDIntMat=reshape(myHPDIntMat(:),size(myCvdMatrix1,1),[]);
    for myJ=1:size(myCvdMatrix,1)
        matrix2latex(myHPDIntMat(myJ,:),[myLatexPath '\FHPDCvd_' myHorizon{myI} '_' num2str(myJ) '.tex'],'format', '%-6.1f');
    end
end

%%%%%%%%%%%% h-step ahead forecasts %%%%%%%%%%%%%%%%%%%%%
% plot(data_picU)
% hold on  
% plot([nan(1,1);oo_.Filtered_Variables_1_step_ahead.Mean.data_picU],':k','linewidth',2)
% plot([nan(4,1);oo_.Filtered_Variables_2_step_ahead.Mean.data_picU],'-.k','linewidth',2)
% plot([nan(8,1);oo_.Filtered_Variables_3_step_ahead.Mean.data_picU],'--k','linewidth',2)
% plot([nan(12,1);oo_.Filtered_Variables_4_step_ahead.Mean.data_picU],'ok','linewidth',2)
% hold off

%%%%%%%%%%%%%% data_picU %%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%% Random walk benchmark %%%%%%%%%%%%%%%%%%%
% 1-steap ahead error
RMSE1stepRW_data_picU = sqrt(mean((data_picU(1+1:end) - data_picU(1:end-1)).^2));
MAE1stepRW_data_picU = mean(abs(data_picU(1+1:end) - data_picU(1:end-1)));

% 4-steap ahead error
RMSE4stepRW_data_picU = sqrt(mean((data_picU(1+4:end) - data_picU(1:end-4)).^2));
MAE4stepRW_data_picU = mean(abs(data_picU(1+4:end) - data_picU(1:end-4)));

% 8-steap ahead error
RMSE8stepRW_data_picU = sqrt(mean((data_picU(1+8:end) - data_picU(1:end-8)).^2));
MAE8stepRW_data_picU = mean(abs(data_picU(1+8:end) - data_picU(1:end-8)));

% 12-steap ahead error
RMSE12stepRW_data_picU = sqrt(mean((data_picU(1+12:end) - data_picU(1:end-12)).^2));
MAE12stepRW_data_picU = mean(abs(data_picU(1+12:end) - data_picU(1:end-12)));

%%% note the address of the variable - depends on the varlist after
%%% the estimation
% Baseline CPI forecasts
data_picUBForecasts = squeeze(oo_.FilteredVariablesKStepAhead(:,nbefore+12,:));

% plot(data_picU)
% hold on  
% plot([nan(1,1),data_picUForecasts(1,:)],':k','linewidth',2)
% plot([nan(1,4),data_picUForecasts(2,:)],'-.k','linewidth',2)
% plot([nan(1,8),data_picUForecasts(3,:)],'--k','linewidth',2)
% plot([nan(1,12),data_picUForecasts(4,:)],'ok','linewidth',2)
% hold off

% 1-steap ahead error
RMSE1stepB_data_picU = sqrt(mean((data_picU(1+1:end) - data_picUBForecasts(1,1+1:end-12)').^2));
MAE1stepB_data_picU = mean(abs(data_picU(1+1:end) - data_picUBForecasts(1,1+1:end-12)'));

% 4-steap ahead error
RMSE4stepB_data_picU = sqrt(mean((data_picU(1+4:end) - data_picUBForecasts(2,1+4:end-12)').^2));
MAE4stepB_data_picU = mean(abs(data_picU(1+4:end) - data_picUBForecasts(2,1+4:end-12)'));

% 8-steap ahead error
RMSE8stepB_data_picU = sqrt(mean((data_picU(1+8:end) - data_picUBForecasts(3,1+8:end-12)').^2));
MAE8stepB_data_picU = mean(abs(data_picU(1+8:end) - data_picUBForecasts(3,1+8:end-12)'));

% 12-steap ahead error
RMSE12stepB_data_picU = sqrt(mean((data_picU(1+12:end) - data_picUBForecasts(4,1+12:end-12)').^2));
MAE12stepB_data_picU = mean(abs(data_picU(1+12:end) - data_picUBForecasts(4,1+12:end-12)'));

matrix2latexNS(RMSE1stepB_data_picU/RMSE1stepRW_data_picU,[myLatexPath '\RMSE1stepB_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE4stepB_data_picU/RMSE4stepRW_data_picU,[myLatexPath '\RMSE4stepB_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE8stepB_data_picU/RMSE8stepRW_data_picU,[myLatexPath '\RMSE8stepB_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE12stepB_data_picU/RMSE12stepRW_data_picU,[myLatexPath '\RMSE12stepB_data_picU'  '.tex'],'format', '%-6.2f');

matrix2latexNS(MAE1stepB_data_picU/MAE1stepRW_data_picU,[myLatexPath '\MAE1stepB_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE4stepB_data_picU/MAE4stepRW_data_picU,[myLatexPath '\MAE4stepB_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE8stepB_data_picU/MAE8stepRW_data_picU,[myLatexPath '\MAE8stepB_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE12stepB_data_picU/MAE12stepRW_data_picU,[myLatexPath '\MAE12stepB_data_picU'  '.tex'],'format', '%-6.2f');

% BSVAR CPI forecasts
% 
data_picUSVARForecasts = squeeze(HomeSVAR_oo_.FilteredVariablesKStepAhead(:,3,:)); % watch out of the ordering of vars 

% plot(data_picU)
% hold on  
% plot([nan(1,1),data_picUSVARForecasts(1,:)],':k','linewidth',2)
% plot([nan(1,4),data_picUSVARForecasts(2,:)],'-.k','linewidth',2)
% plot([nan(1,8),data_picUSVARForecasts(3,:)],'--k','linewidth',2)
% plot([nan(1,12),data_picUSVARForecasts(4,:)],'ok','linewidth',2)
% hold off

% 1-steap ahead error
RMSE1stepSVAR_data_picU = sqrt(mean((data_picU(1+1:end) - data_picUSVARForecasts(1,1+1:end-12)').^2));
MAE1stepSVAR_data_picU = mean(abs(data_picU(1+1:end) - data_picUSVARForecasts(1,1+1:end-12)'));

% 4-steap ahead error
RMSE4stepSVAR_data_picU = sqrt(mean((data_picU(1+4:end) - data_picUSVARForecasts(2,1+4:end-12)').^2));
MAE4stepSVAR_data_picU = mean(abs(data_picU(1+4:end) - data_picUSVARForecasts(2,1+4:end-12)'));

% 8-steap ahead error
RMSE8stepSVAR_data_picU = sqrt(mean((data_picU(1+8:end) - data_picUSVARForecasts(3,1+8:end-12)').^2));
MAE8stepSVAR_data_picU = mean(abs(data_picU(1+8:end) - data_picUSVARForecasts(3,1+8:end-12)'));

% 12-steap ahead error
RMSE12stepSVAR_data_picU = sqrt(mean((data_picU(1+12:end) - data_picUSVARForecasts(4,1+12:end-12)').^2));
MAE12stepSVAR_data_picU = mean(abs(data_picU(1+12:end) - data_picUSVARForecasts(4,1+12:end-12)'));

matrix2latexNS(RMSE1stepSVAR_data_picU/RMSE1stepRW_data_picU,[myLatexPath '\RMSE1stepSVAR_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE4stepSVAR_data_picU/RMSE4stepRW_data_picU,[myLatexPath '\RMSE4stepSVAR_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE8stepSVAR_data_picU/RMSE8stepRW_data_picU,[myLatexPath '\RMSE8stepSVAR_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE12stepSVAR_data_picU/RMSE12stepRW_data_picU,[myLatexPath '\RMSE12stepSVAR_data_picU'  '.tex'],'format', '%-6.2f');

matrix2latexNS(MAE1stepSVAR_data_picU/MAE1stepRW_data_picU,[myLatexPath '\MAE1stepSVAR_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE4stepSVAR_data_picU/MAE4stepRW_data_picU,[myLatexPath '\MAE4stepSVAR_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE8stepSVAR_data_picU/MAE8stepRW_data_picU,[myLatexPath '\MAE8stepSVAR_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE12stepSVAR_data_picU/MAE12stepRW_data_picU,[myLatexPath '\MAE12stepSVAR_data_picU'  '.tex'],'format', '%-6.2f');



%%%% Last myfx quarters %%%%%
myfx=40; % last 40q or 10 years

%%%%%%%%%% Random walk benchmark %%%%%%%%%%%%%%%%%%%
% 1-steap ahead error
RMSE1stepRW_data_picUmyfx = sqrt(mean((data_picU(1+end-myfx:end) - data_picU(end-myfx:end-1)).^2));
MAE1stepRW_data_picUmyfx = mean(abs(data_picU(1+end-myfx:end) - data_picU(end-myfx:end-1)));

% 4-steap ahead error
RMSE4stepRW_data_picUmyfx = sqrt(mean((data_picU(end-myfx+4:end) - data_picU(end-myfx:end-4)).^2));
MAE4stepRW_data_picUmyfx = mean(abs(data_picU(end-myfx+4:end) - data_picU(end-myfx:end-4)));

% 8-steap ahead error
RMSE8stepRW_data_picUmyfx = sqrt(mean((data_picU(end-myfx+8:end) - data_picU(end-myfx:end-8)).^2));
MAE8stepRW_data_picUmyfx = mean(abs(data_picU(end-myfx+8:end) - data_picU(end-myfx:end-8)));

% 12-steap ahead error
RMSE12stepRW_data_picUmyfx = sqrt(mean((data_picU(end-myfx+12:end) - data_picU(end-myfx:end-12)).^2));
MAE12stepRW_data_picUmyfx = mean(abs(data_picU(end-myfx+12:end) - data_picU(end-myfx:end-12)));

%%% note the address of the variable - depends on the varlist after
%%% the estimation
data_picUBForecasts = squeeze(oo_.FilteredVariablesKStepAhead(:,nbefore+12,:));

% plot(data_picU)
% hold on  
% plot([nan(1,1),data_picUForecasts(1,:)],':k','linewidth',2)
% plot([nan(1,4),data_picUForecasts(2,:)],'-.k','linewidth',2)
% plot([nan(1,8),data_picUForecasts(3,:)],'--k','linewidth',2)
% plot([nan(1,12),data_picUForecasts(4,:)],'ok','linewidth',2)
% hold off

% 1-steap ahead error
RMSE1stepB_data_picUmyfx = sqrt(mean((data_picU(end-myfx+1:end) - data_picUBForecasts(1,end-myfx-12+1:end-12)').^2));
MAE1stepB_data_picUmyfx = mean(abs(data_picU(end-myfx+1:end) - data_picUBForecasts(1,end-myfx-12+1:end-12)'));

% 4-steap ahead error
RMSE4stepB_data_picUmyfx = sqrt(mean((data_picU(end-myfx+4:end) - data_picUBForecasts(2,end-myfx-12+4:end-12)').^2));
MAE4stepB_data_picUmyfx = mean(abs(data_picU(end-myfx+4:end) - data_picUBForecasts(2,end-myfx-12+4:end-12)'));

% 8-steap ahead error
RMSE8stepB_data_picUmyfx = sqrt(mean((data_picU(end-myfx+8:end) - data_picUBForecasts(3,end-myfx-12+8:end-12)').^2));
MAE8stepB_data_picUmyfx = mean(abs(data_picU(end-myfx+8:end) - data_picUBForecasts(3,end-myfx-12+8:end-12)'));

% 12-steap ahead error
RMSE12stepB_data_picUmyfx = sqrt(mean((data_picU(end-myfx+12:end) - data_picUBForecasts(4,end-myfx-12+12:end-12)').^2));
MAE12stepB_data_picUmyfx = mean(abs(data_picU(end-myfx+12:end) - data_picUBForecasts(4,end-myfx-12+12:end-12)'));

matrix2latexNS(RMSE1stepB_data_picUmyfx/RMSE1stepRW_data_picUmyfx,[myLatexPath '\RMSE1stepB_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE4stepB_data_picUmyfx/RMSE4stepRW_data_picUmyfx,[myLatexPath '\RMSE4stepB_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE8stepB_data_picUmyfx/RMSE8stepRW_data_picUmyfx,[myLatexPath '\RMSE8stepB_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE12stepB_data_picUmyfx/RMSE12stepRW_data_picUmyfx,[myLatexPath '\RMSE12stepB_data_picUmyfx'  '.tex'],'format', '%-6.2f');

matrix2latexNS(MAE1stepB_data_picUmyfx/MAE1stepRW_data_picUmyfx,[myLatexPath '\MAE1stepB_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE4stepB_data_picUmyfx/MAE4stepRW_data_picUmyfx,[myLatexPath '\MAE4stepB_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE8stepB_data_picUmyfx/MAE8stepRW_data_picUmyfx,[myLatexPath '\MAE8stepB_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE12stepB_data_picUmyfx/MAE12stepRW_data_picUmyfx,[myLatexPath '\MAE12stepB_data_picUmyfx'  '.tex'],'format', '%-6.2f');

% SVAR short

data_picUSVARForecasts = squeeze(HomeSVAR_oo_.FilteredVariablesKStepAhead(:,3,:));

% plot(data_picU)
% hold on  
% plot([nan(1,1),data_picUSVARForecasts(1,:)],':k','linewidth',2)
% plot([nan(1,4),data_picUSVARForecasts(2,:)],'-.k','linewidth',2)
% plot([nan(1,8),data_picUSVARForecasts(3,:)],'--k','linewidth',2)
% plot([nan(1,12),data_picUSVARForecasts(4,:)],'ok','linewidth',2)
% hold off

% 1-steap ahead error
RMSE1stepSVAR_data_picUmyfx = sqrt(mean((data_picU(end-myfx+1:end) - data_picUSVARForecasts(1,end-myfx-12+1:end-12)').^2));
MAE1stepSVAR_data_picUmyfx = mean(abs(data_picU(end-myfx+1:end) - data_picUSVARForecasts(1,end-myfx-12+1:end-12)'));

% 4-steap ahead error
RMSE4stepSVAR_data_picUmyfx = sqrt(mean((data_picU(end-myfx+4:end) - data_picUSVARForecasts(2,end-myfx-12+4:end-12)').^2));
MAE4stepSVAR_data_picUmyfx = mean(abs(data_picU(end-myfx+4:end) - data_picUSVARForecasts(2,end-myfx-12+4:end-12)'));

% 8-steap ahead error
RMSE8stepSVAR_data_picUmyfx = sqrt(mean((data_picU(end-myfx+8:end) - data_picUSVARForecasts(3,end-myfx-12+8:end-12)').^2));
MAE8stepSVAR_data_picUmyfx = mean(abs(data_picU(end-myfx+8:end) - data_picUSVARForecasts(3,end-myfx-12+8:end-12)'));

% 12-steap ahead error
RMSE12stepSVAR_data_picUmyfx = sqrt(mean((data_picU(end-myfx+12:end) - data_picUSVARForecasts(4,end-myfx-12+12:end-12)').^2));
MAE12stepSVAR_data_picUmyfx = mean(abs(data_picU(end-myfx+12:end) - data_picUSVARForecasts(4,end-myfx-12+12:end-12)'));

matrix2latexNS(RMSE1stepSVAR_data_picUmyfx/RMSE1stepRW_data_picUmyfx,[myLatexPath '\RMSE1stepSVAR_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE4stepSVAR_data_picUmyfx/RMSE4stepRW_data_picUmyfx,[myLatexPath '\RMSE4stepSVAR_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE8stepSVAR_data_picUmyfx/RMSE8stepRW_data_picUmyfx,[myLatexPath '\RMSE8stepSVAR_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE12stepSVAR_data_picUmyfx/RMSE12stepRW_data_picUmyfx,[myLatexPath '\RMSE12stepSVAR_data_picUmyfx'  '.tex'],'format', '%-6.2f');

matrix2latexNS(MAE1stepSVAR_data_picUmyfx/MAE1stepRW_data_picUmyfx,[myLatexPath '\MAE1stepSVAR_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE4stepSVAR_data_picUmyfx/MAE4stepRW_data_picUmyfx,[myLatexPath '\MAE4stepSVAR_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE8stepSVAR_data_picUmyfx/MAE8stepRW_data_picUmyfx,[myLatexPath '\MAE8stepSVAR_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE12stepSVAR_data_picUmyfx/MAE12stepRW_data_picUmyfx,[myLatexPath '\MAE12stepSVAR_data_picUmyfx'  '.tex'],'format', '%-6.2f');



%%%%%% finfric %%%%%%%%%%%%%

%%% note the address of the variable - depends on the varlist after
%%% the estimation
data_picUFForecasts = squeeze(finfric_oo_.FilteredVariablesKStepAhead(:,fnbefore+1+12,:));


% 1-steap ahead error
RMSE1stepF_data_picU = sqrt(mean((data_picU(1+1:end) - data_picUFForecasts(1,1+1:end-12)').^2));
MAE1stepF_data_picU = mean(abs(data_picU(1+1:end) - data_picUFForecasts(1,1+1:end-12)'));

% 4-steap ahead error
RMSE4stepF_data_picU = sqrt(mean((data_picU(1+4:end) - data_picUFForecasts(2,1+4:end-12)').^2));
MAE4stepF_data_picU = mean(abs(data_picU(1+4:end) - data_picUFForecasts(2,1+4:end-12)'));

% 8-steap ahead error
RMSE8stepF_data_picU = sqrt(mean((data_picU(1+8:end) - data_picUFForecasts(3,1+8:end-12)').^2));
MAE8stepF_data_picU = mean(abs(data_picU(1+8:end) - data_picUFForecasts(3,1+8:end-12)'));

% 12-steap ahead error
RMSE12stepF_data_picU = sqrt(mean((data_picU(1+12:end) - data_picUFForecasts(4,1+12:end-12)').^2));
MAE12stepF_data_picU = mean(abs(data_picU(1+12:end) - data_picUFForecasts(4,1+12:end-12)'));

matrix2latexNS(RMSE1stepF_data_picU/RMSE1stepRW_data_picU,[myLatexPath '\RMSE1stepF_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE4stepF_data_picU/RMSE4stepRW_data_picU,[myLatexPath '\RMSE4stepF_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE8stepF_data_picU/RMSE8stepRW_data_picU,[myLatexPath '\RMSE8stepF_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE12stepF_data_picU/RMSE12stepRW_data_picU,[myLatexPath '\RMSE12stepF_data_picU'  '.tex'],'format', '%-6.2f');

matrix2latexNS(MAE1stepF_data_picU/MAE1stepRW_data_picU,[myLatexPath '\MAE1stepF_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE4stepF_data_picU/MAE4stepRW_data_picU,[myLatexPath '\MAE4stepF_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE8stepF_data_picU/MAE8stepRW_data_picU,[myLatexPath '\MAE8stepF_data_picU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE12stepF_data_picU/MAE12stepRW_data_picU,[myLatexPath '\MAE12stepF_data_picU'  '.tex'],'format', '%-6.2f');


%%% last 10 years %%%

% 1-steap ahead error
RMSE1stepF_data_picUmyfx = sqrt(mean((data_picU(end-myfx+1:end) - data_picUFForecasts(1,end-myfx-12+1:end-12)').^2));
MAE1stepF_data_picUmyfx = mean(abs(data_picU(end-myfx+1:end) - data_picUFForecasts(1,end-myfx-12+1:end-12)'));

% 4-steap ahead error
RMSE4stepF_data_picUmyfx = sqrt(mean((data_picU(end-myfx+4:end) - data_picUFForecasts(2,end-myfx-12+4:end-12)').^2));
MAE4stepF_data_picUmyfx = mean(abs(data_picU(end-myfx+4:end) - data_picUFForecasts(2,end-myfx-12+4:end-12)'));

% 8-steap ahead error
RMSE8stepF_data_picUmyfx = sqrt(mean((data_picU(end-myfx+8:end) - data_picUFForecasts(3,end-myfx-12+8:end-12)').^2));
MAE8stepF_data_picUmyfx = mean(abs(data_picU(end-myfx+8:end) - data_picUFForecasts(3,end-myfx-12+8:end-12)'));

% 12-steap ahead error
RMSE12stepF_data_picUmyfx = sqrt(mean((data_picU(end-myfx+12:end) - data_picUFForecasts(4,end-myfx-12+12:end-12)').^2));
MAE12stepF_data_picUmyfx = mean(abs(data_picU(end-myfx+12:end) - data_picUFForecasts(4,end-myfx-12+12:end-12)'));

matrix2latexNS(RMSE1stepF_data_picUmyfx/RMSE1stepRW_data_picUmyfx,[myLatexPath '\RMSE1stepF_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE4stepF_data_picUmyfx/RMSE4stepRW_data_picUmyfx,[myLatexPath '\RMSE4stepF_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE8stepF_data_picUmyfx/RMSE8stepRW_data_picUmyfx,[myLatexPath '\RMSE8stepF_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE12stepF_data_picUmyfx/RMSE12stepRW_data_picUmyfx,[myLatexPath '\RMSE12stepF_data_picUmyfx'  '.tex'],'format', '%-6.2f');

matrix2latexNS(MAE1stepF_data_picUmyfx/MAE1stepRW_data_picUmyfx,[myLatexPath '\MAE1stepF_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE4stepF_data_picUmyfx/MAE4stepRW_data_picUmyfx,[myLatexPath '\MAE4stepF_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE8stepF_data_picUmyfx/MAE8stepRW_data_picUmyfx,[myLatexPath '\MAE8stepF_data_picUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE12stepF_data_picUmyfx/MAE12stepRW_data_picUmyfx,[myLatexPath '\MAE12stepF_data_picUmyfx'  '.tex'],'format', '%-6.2f');




%%%%%%%%%%%%%% data_ydiffU %%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%% Random walk benchmark %%%%%%%%%%%%%%%%%%%
% 1-steap ahead error
RMSE1stepRW_data_ydiffU = sqrt(mean((data_ydiffU(1+1:end) - data_ydiffU(1:end-1)).^2));
MAE1stepRW_data_ydiffU = mean(abs(data_ydiffU(1+1:end) - data_ydiffU(1:end-1)));

% 4-steap ahead error
RMSE4stepRW_data_ydiffU = sqrt(mean((data_ydiffU(1+4:end) - data_ydiffU(1:end-4)).^2));
MAE4stepRW_data_ydiffU = mean(abs(data_ydiffU(1+4:end) - data_ydiffU(1:end-4)));

% 8-steap ahead error
RMSE8stepRW_data_ydiffU = sqrt(mean((data_ydiffU(1+8:end) - data_ydiffU(1:end-8)).^2));
MAE8stepRW_data_ydiffU = mean(abs(data_ydiffU(1+8:end) - data_ydiffU(1:end-8)));

% 12-steap ahead error
RMSE12stepRW_data_ydiffU = sqrt(mean((data_ydiffU(1+12:end) - data_ydiffU(1:end-12)).^2));
MAE12stepRW_data_ydiffU = mean(abs(data_ydiffU(1+12:end) - data_ydiffU(1:end-12)));


data_ydiffUBForecasts = squeeze(oo_.FilteredVariablesKStepAhead(:,nbefore+4,:));

% plot(data_ydiffU)
% hold on  
% plot([nan(1,1),data_ydiffUBForecasts(1,:)],':k','linewidth',2)
% plot([nan(1,4),data_ydiffUBForecasts(2,:)],'-.k','linewidth',2)
% plot([nan(1,8),data_ydiffUBForecasts(3,:)],'--k','linewidth',2)
% plot([nan(1,12),data_ydiffUBForecasts(4,:)],'ok','linewidth',2)
% hold off

% plot(data_ydiffU(1+1:end))
% hold on
% plot(data_ydiffUBForecasts(1,1:end-1-12)','k')

% 1-steap ahead error
RMSE1stepB_data_ydiffU = sqrt(mean((data_ydiffU(1+1:end) - data_ydiffUBForecasts(1,1+ 1:end-12)').^2));
MAE1stepB_data_ydiffU = mean(abs(data_ydiffU(1+1:end) - data_ydiffUBForecasts(1,1+1:end-12)'));

% 4-steap ahead error
RMSE4stepB_data_ydiffU = sqrt(mean((data_ydiffU(1+4:end) - data_ydiffUBForecasts(2,1+4:end-12)').^2));
MAE4stepB_data_ydiffU = mean(abs(data_ydiffU(1+4:end) - data_ydiffUBForecasts(2,1+4:end-12)'));

% 8-steap ahead error
RMSE8stepB_data_ydiffU = sqrt(mean((data_ydiffU(1+8:end) - data_ydiffUBForecasts(3,1+8:end-12)').^2));
MAE8stepB_data_ydiffU = mean(abs(data_ydiffU(1+8:end) - data_ydiffUBForecasts(3,1+8:end-12)'));

% 12-steap ahead error
RMSE12stepB_data_ydiffU = sqrt(mean((data_ydiffU(1+12:end) - data_ydiffUBForecasts(4,1+12:end-12)').^2));
MAE12stepB_data_ydiffU = mean(abs(data_ydiffU(1+12:end) - data_ydiffUBForecasts(4,1+12:end-12)'));

matrix2latexNS(RMSE1stepB_data_ydiffU/RMSE1stepRW_data_ydiffU,[myLatexPath '\RMSE1stepB_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE4stepB_data_ydiffU/RMSE4stepRW_data_ydiffU,[myLatexPath '\RMSE4stepB_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE8stepB_data_ydiffU/RMSE8stepRW_data_ydiffU,[myLatexPath '\RMSE8stepB_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE12stepB_data_ydiffU/RMSE12stepRW_data_ydiffU,[myLatexPath '\RMSE12stepB_data_ydiffU'  '.tex'],'format', '%-6.2f');

matrix2latexNS(MAE1stepB_data_ydiffU/MAE1stepRW_data_ydiffU,[myLatexPath '\MAE1stepB_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE4stepB_data_ydiffU/MAE4stepRW_data_ydiffU,[myLatexPath '\MAE4stepB_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE8stepB_data_ydiffU/MAE8stepRW_data_ydiffU,[myLatexPath '\MAE8stepB_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE12stepB_data_ydiffU/MAE12stepRW_data_ydiffU,[myLatexPath '\MAE12stepB_data_ydiffU'  '.tex'],'format', '%-6.2f');

%%%% Last myfx quarters %%%%%
myfx=40; % last 40q or 10 years

%%%%%%%%%% Random walk benchmark %%%%%%%%%%%%%%%%%%%
% 1-steap ahead error
RMSE1stepRW_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+1:end) - data_ydiffU(end-myfx:end-1)).^2));
MAE1stepRW_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+1:end) - data_ydiffU(end-myfx:end-1)));

% 4-steap ahead error
RMSE4stepRW_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+4:end) - data_ydiffU(end-myfx:end-4)).^2));
MAE4stepRW_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+4:end) - data_ydiffU(end-myfx:end-4)));

% 8-steap ahead error
RMSE8stepRW_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+8:end) - data_ydiffU(end-myfx:end-8)).^2));
MAE8stepRW_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+8:end) - data_ydiffU(end-myfx:end-8)));

% 12-steap ahead error
RMSE12stepRW_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+12:end) - data_ydiffU(end-myfx:end-12)).^2));
MAE12stepRW_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+12:end) - data_ydiffU(end-myfx:end-12)));


data_ydiffUBForecasts = squeeze(oo_.FilteredVariablesKStepAhead(:,nbefore+4,:));

% plot(data_ydiffU)
% hold on  
% plot([nan(1,1),data_ydiffUBForecasts(1,:)],':k','linewidth',2)
% plot([nan(1,4),data_ydiffUBForecasts(2,:)],'-.k','linewidth',2)
% plot([nan(1,8),data_ydiffUBForecasts(3,:)],'--k','linewidth',2)
% plot([nan(1,12),data_ydiffUBForecasts(4,:)],'ok','linewidth',2)
% hold off

% 1-steap ahead error
RMSE1stepB_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+1:end) - data_ydiffUBForecasts(1,end-myfx-12+1:end-12)').^2));
MAE1stepB_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+1:end) - data_ydiffUBForecasts(1,end-myfx-12+1:end-12)'));

% 4-steap ahead error
RMSE4stepB_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+4:end) - data_ydiffUBForecasts(2,end-myfx-12+4:end-12)').^2));
MAE4stepB_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+4:end) - data_ydiffUBForecasts(2,end-myfx-12+4:end-12)'));

% 8-steap ahead error
RMSE8stepB_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+8:end) - data_ydiffUBForecasts(3,end-myfx-12+8:end-12)').^2));
MAE8stepB_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+8:end) - data_ydiffUBForecasts(3,end-myfx-12+8:end-12)'));

% 12-steap ahead error
RMSE12stepB_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+12:end) - data_ydiffUBForecasts(4,end-myfx-12+12:end-12)').^2));
MAE12stepB_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+12:end) - data_ydiffUBForecasts(4,end-myfx-12+12:end-12)'));

matrix2latexNS(RMSE1stepB_data_ydiffUmyfx/RMSE1stepRW_data_ydiffUmyfx,[myLatexPath '\RMSE1stepB_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE4stepB_data_ydiffUmyfx/RMSE4stepRW_data_ydiffUmyfx,[myLatexPath '\RMSE4stepB_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE8stepB_data_ydiffUmyfx/RMSE8stepRW_data_ydiffUmyfx,[myLatexPath '\RMSE8stepB_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE12stepB_data_ydiffUmyfx/RMSE12stepRW_data_ydiffUmyfx,[myLatexPath '\RMSE12stepB_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');

matrix2latexNS(MAE1stepB_data_ydiffUmyfx/MAE1stepRW_data_ydiffUmyfx,[myLatexPath '\MAE1stepB_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE4stepB_data_ydiffUmyfx/MAE4stepRW_data_ydiffUmyfx,[myLatexPath '\MAE4stepB_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE8stepB_data_ydiffUmyfx/MAE8stepRW_data_ydiffUmyfx,[myLatexPath '\MAE8stepB_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE12stepB_data_ydiffUmyfx/MAE12stepRW_data_ydiffUmyfx,[myLatexPath '\MAE12stepB_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');

% Home SVAR 
data_ydiffUSVARForecasts = squeeze(HomeSVAR_oo_.FilteredVariablesKStepAhead(:,2,:));

% plot(data_ydiffU)
% hold on  
% plot([nan(1,1),data_ydiffUSVARForecasts(1,:)],':k','linewidth',2)
% plot([nan(1,4),data_ydiffUSVARForecasts(2,:)],'-.k','linewidth',2)
% plot([nan(1,8),data_ydiffUSVARForecasts(3,:)],'--k','linewidth',2)
% plot([nan(1,12),data_ydiffUSVARForecasts(4,:)],'ok','linewidth',2)
% hold off

% 1-steap ahead error
RMSE1stepSVAR_data_ydiffU = sqrt(mean((data_ydiffU(1+1:end) - data_ydiffUSVARForecasts(1,1+1:end-12)').^2));
MAE1stepSVAR_data_ydiffU = mean(abs(data_ydiffU(1+1:end) - data_ydiffUSVARForecasts(1,1+1:end-12)'));

% 4-steap ahead error
RMSE4stepSVAR_data_ydiffU = sqrt(mean((data_ydiffU(1+4:end) - data_ydiffUSVARForecasts(2,1+4:end-12)').^2));
MAE4stepSVAR_data_ydiffU = mean(abs(data_ydiffU(1+4:end) - data_ydiffUSVARForecasts(2,1+4:end-12)'));

% 8-steap ahead error
RMSE8stepSVAR_data_ydiffU = sqrt(mean((data_ydiffU(1+8:end) - data_ydiffUSVARForecasts(3,1+8:end-12)').^2));
MAE8stepSVAR_data_ydiffU = mean(abs(data_ydiffU(1+8:end) - data_ydiffUSVARForecasts(3,1+8:end-12)'));

% 12-steap ahead error
RMSE12stepSVAR_data_ydiffU = sqrt(mean((data_ydiffU(1+12:end) - data_ydiffUSVARForecasts(4,1+12:end-12)').^2));
MAE12stepSVAR_data_ydiffU = mean(abs(data_ydiffU(1+12:end) - data_ydiffUSVARForecasts(4,1+12:end-12)'));

matrix2latexNS(RMSE1stepSVAR_data_ydiffU/RMSE1stepRW_data_ydiffU,[myLatexPath '\RMSE1stepSVAR_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE4stepSVAR_data_ydiffU/RMSE4stepRW_data_ydiffU,[myLatexPath '\RMSE4stepSVAR_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE8stepSVAR_data_ydiffU/RMSE8stepRW_data_ydiffU,[myLatexPath '\RMSE8stepSVAR_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE12stepSVAR_data_ydiffU/RMSE12stepRW_data_ydiffU,[myLatexPath '\RMSE12stepSVAR_data_ydiffU'  '.tex'],'format', '%-6.2f');

matrix2latexNS(MAE1stepSVAR_data_ydiffU/MAE1stepRW_data_ydiffU,[myLatexPath '\MAE1stepSVAR_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE4stepSVAR_data_ydiffU/MAE4stepRW_data_ydiffU,[myLatexPath '\MAE4stepSVAR_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE8stepSVAR_data_ydiffU/MAE8stepRW_data_ydiffU,[myLatexPath '\MAE8stepSVAR_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE12stepSVAR_data_ydiffU/MAE12stepRW_data_ydiffU,[myLatexPath '\MAE12stepSVAR_data_ydiffU'  '.tex'],'format', '%-6.2f');


data_ydiffUSVARForecasts = squeeze(HomeSVAR_oo_.FilteredVariablesKStepAhead(:,2,:));

% plot(data_ydiffU)
% hold on  
% plot([nan(1,1),data_ydiffUBForecasts(1,:)],':k','linewidth',2)
% plot([nan(1,4),data_ydiffUBForecasts(2,:)],'-.k','linewidth',2)
% plot([nan(1,8),data_ydiffUBForecasts(3,:)],'--k','linewidth',2)
% plot([nan(1,12),data_ydiffUBForecasts(4,:)],'ok','linewidth',2)
% hold off

% 1-steap ahead error
RMSE1stepSVAR_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+1:end) - data_ydiffUSVARForecasts(1,end-myfx-12+1:end-12)').^2));
MAE1stepSVAR_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+1:end) - data_ydiffUSVARForecasts(1,end-myfx-12+1:end-12)'));

% 4-steap ahead error
RMSE4stepSVAR_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+4:end) - data_ydiffUSVARForecasts(2,end-myfx-12+4:end-12)').^2));
MAE4stepSVAR_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+4:end) - data_ydiffUSVARForecasts(2,end-myfx-12+4:end-12)'));

% 8-steap ahead error
RMSE8stepSVAR_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+8:end) - data_ydiffUSVARForecasts(3,end-myfx-12+8:end-12)').^2));
MAE8stepSVAR_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+8:end) - data_ydiffUSVARForecasts(3,end-myfx-12+8:end-12)'));

% 12-steap ahead error
RMSE12stepSVAR_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+12:end) - data_ydiffUSVARForecasts(4,end-myfx-12+12:end-12)').^2));
MAE12stepSVAR_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+12:end) - data_ydiffUSVARForecasts(4,end-myfx-12+12:end-12)'));

matrix2latexNS(RMSE1stepSVAR_data_ydiffUmyfx/RMSE1stepRW_data_ydiffUmyfx,[myLatexPath '\RMSE1stepSVAR_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE4stepSVAR_data_ydiffUmyfx/RMSE4stepRW_data_ydiffUmyfx,[myLatexPath '\RMSE4stepSVAR_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE8stepSVAR_data_ydiffUmyfx/RMSE8stepRW_data_ydiffUmyfx,[myLatexPath '\RMSE8stepSVAR_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE12stepSVAR_data_ydiffUmyfx/RMSE12stepRW_data_ydiffUmyfx,[myLatexPath '\RMSE12stepSVAR_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');

matrix2latexNS(MAE1stepSVAR_data_ydiffUmyfx/MAE1stepRW_data_ydiffUmyfx,[myLatexPath '\MAE1stepSVAR_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE4stepSVAR_data_ydiffUmyfx/MAE4stepRW_data_ydiffUmyfx,[myLatexPath '\MAE4stepSVAR_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE8stepSVAR_data_ydiffUmyfx/MAE8stepRW_data_ydiffUmyfx,[myLatexPath '\MAE8stepSVAR_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE12stepSVAR_data_ydiffUmyfx/MAE12stepRW_data_ydiffUmyfx,[myLatexPath '\MAE12stepSVAR_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');





%%%%%% finfric %%%%%%%%%%%%%

data_ydiffUFForecasts = squeeze(finfric_oo_.FilteredVariablesKStepAhead(:,fnbefore+1+4,:));

% 1-steap ahead error
RMSE1stepF_data_ydiffU = sqrt(mean((data_ydiffU(1+1:end) - data_ydiffUFForecasts(1,1+1:end-12)').^2));
MAE1stepF_data_ydiffU = mean(abs(data_ydiffU(1+1:end) - data_ydiffUFForecasts(1,1+1:end-12)'));

% 4-steap ahead error
RMSE4stepF_data_ydiffU = sqrt(mean((data_ydiffU(1+4:end) - data_ydiffUFForecasts(2,1+4:end-12)').^2));
MAE4stepF_data_ydiffU = mean(abs(data_ydiffU(1+4:end) - data_ydiffUFForecasts(2,1+4:end-12)'));

% 8-steap ahead error
RMSE8stepF_data_ydiffU = sqrt(mean((data_ydiffU(1+8:end) - data_ydiffUFForecasts(3,1+8:end-12)').^2));
MAE8stepF_data_ydiffU = mean(abs(data_ydiffU(1+8:end) - data_ydiffUFForecasts(3,1+8:end-12)'));

% 12-steap ahead error
RMSE12stepF_data_ydiffU = sqrt(mean((data_ydiffU(1+12:end) - data_ydiffUFForecasts(4,1+12:end-12)').^2));
MAE12stepF_data_ydiffU = mean(abs(data_ydiffU(1+12:end) - data_ydiffUFForecasts(4,1+12:end-12)'));

matrix2latexNS(RMSE1stepF_data_ydiffU/RMSE1stepRW_data_ydiffU,[myLatexPath '\RMSE1stepF_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE4stepF_data_ydiffU/RMSE4stepRW_data_ydiffU,[myLatexPath '\RMSE4stepF_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE8stepF_data_ydiffU/RMSE8stepRW_data_ydiffU,[myLatexPath '\RMSE8stepF_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE12stepF_data_ydiffU/RMSE12stepRW_data_ydiffU,[myLatexPath '\RMSE12stepF_data_ydiffU'  '.tex'],'format', '%-6.2f');

matrix2latexNS(MAE1stepF_data_ydiffU/MAE1stepRW_data_ydiffU,[myLatexPath '\MAE1stepF_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE4stepF_data_ydiffU/MAE4stepRW_data_ydiffU,[myLatexPath '\MAE4stepF_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE8stepF_data_ydiffU/MAE8stepRW_data_ydiffU,[myLatexPath '\MAE8stepF_data_ydiffU'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE12stepF_data_ydiffU/MAE12stepRW_data_ydiffU,[myLatexPath '\MAE12stepF_data_ydiffU'  '.tex'],'format', '%-6.2f');

%%% last 10 years %%%%

% 1-steap ahead error
RMSE1stepF_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+1:end) - data_ydiffUFForecasts(1,end-myfx-12+1:end-12)').^2));
MAE1stepF_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+1:end) - data_ydiffUFForecasts(1,end-myfx-12+1:end-12)'));

% 4-steap ahead error
RMSE4stepF_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+4:end) - data_ydiffUFForecasts(2,end-myfx-12+4:end-12)').^2));
MAE4stepF_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+4:end) - data_ydiffUFForecasts(2,end-myfx-12+4:end-12)'));

% 8-steap ahead error
RMSE8stepF_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+8:end) - data_ydiffUFForecasts(1,end-myfx-12+8:end-12)').^2));
MAE8stepF_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+8:end) - data_ydiffUFForecasts(1,end-myfx-12+8:end-12)'));

% 12-steap ahead error
RMSE12stepF_data_ydiffUmyfx = sqrt(mean((data_ydiffU(end-myfx+12:end) - data_ydiffUFForecasts(1,end-myfx-12+12:end-12)').^2));
MAE12stepF_data_ydiffUmyfx = mean(abs(data_ydiffU(end-myfx+12:end) - data_ydiffUFForecasts(1,end-myfx-12+12:end-12)'));

matrix2latexNS(RMSE1stepF_data_ydiffUmyfx/RMSE1stepRW_data_ydiffUmyfx,[myLatexPath '\RMSE1stepF_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE4stepF_data_ydiffUmyfx/RMSE4stepRW_data_ydiffUmyfx,[myLatexPath '\RMSE4stepF_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE8stepF_data_ydiffUmyfx/RMSE8stepRW_data_ydiffUmyfx,[myLatexPath '\RMSE8stepF_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(RMSE12stepF_data_ydiffUmyfx/RMSE12stepRW_data_ydiffUmyfx,[myLatexPath '\RMSE12stepF_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');

matrix2latexNS(MAE1stepF_data_ydiffUmyfx/MAE1stepRW_data_ydiffUmyfx,[myLatexPath '\MAE1stepF_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE4stepF_data_ydiffUmyfx/MAE4stepRW_data_ydiffUmyfx,[myLatexPath '\MAE4stepF_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE8stepF_data_ydiffUmyfx/MAE8stepRW_data_ydiffUmyfx,[myLatexPath '\MAE8stepF_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');
matrix2latexNS(MAE12stepF_data_ydiffUmyfx/MAE12stepRW_data_ydiffUmyfx,[myLatexPath '\MAE12stepF_data_ydiffUmyfx'  '.tex'],'format', '%-6.2f');



%%%% unobserved variables %%%%%%%%%
% net external debt to GP ratio: aU
% bankruptcy rate: exp(lbankruptcyrateU) [proportional to the spread]
% credit amount
%finfric_oo_.SmoothedVariables.Mean.aU

% net external debt

cd(mainpath);
[numq,strq]=xlsread([mainpath,'\data_lv2.xlsx'],'quarterly');
[numm,strm]=xlsread([mainpath,'\data_lv2.xlsx'],'monthly');
cd('CTWopenEconDataAndCode')
addpath('utilities_and_data')
cd('CTW CodeKit across models')
cd('baseline')

original_etaaU_Eurostat = numq(:,33);
original_etaaU_CSP_Maastricht = numq(:,34);



    %aH=subaxis(6,3,myj, 'SpacingHoriz', 0.04,'SpacingVert',.08); % fro
    %plot(smoothedvar,'black','linewidth',2)
    plot(-original_etaaU_Eurostat(2:end),':black','linewidth',2)
    hold on
    plot(-original_etaaU_CSP_Maastricht(2:end),'-.black','linewidth',2)
    plot((smoothedvars.etaaU)*100,'--blue', 'linewidth',2)
    plot((ff_smoothedvars.etaaU)*100,'red', 'linewidth',2)
    %legend([myvarlist{myj},'original'], [myvarlist{myj},'filtered'])  
    title('Net foreign assets to GDP ratio','FontSize',14)
    hold off
    %set(aH,'PlotBoxAspectRatio',[1 1 1])
    set(gca,'XTick',[4 20 36 52 68])
    set(gca,'XTickLabel',['1996';'2000';'2004';'2008';'2012'])
    axis([-Inf length(originalvar) -Inf +Inf])
    [legh,objh,outh,outm]  = legend(gca,'observed, Eurostat','observed, Maastricht','smoothed, baseline','smoothed, finfric','location','SouthWest'); %'show' 'zero line',
    set(legh,'Fontsize',13);
    set(objh,'linewidth',3);
    
thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','unobservable_aU')
print(1,'-dpdf','unobservable_aU')
cd(thispath)

close all

% bankruptcy rate

    %aH=subaxis(6,3,myj, 'SpacingHoriz', 0.04,'SpacingVert',.08); % fro
    %plot(smoothedvar,'black','linewidth',2)
   % plot(-original_aU_Eurostat(2:end),':black','linewidth',2)
    hold on
   % plot(-original_aU_CSP_Maastricht(2:end),'-.black','linewidth',2)
   % plot(smoothedvars.aU*100,'--blue', 'linewidth',2)
    plot(exp(ff_smoothedvars.lbankruptcyrateU)*100,'red', 'linewidth',2)
    %legend([myvarlist{myj},'original'], [myvarlist{myj},'filtered'])  
    title('Quarterly bankruptcy rate','FontSize',14)
    hold off
    %set(aH,'PlotBoxAspectRatio',[1 1 1])
    set(gca,'XTick',[4 20 36 52 68])
    set(gca,'XTickLabel',['1996';'2000';'2004';'2008';'2012'])
    axis([-Inf length(originalvar) -Inf +Inf])
    [legh,objh,outh,outm]  = legend(gca,'smoothed, finfric','location','North'); %'show' 'zero line',
    set(legh,'Fontsize',13);
    set(objh,'linewidth',3);
    
thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','unobservable_bankruptcy')
print(1,'-dpdf','unobservable_bankruptcy')
cd(thispath)

close all

% loan growth rate
run('ctwData17.m')
% try using data_loandiffU

addpath(genpath('C:\Users\gintersb\Documents\mydata\matlab\external codes\lesage'))


% total of households and non-MFI firms
loan_total=numm(:,12)+numm(:,13);
qloan_total=mth2qtr(loan_total(1:end-1));
gqloan=100*log(qloan_total(2:end)./qloan_total(1:end-1));


ff_credit=ff_smoothedvars.lbU;

    %aH=subaxis(6,3,myj, 'SpacingHoriz', 0.04,'SpacingVert',.08); % fro
    %plot(smoothedvar,'black','linewidth',2)
    %plot(gqloan(2:end),':black','linewidth',2)
    plot(data_loandiffU(2:end),':black','linewidth',2)
    hold on
   % plot(-original_aU_CSP_Maastricht(2:end),'-.black','linewidth',2)
   % plot(smoothedvars.aU*100,'--blue', 'linewidth',2)
    plot((ff_credit(2:end)-ff_credit(1:end-1))*100,'red', 'linewidth',2)
    %legend([myvarlist{myj},'original'], [myvarlist{myj},'filtered'])  
    title('Loan growth rate','FontSize',14)
    hold off
    %set(aH,'PlotBoxAspectRatio',[1 1 1])
    set(gca,'XTick',[3 19 35 51 67])
    set(gca,'XTickLabel',['1996';'2000';'2004';'2008';'2012'])
    axis([-Inf length(ff_credit)-1 -Inf +Inf])
    [legh,objh,outh,outm]  = legend(gca,'observed','smoothed, finfric','location','NorthWest'); %'show' 'zero line',
    set(legh,'Fontsize',13);
    set(objh,'linewidth',3);
    
thispath = cd; 
cd(myLatexPath)
print(1,'-depsc','unobservable_loans')
print(1,'-dpdf','unobservable_loans')
cd(thispath)

close all

%%%%%%%%%%% priors and posteriors%%%%%%%%%%%%
%%%%%% take only finfric (and SVAR) %%%%%%%%%%%%%%%%%%%%%

cd(myWhichSVARmodel)
cd('Output')
WhichPP={'1','2','3'};
for myi=1:length(WhichPP)
    copyfile([myWhichSVARmodel '_PriorsAndPosteriors' WhichPP{myi} '.eps'],[myLatexPath '\SVAR' '_PriorsAndPosteriors' WhichPP{myi} '.eps']);
end

cd(mainpath)
cd('CTWopenEconDataAndCode')
addpath('utilities_and_data')
cd('CTW CodeKit across models')
cd('finfric')

cd(myWhichFFModel)
cd('Output')
WhichPP={'1','2','3','4','5'};
for myi=1:length(WhichPP)
    copyfile([myWhichFFModel '_PriorsAndPosteriors' WhichPP{myi} '.eps'],[myLatexPath '\finfric' '_PriorsAndPosteriors' WhichPP{myi} '.eps']);
end

cd(mainpath)
cd('CTWopenEconDataAndCode')
addpath('utilities_and_data')
cd('CTW CodeKit across models')
cd('baseline')



